/****************************/
/* 配列に対するプログラム例 */
/*      coded by Y.Suganuma */
/****************************/
import java.io.*;
import java.util.*;

public class Test {
	public static void main(String args[]) throws IOException
	{
			//
			// 1 次元配列
			//
		BufferedReader inp = new BufferedReader(new InputStreamReader(System.in));
		int m3;   // 人数
		System.out.printf("人数は？ ");
		m3       = Integer.parseInt(inp.readLine());
		int a3[] = new int [m3];
//		int a3[] = {1, 2, 3}; のような初期設定も可
//		int b3[];
//		b3 = a3;   a3 と b3 は同じ配列（a3 を変更すれば b3 も変化）
		double mean3 = 0.0;
		for (int i1 = 0; i1 < m3; i1++) {
			System.out.printf("   %d 番目の人の点数は？ ", i1+1);
			a3[i1] = Integer.parseInt(inp.readLine());
			mean3 += a3[i1];
		}
		mean3 /= m3;
		int n3 = 0;
		for (int i1 = 0; i1 < m3; i1++) {
			if (a3[i1] >= mean3)
				n3++;
		}
		System.out.printf("   平均点（ %f ）以上は %d 人\n", mean3, n3);
			//
			// 2 次元配列
			//
		int m4;   // クラス数
		System.out.printf("クラス数は？ ");
		m4               = Integer.parseInt(inp.readLine());
		double mean4     = 0.0;   // 全体の平均
		double c_mean4[] = new double [m4];   // クラス毎の平均
		int s_num4       = 0;   // 全体の人数
		int a4[][]       = new int [m4][];
//		int a4[][]       = new int [2][3]; 列の数が既知の場合
//		int a4[][] = {{1, 2, 3}, {4, 5, 6}}; のような初期設定も可
		for (int i1 = 0; i1 < m4; i1++) {
			int n_m4;   // クラス内の人数
			System.out.printf("   クラス %d の人数は？ ", i1+1);
			n_m4        = Integer.parseInt(inp.readLine());
			a4[i1]      = new int [n_m4];
			c_mean4[i1] = 0.0;
			for (int i2 = 0; i2 < n_m4; i2++) {
				System.out.printf("      クラス %d の %d 番目の人の点数は？ ", i1+1, i2+1);
				a4[i1][i2]   = Integer.parseInt(inp.readLine());
				c_mean4[i1] += a4[i1][i2];
			}
			mean4       += c_mean4[i1];
			s_num4      += n_m4;
			c_mean4[i1] /= n_m4;   // クラス毎の平均
		}
		mean4 /= s_num4;   // 全体の平均
		int n4 = 0;
		for (int i1 = 0; i1 < m4; i1++) {
			if (c_mean4[i1] >= mean4)
				n4++;
		}
		System.out.printf("   平均点（ %f ）以上のクラスは %d \n", mean4, n4);
//		int b4[][];
//		b4 = a4;   a4 と b4 は同じ配列（a4 を変更すれば b4 も変化）
//		int c4[];
//		c4 = a4[1];   c4 は，a4 の 2 行目と同じ 1 次元配列
//	 	             （a4 の 2 行目を変更すれば c4 も変化）
			//
			// ArrayList クラス（Collection オブジェクトの各要素を初期値とすることが可）
			//
		System.out.printf("ファイル入出力（ArrayList クラス）\n");
		BufferedReader in = new BufferedReader(new FileReader("data.txt"));
		PrintStream out   = new PrintStream(new FileOutputStream("out.txt"));
		double mean5 = 0.0;
		int m5       = 0;
		String line;
		ArrayList <Integer> a5 = new ArrayList <Integer> ();
		while ((line = in.readLine()) != null) {
			int x = Integer.parseInt(line);
			a5.add(new Integer(x));
			mean5 += x;
			m5++;
			out.printf("%d %d\n", m5, x);
		}
		in.close();
		out.close();
		mean5 /= m5;
		int n5 = 0;
		for (int i1 = 0; i1 < m5; i1++) {
			if (a5.get(i1) >= mean5)
				n5++;
		}
		System.out.printf("   平均点（ %f ）以上は %d 人\n", mean5, n5);
//		ArrayList <Integer> b5;
//		b5 = a5;   a5 と b5 は同じ ArrayList（a5 を変更すれば b5 も変化）
//		ArrayList <Integer> b5 = new ArrayList <Integer> ();
//		for(int i1 = 0; i1 < 3; i1++)
//			b5.add(new Integer(i1+1));
//		ArrayList <Integer> a5 = new ArrayList <Integer> (b5);
			//
			// TreeMap クラス（Collection オブジェクトの各要素を初期値とすることが可）
			//
		System.out.printf("TreeMap クラス\n");
		TreeMap <String, Integer> a6 = new TreeMap <String, Integer> ();
		a6.put("suzuki", new Integer(40));
		a6.put("sato", new Integer(60));
		a6.put("yamada", new Integer(70));
		System.out.printf("   suzuki さんの得点：%d\n", a6.get("suzuki"));
//		TreeMap <String, Integer> b6;
//		b6 = a6;   a6 と b6 は同じ TreeMap（a6 を変更すれば b6 も変化）
	}
}
