############################
# 配列に対するプログラム例 #
#      coded by Y.Suganuma #
############################
		#
		# 1 次元配列
		#
printf("人数は？ ");
m3 = Integer(gets());   # 人数
a3 = Array.new();
#a3 = Array.new(3);   # サイズを指定しても良い
#a3 = Array[1, "abc", 3.5];   # a3 = [1, "abc", 3.5]; でも良い．
#b3 = a3;   #a3 と b3 は同じ配列（a3 を変更すれば b3 も変化）
mean3 = 0.0;
for i1 in (0...m3)
	printf("   %d 番目の人の点数は？ ", i1+1);
	a3[i1] = Integer(gets());
	mean3 += a3[i1];
end
mean3 /= Float(m3);
n3     = 0;
for i1 in (0...m3)
	if (a3[i1] >= mean3)
		n3 += 1;
	end
end
printf("   平均点（ %f ）以上は %d 人\n", mean3, n3);
		#
		# 2 次元配列（new，初期設定は不可）
		#
printf("クラス数は？ ");
m4      = Integer(gets());   # クラス数
mean4   = 0.0;   # 全体の平均
c_mean4 = Array.new();   # クラス毎の平均
s_num4  = 0;   # 全体の人数
a4      = Array.new();
#a4 = Array[[1, 2, 3], [10, 20, 30]];   # 全体の初期設定も可
for i1 in (0...m4)
	printf("   クラス %d の人数は？ ", i1+1);
	n_m4        = Integer(gets());   # クラス内の人数
	a4[i1]      = Array.new();
#	a4[i1] = Array[1, 2, 3];   # 行毎の初期設定も可
	c_mean4[i1] = 0.0;
	for i2 in(0...n_m4)
		printf("      クラス %d の %d 番目の人の点数は？ ", i1+1, i2+1);
		a4[i1][i2]   = Integer(gets());
		c_mean4[i1] += a4[i1][i2];
	end
	mean4       += c_mean4[i1];
	s_num4      += n_m4;
	c_mean4[i1] /= Float(n_m4);   # クラス毎の平均
end
mean4 /= Float(s_num4);   # 全体の平均
n4     = 0;
for i1 in (0...m4)
	if (c_mean4[i1] >= mean4)
		n4 += 1;
	end
end
printf("   平均点（ %f ）以上のクラスは %d \n", mean4, n4);
#b4 = a4;   # a4 と b4 は同じ配列（a4 を変更すれば b4 も変化）
#c4 = a4[1];   # c4 は，a4 の 2 行目と同じ 1 次元配列
#              （a4 の 2 行目を変更すれば c4 も変化）
		#
		# ファイル入出力
		#
printf("ファイル入出力\n");
inp   = open("data.txt", "r");
out   = open("out.txt", "w");
mean5 = 0.0;
m5    = 0;
a5    = Array.new();
while x = inp.gets()
	a5[m5] = Integer(x);
	mean5 += a5[m5];
	m5 += 1;
	out.printf("%d %d\n", m5, a5[m5-1]);
end
inp.close();
out.close();
mean5 /= Float(m5);
n5     = 0;
for i1 in (0...m5)
	if (a5[i1] >= mean5)
		n5 += 1;
	end
end
printf("   平均点（ %f ）以上は %d 人\n", mean5, n5);
		#
		# 行列の計算（演算子のオーバーロード）
		#
class Matrix

	def initialize(_n, _m)
		@_n   = _n;
		@_m   = _m;
		@_mat = Array.new(@_n);
		for i1 in (0...@_n)
			@_mat[i1] = Array.new(@_m);
		end
	end

	def input()
		printf("*** %d 行 %d 列の行列***\n", @_n, @_m);
		for i1 in (0...@_n)
			printf("%d 行目のデータ\n", i1+1);
			for i2 in (0...@_m)
				printf("   %d 列目の値は？ ", i2+1);
				@_mat[i1][i2] = Float(gets());
			end
		end
	end

	def output()
		for i1 in (0...@_n)
			for i2 in (0...@_m)
				printf(" %f", @_mat[i1][i2]);
			end
			printf("\n");
		end
	end

	def col()
		return @_m;
	end

	def mat()
		return @_mat;
	end

	def set(i, j, v)
		@_mat[i][j]  = v;
	end

	def +(obj)
		c = Matrix.new(@_n, @_m);
		for i1 in (0...@_n)
			for i2 in (0...@_m)
				v = @_mat[i1][i2] + (obj.mat)[i1][i2];
				c.set(i1, i2, v);
			end
		end
		return c;
	end

	def -(obj)
		c = Matrix.new(@_n, @_m);
		for i1 in (0...@_n)
			for i2 in (0...@_m)
				v = @_mat[i1][i2] - (obj.mat)[i1][i2];
				c.set(i1, i2, v);
			end
		end
		return c;
	end

	def *(obj)
		m = obj.col();
		c = Matrix.new(@_n, m);
		for i1 in (0...@_n)
			for i2 in (0...m)
				v = 0.0;
				for i3 in (0...@_m)
					v += @_mat[i1][i3] * (obj.mat)[i3][i2];
				end
				c.set(i1, i2, v);
			end
		end
		return c;
	end
end

printf("計算方法（ 0 : +, 1 : -, 2 : * ） ");
sw = Integer(gets());   # 計算方法
case sw
	when 0       # +
		printf("--- A+B ---\n");
		printf("n 行 m 列の n と m？ ");
		str = gets();
		x   = str.split(" ");
		n   = Integer(x[0]);
		m   = Integer(x[1]);
		a   = Matrix.new(n, m)
		b   = Matrix.new(n, m)
		printf("Matrix A  \n");
		a.input();
		printf("Matrix B  \n");
		b.input();
		printf("Matrix (A+B)\n");
		c = a + b;
		c.output();
	when 1       # -
		printf("--- A-B ---\n");
		printf("n 行 m 列の n と m？ ");
		str = gets();
		x   = str.split(" ");
		n   = Integer(x[0]);
		m   = Integer(x[1]);
		a   = Matrix.new(n, m)
		b   = Matrix.new(n, m)
		printf("Matrix A  \n");
		a.input();
		printf("Matrix B  \n");
		b.input();
		printf("Matrix (A-B)\n");
		c = a - b;
		c.output();
	when 2       # -
		printf("--- A*B ---\n");
		printf("n 行 m 列の n と m（ A ）？ ");
		str = gets();
		x   = str.split(" ");
		n   = Integer(x[0]);
		m   = Integer(x[1]);
		a   = Matrix.new(n, m)
		printf("行列 B の列数は？ ");
		l = Integer(gets());
		b = Matrix.new(m, l)
		printf("Matrix A  \n");
		a.input();
		printf("Matrix B  \n");
		b.input();
		printf("Matrix (A*B)\n");
		c = a * b;
		c.output();
end
		#
		# Matrix クラスの利用
		#
printf("***Matrix クラスの利用***\n");
require 'matrix'
a = Matrix[[1.0, 1.0], [1.0, 2.0]]
b = Matrix[[2.0, -1.0], [-1.0, 1.0]]
print a, "\n"
	# => Matrix[[1.0, 1.0], [1.0, 2.0]]
print b, "\n"
	# => Matrix[[2.0, -1.0], [-1.0, 1.0]]
print "a+b  ", a+b, "\n"
	# => a+b  Matrix[[3.0, 0.0], [0.0, 3.0]]
print "a-b  ", a-b, "\n"
	# => a-b  Matrix[[-1.0, 2.0], [2.0, 1.0]]
print "a*b  ", a*b, "\n"
	# => a*b  Matrix[[1.0, 0.0], [0.0, 1.0]]
print "a/a  ", a/a, "\n"
	# => a/a  Matrix[[1.0, 0.0], [0.0, 1.0]]
print "a*2.0  ", a*2.0, "\n"
	# => a*2.0  Matrix[[2.0, 2.0], [2.0, 4.0]]
print "a/2.0  ", a/2.0, "\n"
	# => a/2.0  Matrix[[0.5, 0.5], [0.5, 1.0]]
