/****************************/
/* 関数に対するプログラム例 */
/*      coded by Y.Suganuma */
/****************************/
import java.io.*;
import java.util.*;

public class Test {
	/*******************/
	/* main プログラム */
	/*******************/
	public static void main(String args[]) throws IOException
	{
		Test1 ts = new Test1();
	}
}

class Test1 {
	Test1()
	{
			//
			// 基本型，文字列
			//
		System.out.printf("基本型，文字列\n");
		int a1 = 10, b1 = 20, c1 = 0;
		String s1 = "abc", s2 = new String("abc");
		System.out.printf("   前 %d %d %d %s %s\n", a1, b1, c1, s1, s2);
		c1 = func1(a1, b1, s1, s2);
		System.out.printf("   後 %d %d %d %s %s\n", a1, b1, c1, s1, s2);
			//
			// 1 次元配列
			//
		System.out.printf("1 次元配列\n");
		int a2[] = {1, 2, 3, 0};
		ArrayList <Integer> b2 = new ArrayList <Integer> ();
		for (int i1 = 0; i1 < 3; i1++)
			b2.add(new Integer(10 * (i1 + 1)));
		b2.add(new Integer(0));
		System.out.printf("   前 a2 %d %d %d %d\n", a2[0], a2[1], a2[2], a2[3]);
		System.out.printf("      b2 %d %d %d %d\n", b2.get(0), b2.get(1), b2.get(2), b2.get(3));
		func2(3, a2, b2);
		System.out.printf("   後 a2 %d %d %d %d\n", a2[0], a2[1], a2[2], a2[3]);
		System.out.printf("      b2 %d %d %d %d\n", b2.get(0), b2.get(1), b2.get(2), b2.get(3));
			//
			// 2 次元配列
			//
		System.out.printf("2 次元配列\n");
		int a3[][] = {{1, 2, 3, 0}, {4, 5, 6, 0}};
		System.out.printf("   前 a3 %d %d %d %d\n", a3[0][0], a3[0][1], a3[0][2], a3[0][3]);
		System.out.printf("         %d %d %d %d\n", a3[1][0], a3[1][1], a3[1][2], a3[1][3]);
		func3(2, 3, a3);
		System.out.printf("   後 a3 %d %d %d %d\n", a3[0][0], a3[0][1], a3[0][2], a3[0][3]);
		System.out.printf("         %d %d %d %d\n", a3[1][0], a3[1][1], a3[1][2], a3[1][3]);
			//
			// クラスのインスタンス（オブジェクト）
			//
		System.out.printf("オブジェクト\n");
		Example a4 = new Example(3);
		System.out.printf("   前 n %d\n", a4.n);
		System.out.printf("      x %d %d %d\n", a4.x[0], a4.x[1], a4.x[2]);
		func4(a4);
		System.out.printf("   後 n %d\n", a4.n);
		System.out.printf("      x %d %d %d\n", a4.x[0], a4.x[1], a4.x[2]);
			//
			// 関数名（sort）
			//
		System.out.printf("関数名（sort）\n");
		int a7[] = {3, 2, 5, 4, 1};
		int a8[] = {3, 2, 5, 4, 1};
		System.out.printf("   前 %d %d %d %d %d\n", a7[0], a7[1], a7[2], a7[3], a7[4]);
		System.out.printf("   前 %d %d %d %d %d\n", a8[0], a8[1], a8[2], a8[3], a8[4]);
		Sort st = new Sort(0);   // 昇順
		func5(5, a7, st);
		st = new Sort(1);   // 降順
		func5(5, a8, st);
		System.out.printf("   後 %d %d %d %d %d\n", a7[0], a7[1], a7[2], a7[3], a7[4]);
		System.out.printf("   後 %d %d %d %d %d\n", a8[0], a8[1], a8[2], a8[3], a8[4]);
			//
			// 関数名（Newton 法）
			//
		System.out.printf("関数名（Newton 法）\n");
		double eps1 = 1.0e-7;
		double eps2 = 1.0e-10;
		double x0   = 0.0;
		int max     = 20;
		int ind[]   = new int [1];
		Newton nt   = new Newton();
		double x = func6(nt, x0, eps1, eps2, max, ind);
		System.out.printf("   回数=%d  x=%f  関数値=%f  微係数=%f\n", ind[0], x, nt.fn(0, x), nt.fn(1, x));
	}

	/**********************************/
	/* 2 つの整数の和                 */
	/*      u, v : 和を計算するデータ */
	/*      t1, t2 : 文字列           */
	/*      return : u + v            */
	/**********************************/
	int func1(int u, int v, String t1, String t2)
	{
		t1    = t1.replace('a', 'x');
		t2    = t2.replace('a', 'x');
		u     = 100;
		int a = u + v;
		return a;
	}

	/************************/
	/* 1 次元配列の要素の和 */
	/*      n : 要素数      */
	/*      u : 配列        */
	/************************/
	void func2(int n, int u[], ArrayList <Integer> w)
	{
		int s = 0;
		for (int i1 = 0; i1 < n; i1++) {
			u[n] += u[i1];
			s    += w.get(i1);
		}
		w.set(n, s);
	}

	/****************************/
	/* 2 次元配列の要素の和     */
	/*      n : 行数            */
	/*      m : 列数            */
	/*      u : 配列            */
	/*      u[i1][m] : 各行の和 */
	/****************************/
	void func3(int n, int m, int u[][])
	{
		for (int i1 = 0; i1 < n; i1++) {
			for (int i2 = 0; i2 < m; i2++)
				u[i1][m] += u[i1][i2];
		}
	}

	/**************************/
	/* オブジェクトの値変更   */
	/*      x1 : オブジェクト */
	/**************************/
	void func4(Example x1)
	{
		x1.n    = 4;
		x1.x[0] = 4;
	}

	/*****************************************************************/
	/* バブルソート                                                  */
	/*      n : データの数                                           */
	/*      data : データ                                            */
	/*      compare : 比較を行う関数                                 */
	/* バブルソートの手順                                            */
	/*　　　　　1)配列data[i]にn個のデータが入っているものとする．   */
	/*　　　　　　　　i=0,1,･･･,n-1                                  */
	/*　　　　　2)i番目のデータとi+1番目のデータを比較し，もし，     */
	/*　　　　　　　　data[i+1] < data[i]　（昇順の場合）            */
	/*　　　　　　であればそれらのデータを交換する．　i=0,1,･･･,n-2  */
	/*　　　　　　　　→この結果，data[n-1]に最も大きなデータが入る  */
	/*              ことになる                                       */
	/*　　　　　3)次に，n-1個のデータに対し上の処理を繰り返す．      */
	/*　　　　　4)同様に，n-2，n-3，・・・個のデータに対して同じ処理 */
	/*        を繰り返す                                             */
	/*****************************************************************/
	void func5(int n, int data[], Sort st)
	{
		int i1, sw = 0;
	
		if (n > 1) {
			for (i1 = 0; i1 < n-1; i1++) {
				if (st.compare(data[i1], data[i1+1])) {
					sw         = 1;
					int x      = data[i1];
					data[i1]   = data[i1+1];
					data[i1+1] = x;
				}
			}
		}

		if (sw > 0)
			func5(n-1, data, st);
	}

	/*****************************************************/
	/* Newton法による非線形方程式(f(x)=0)の解            */
	/*      nt : f(x)及びf(x)の微分を計算する関数        */
	/*      x0 : 初期値                                  */
	/*      eps1 : 終了条件１（｜x(k+1)-x(k)｜＜eps1）   */
	/*      eps2 : 終了条件２（｜f(x(k))｜＜eps2）       */
	/*      max : 最大試行回数                           */
	/*      ind : 実際の試行回数                         */
	/*            （負の時は解を得ることができなかった） */
	/*      return : 解                                  */
	/*****************************************************/
	double func6(Newton nt, double x0, double eps1, double eps2, int max, int ind[])
	{
		double x = x0, x1 = x0;
		int sw = 0;
		ind[0] = 0;
	
		while (sw == 0 && ind[0] >= 0) {
			sw      = 1;
			ind[0] += 1;
			double g = nt.fn(0, x1);
			if (Math.abs(g) > eps2) {
				if (ind[0] <= max) {
					double dg = nt.fn(1, x1);
					if (Math.abs(dg) > eps2) {
						x = x1 - g / dg;
						if (Math.abs(x-x1) > eps1 && Math.abs(x-x1) > eps1*Math.abs(x)) {
							x1 = x;
							sw = 0;
						}
					}
					else
						ind[0] = -1;
				}
				else
					ind[0] = -1;
			}
		}

		return x;
	}
}

/******************/
/* クラス Example */
/******************/
class Example {
	int n;
	int x[];
	Example(int n1)
	{
		n = n1;
		x = new int [n];
		for (int i1 = 0; i1 < n; i1++)
			x[i1] = i1;
	}
}

/***************/
/* クラス Sort */
/***************/
class Sort {

	int sw;   // =0 : 昇順，=1 : 降順

	Sort(int swi)
	{
		sw = swi;
	}

	boolean compare(int a, int b)
	{
		return (sw ==0) ? ascend(a, b) : descend(a, b);
	}

	/************************/
	/* データの比較（昇順） */
	/* a > bの場合に真　　  */
	/************************/
	boolean ascend(int a, int b)
	{
		boolean tf = false;
		if (a > b)
			tf = true;
		return tf;
	}

	/************************/
	/* データの比較（降順） */
	/* a < bの場合に真      */
	/************************/
	boolean descend(int a, int b)
	{
		boolean tf = false;
		if (a < b)
			tf = true;
		return tf;
	}
}

/*****************/
/* クラス Newton */
/*****************/
class Newton {
	double fn(int sw, double x)
	{
		double y;
		if (sw == 0)   // 関数値の計算
			y = Math.exp(x) - 3.0 * x;
		else   // 関数の微分の計算
			y = Math.exp(x) - 3.0;
		return y;
	}
}
