<?php
	/****************************/
	/* 関数に対するプログラム例 */
	/*      coded by Y.Suganuma */
	/****************************/
			//
			// 基本型，文字列
			//
	printf("基本型，文字列\n");
	$a1 = 10;
	$b1 = 20;
	$c1 = 0;
	$d1 = 0;
	$s1 = "abc";
	printf("   前 %d %d %d %d %s\n", $a1, $b1, $c1, $d1, $s1);
	$c1 = func1($a1, $b1, $d1, $s1);
	printf("   後 %d %d %d %d %s\n", $a1, $b1, $c1, $d1, $s1);
			//
			// 1 次元配列
			//
	printf("1 次元配列\n");
	$a2 = array(1, 2, 3, 0);
	$b2 = $a2;
	printf("   前 a2 %d %d %d %d\n", $a2[0], $a2[1], $a2[2], $a2[3]);
	printf("      b2 %d %d %d %d\n", $b2[0], $b2[1], $b2[2], $b2[3]);
	$x = func2(3, $a2, $b2);
	printf("   後 a2 %d %d %d %d %d\n", $a2[0], $a2[1], $a2[2], $a2[3], $x);
	printf("      b2 %d %d %d %d\n", $b2[0], $b2[1], $b2[2], $b2[3]);
			//
			// 2 次元配列
			//
	printf("2 次元配列\n");
	$a3 = array(2);
	$a3[0] = array(1, 2, 3, 0);
	$a3[1] = array(4, 5, 6, 0);
	printf("   前 %d %d %d %d\n", $a3[0][0], $a3[0][1], $a3[0][2], $a3[0][3]);
	printf("      %d %d %d %d\n", $a3[1][0], $a3[1][1], $a3[1][2], $a3[1][3]);
	$c3 = func3(2, 3, $a3);
	printf("   後 %d %d %d %d\n", $a3[0][0], $a3[0][1], $a3[0][2], $a3[0][3]);
	printf("      %d %d %d %d\n", $a3[1][0], $a3[1][1], $a3[1][2], $a3[1][3]);
			//
			// クラスのインスタンス（オブジェクト）
			//
	printf("オブジェクト\n");
	$a4 = new Example(1);
	$a5 = new Example(1);
	printf("   前 a4 n %d\n", $a4->n);
	printf("      x %d %d %d\n", $a4->x[0], $a4->x[1], $a4->x[2]);
	printf("   前 a5 n %d\n", $a5->n);
	printf("      x %d %d %d\n", $a5->x[0], $a5->x[1], $a5->x[2]);
	func4($a4, $a5);
	printf("   後 a4 n %d\n", $a4->n);
	printf("      x %d %d %d\n", $a4->x[0], $a4->x[1], $a4->x[2]);
	printf("   後 a5 n %d\n", $a5->n);
	printf("      x %d %d %d\n", $a5->x[0], $a5->x[1], $a5->x[2]);
			//
			// 関数名（sort）
			//
	printf("関数名（sort）\n");
	$a7 = array(3, 2, 5, 4, 1);
	$a8 = array(3, 2, 5, 4, 1);
	printf("   前 %d %d %d %d %d\n", $a7[0], $a7[1], $a7[2], $a7[3], $a7[4]);
	printf("   前 %d %d %d %d %d\n", $a8[0], $a8[1], $a8[2], $a8[3], $a8[4]);
	func5(5, $a7, "ascend");   // 昇順
	func5(5, $a8, "descend");   // 降順
	printf("   後 %d %d %d %d %d\n", $a7[0], $a7[1], $a7[2], $a7[3], $a7[4]);
	printf("   後 %d %d %d %d %d\n", $a8[0], $a8[1], $a8[2], $a8[3], $a8[4]);
			//
			// 関数名（Newton 法）
			//
	printf("関数名（Newton 法）\n");
	$eps1 = 1.0e-7;
	$eps2 = 1.0e-10;
	$x0   = 0.0;
	$max  = 20;
	$ind  = 0;
	$x = func6("snx", "dsnx", $x0, $eps1, $eps2, $max, $ind);
	printf("   回数=%d  x=%f  関数値=%f  微係数=%f\n", $ind, $x, snx($x), dsnx($x));

	/************************************/
	/* 2 つの整数の和                   */
	/*      $u, $v : 和を計算するデータ */
	/*      $w : $u + $v                */
	/*      $t1 : 文字列                */
	/*      return : $u + $v            */
	/************************************/
	function func1($u, $v, &$w, $t1)
	{
		$t1 = str_replace("a", "x", $t1);
		$u  = 100;
		$a  = $u + $v;
		$w  = $a;
		return $a;
	}

	/************************/
	/* 1 次元配列の要素の和 */
	/*      $n : 要素数     */
	/*      $u,$w : 配列    */
	/*      return : 和     */
	/************************/
	function func2($n, $u, &$w)
	{
		for ($i1 = 0; $i1 < $n; $i1++) {
			$u[$n] += $u[$i1];
			$w[$n] += $w[$i1];
		}
		return $u[$n];
	}

	/************************/
	/* 2 次元配列の要素の和 */
	/*      $n : 行数       */
	/*      $m : 列数       */
	/*      $u : 配列       */
	/************************/
	function func3($n, $m, &$u)
	{
		for ($i1 = 0; $i1 < $n; $i1++) {
			for ($i2 = 0; $i2 < $m; $i2++)
				$u[$i1][$m] += $u[$i1][$i2];
		}
	}

	/******************/
	/* クラス Example */
	/******************/
	class Example {
		public $n;
		public $x;
		function Example($n)
		{
			$this->n = $n;
			$this->x = array(1, 2, 3);
		}
	}

	/************************/
	/* オブジェクトの値変更 */
	/*      x1 : コピー     */
	/*      x2 : 参照       */
	/************************/
	function func4($x1, &$x2)
	{
		$x1->n = 2;
		$x2->n = 3;
		$x1->x[0] = 4;
		$x2->x[0] = 5;
	}

	/*****************************/
	/* データの比較（昇順）      */
	/* a > bの場合に０以外（真） */
	/*****************************/
	function ascend($a, $b)
	{
		return $a > $b;
	}
	
	/*****************************/
	/* データの比較（降順）      */
	/* a < bの場合に０以外（真） */
	/*****************************/
	function descend($a, $b)
	{
		return $a < $b;
	}
	
	/*****************************************************************/
	/* バブルソート                                                  */
	/*      n : データの数                                           */
	/*      data : データ                                            */
	/*      compare : 比較を行う関数                                 */
	/* バブルソートの手順                                            */
	/*　　　　　1)配列data[i]にn個のデータが入っているものとする．   */
	/*　　　　　　　　i=0,1,･･･,n-1                                  */
	/*　　　　　2)i番目のデータとi+1番目のデータを比較し，もし，     */
	/*　　　　　　　　data[i+1] < data[i]　（昇順の場合）            */
	/*　　　　　　であればそれらのデータを交換する．　i=0,1,･･･,n-2  */
	/*　　　　　　　　→この結果，data[n-1]に最も大きなデータが入る  */
	/*              ことになる                                       */
	/*　　　　　3)次に，n-1個のデータに対し上の処理を繰り返す．      */
	/*　　　　　4)同様に，n-2，n-3，・・・個のデータに対して同じ処理 */
	/*        を繰り返す                                             */
	/*****************************************************************/
	function func5($n, &$data, $compare)
	{
		$sw = 0;
	
		if ($n > 1) {
			for ($i1 = 0; $i1 < $n-1; $i1++) {
				if ($compare($data[$i1], $data[$i1+1])) {
					$sw          = 1;
					$x           = $data[$i1];
					$data[$i1]   = $data[$i1+1];
					$data[$i1+1] = $x;
				}
			}
		}
	
		if ($sw > 0)
			func5($n-1, $data, $compare);
	}

	/************************/
	/* 関数値（f(x)）の計算 */
	/************************/
	function snx($x)
	{
		$y = exp($x) - 3.0 * $x;
		return $y;
	}
	
	/********************/
	/* 関数の微分の計算 */
	/********************/
	function dsnx($x)
	{
		$y = exp($x) - 3.0;
		return $y;
	}
	
	/*****************************************************/
	/* Newton法による非線形方程式(f(x)=0)の解            */
	/*      fn : f(x)を計算する関数名                    */
	/*      dfn : f(x)の微分を計算する関数名             */
	/*      x0 : 初期値                                  */
	/*      eps1 : 終了条件１（｜x(k+1)-x(k)｜＜eps1）   */
	/*      eps2 : 終了条件２（｜f(x(k))｜＜eps2）       */
	/*      max : 最大試行回数                           */
	/*      ind : 実際の試行回数                         */
	/*            （負の時は解を得ることができなかった） */
	/*      return : 解                                  */
	/*****************************************************/
	function func6($f, $df, $x0, $eps1, $eps2, $max, &$ind)
	{
		$x   = $x0;
		$x1  = $x0;
		$sw  = 0;
		$ind = 0;
	
		while ($sw == 0 && $ind >= 0) {
			$sw   = 1;
			$ind += 1;
			$g    = $f($x1);
			if (abs($g) > $eps2) {
				if ($ind <= $max) {
					$dg = $df($x1);
					if (abs($dg) > $eps2) {
						$x = $x1 - $g / $dg;
						if (abs($x-$x1) > $eps1 && abs($x-$x1) > $eps1*abs($x)) {
							$x1 = $x;
							$sw = 0;
						}
					}
					else
						$ind = -1;
				}
				else
					$ind = -1;
			}
		}
	
		return $x;
	}
?>
