/******************************/
/* クラスに対するプログラム例 */
/*      coded by Y.Suganuma   */
/******************************/
import java.io.*;
import java.util.*;

public class Test {
	public static void main(String args[]) throws IOException
	{
			// クラス Win
		System.out.printf("Win_name : %s\n", Win.name);   // 名前，static 指定のため可
		System.out.printf("Win_name : %s\n", Win.getName());   // 名前，static 変数だけを参照可
		Win w1 = new Win("file", "edit");
		System.out.printf("w1_name : %s\n", w1.name);   // 名前
		System.out.printf("w1_BGC : %s\n", w1.getBGC());   // 背景色
		int s[] = w1.getSize();   // サイズの取得
		System.out.printf("w1_size : %d %d\n", s[0], s[1]);
		System.out.printf("w1_menu : %s %s\n", w1.menu.get(0), w1.menu.get(1));   // メニュー
			// クラス App（クラス Win を継承）
		System.out.printf("\nApp_name : %s\n", App.name);   // 名前，App.getName() でも可
		App a1 = new App("file", "edit");
		System.out.printf("a1_name : %s\n", a1.name);   // 名前
//		a1.setBGC("red");   // スーパークラスの private 変数にアクセスできない
		System.out.printf("a1_BGC : %s\n", a1.getBGC());   // 背景色
		a1.setSize(200, 400);   // サイズの変更
		s = a1.getSize();
		System.out.printf("a1_size : %d %d\n", s[0], s[1]);
		System.out.printf("w1_size : %d %d\n", w1.getSize()[0], w1.getSize()[1]);
		System.out.printf("a1_menu : %s %s %s\n", a1.menu.get(0), a1.menu.get(1), a1.menu.get(2));   // メニュー
			// 代入
		App a2 = a1;
		System.out.printf("\n前 a1_size : %d %d\n", a1.getSize()[0],a1.getSize()[1]);
		System.out.printf("   a2_size : %d %d\n", a2.getSize()[0],a2.getSize()[1]);
		a1.setSize(300, 600);   // サイズの変更
		System.out.printf("後 a1_size : %d %d\n", a1.getSize()[0],a1.getSize()[1]);
		System.out.printf("   a2_size : %d %d\n", a2.getSize()[0],a2.getSize()[1]);
	}
}

/**************/
/* クラス Win */
/**************/
class Win {
	final static String name = "Window1";   // 名前
	private String BGC = "white";   // 背景色
	protected int size[] = {100, 200};   // サイズ（縦と横）
	ArrayList <String> menu = new ArrayList <String> ();   // メニュー
			// コンストラクタ
	Win (String s1, String s2) {
		menu.add(s1);
		menu.add(s2);
	}
			// 名前の取得
	static String getName() { return name; }
			// 背景色の取得
	String getBGC() { return BGC; }
			// サイズの取得
	int[] getSize() { return size; }
}

/**************/
/* クラス App */
/**************/
class App extends Win {   // クラス Win を継承
//	private String BGC;   // 背景色
			// コンストラクタ
	App(String s1, String s2) {
		super(s1, s2);
		menu.add("other");
	}
			// サイズの変更
	void setSize(int row, int col) { size[0] = row; size[1] = col; }
			// 背景色の変更（スーパークラスの private 変数にアクセスできない）
//	void setBGC(String col) { BGC = col; }
//	String getBGC() { return BGC; }
}
