# -*- coding: UTF-8 -*-

##############################
# クラスに対するプログラム例 #
#      coded by Y.Suganuma   #
##############################

##############
# クラス Win #
##############
class Win :
	name = "Window1";   # 名前
			# 初期化（コンストラクタ）
	def __init__(self, s1, s2) :
		self.BGC  = "white"
		self.size = [100, 200]
		self.menu = [s1, s2]
			# 背景色の取得
	def getBGC(self) : return self.BGC
			# サイズの取得
	def getSize(self) : return self.size
			# 名前の取得（クラスメソッド）
	@classmethod
	def getName_c(cls) :
		return cls.name
			# 名前の取得（スタティックメソッド）
	@staticmethod
	def getName_s() :
		return Win.name

##############
# クラス App #
##############
class App(Win) :   # クラス Win を継承
			# 初期化（コンストラクタ）
	def __init__(self, s1, s2) :
		Win.__init__(self, s1, s2)
		(self.menu).append("other")
			# サイズの変更
	def setSize(self, row, col) :
		self.size[0] = row
		self.size[1] = col
			# 背景色の変更
	def setBGC(self, col) : self.BGC = col

			# クラス Win
print("Win_name :", Win.name)   # 名前
w1 = Win("file", "edit")
print("w1_name :", w1.name)   # 名前
print("w1_name(c) :", w1.getName_c())   # 名前（クラスメソッド）
print("w1_name(s) :", w1.getName_s())   # 名前（スタティックメソッド）
print("w1_BGC :", w1.getBGC())   # 背景色，print(w1.BGC) でも可
s = w1.getSize()   # サイズの取得，s = w1.size でも可
print("w1_size :", s[0], s[1])
print("w1_menu :", w1.menu[0], w1.menu[1])   # メニュー
			# クラス App
print("\nApp_name :", App.name)   # 名前(App)
print("Win_name :", Win.name)   # 名前(Win)
a1       = App("file", "edit")
App.name = "Window2"
a1.name  = "Window3"
print("App_name :", App.name)   # 名前(App)
print("Win_name :", Win.name)   # 名前(Win)
print("a1_name :", a1.name)   # 名前
print("a1_name(c) :", a1.getName_c())   # 名前（クラスメソッド）
print("a1_name(s) :", a1.getName_s())   # 名前（スタティックメソッド）
a1.setBGC("red");
print("a1_BGC :", a1.getBGC())   # 背景色，print(a1.BGC) でも可
print("w1_BGC :", w1.getBGC())   # 背景色，print(w1.BGC) でも可
a1.setSize(200, 400)   # サイズの変更
s = a1.getSize()   # サイズの取得，s = a1.size でも可
print("a1_size :", s[0], s[1])
print("w1_size :", w1.getSize()[0], w1.getSize()[1])
print("a1_menu :", a1.menu[0], a1.menu[1], a1.menu[2])   # メニュー
			# 代入
a2 = a1
print("\n前 a1_size :", a1.getSize()[0], a1.getSize()[1])
print("   a2_size :", a2.getSize()[0], a2.getSize()[1])
a1.setSize(300, 600)   # サイズの変更
print("後 a1_size :", a1.getSize()[0], a1.getSize()[1])
print("   a2_size :", a2.getSize()[0], a2.getSize()[1])
