/****************************/
/* back propagation model   */
/*      coded by Y.Suganuma */
/****************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctime>
#include "MT.h"

/******************************************************/
/* obNvpQ[V̐iNX BackControlj */
/******************************************************/
class BackControl {
	protected:
		double alpha, eata;   //d݋yуoCAXCp[^
		double eps;   // e덷
		unsigned long seed;   // ̏l;
		int order;   // ̓p^[̗^i=0:ԁC=1:_j
		int p_type;   // o͐E@̎w
                      //   =0 : ĔFo
                      //   =1 : Fʂo
                      //   =2 : FʂƏd݂o
                      //        i̎́CFʂƏd݂t@Cւój
		char o_file[100];   // o̓t@C
	public:
		BackControl(char *);   // RXgN^
};

/*****************************************************/
/* obNvpQ[Ṽf[^iNX BackDataj */
/*****************************************************/
class BackData {
		int noiu;   // ̓jbg̐
		int noou;   // o̓jbg̐
		int noip;   // ̓p^[̐
		double **iptn;   // iptn[i][j] : (i+1)Ԗڂ̓̓p^[(j+1)Ԗڂ
                         //              ̓jbg̓͒l
                         //                i=0,noip-1  j=0,noiu-1
		double **optn;   // optn[i][j] : (i+1)Ԗڂ̓̓p^[ɑ΂(j+1)
                         //              Ԗڂ̏o̓jbg̖ڕWo͒l
                         //                i=0,noip-1  j=0,noou-1
	public:
		BackData(char *);   // RXgN^
		~BackData();   // fXgN^
	friend class Backpr;
};

/*******************************************/
/* obNvpQ[ViNX Backprj */
/*******************************************/
class Backpr : BackControl {
		char **con;   // con[i][j] : ejbgɑ΂oCAX̗^CyсC
                      // ڑ@
                      //   [i][i] : jbg(i+1)̃oCAX̗^
                      //     =-3 : ͒lŌŒ
                      //     =-2 : ͒llƂāCwKɂύX
                      //     =-1 : ŏlݒ肵CwKɂύX
                      //   [i][j] : jbg(i+1)(j+1)̐ڑ@(j>i)
                      //     =0 : ڑȂ
                      //     =1 : ڑ(d݂̏l𗐐Őݒ肵CwK)
                      //     =2 : ڑ(d݂̏l͂ŗ^CwK)
                      //     =3 : ڑ(d݂͒lɌŒ)
                      //            i=0,nou-1  j=0,nou-1
		int f_type;   // VOCh֐̃^Cv
                      //   0 : [0,1]
                      //   1 : [-1,1]j
		int noiu;   // ̓jbg̐
		int noou;   // o̓jbg̐
		int *nohu;   // nohu[i] : x(i+1)̉Bw̃jbgiBw
                     //           ɂ͉珇ɔԍtCo͑w̓
                     //           x(nolvl+1)̉BwƂ􂳂j
                     //             i=0,nolvl
		int nolvl;   // Bꃆjbg̊Kw
		int nou;   // ́CóCyсCBẘejbg̘̐aiej
                   // bgɂ͍ł̏o̓jbgCBẘejbgC
                   // yсC̓jbgɎÃjbgԍt
                   // j
		double *dp;   // dp[i] : jbg(i+1)̌덷  i=0,nou-1
		double *op;   // op[i] : jbg(i+1)̏o  i=0,nou-1
		double *theta;   //theta[i] : jbg(i+1)̃oCAX  i=0,nou
		double **w;   // w[i][j] : jbg(i+1)(j+1)ւ̏d(j>i)
                      // w[j][i] : (i+1)(j+1)ւ̏d݂̑OC(j>i)
                      // w[i][i] : jbg(i+1)̃oCAX̑OC
                      //   i=0,nou-1  j=0,nou-1
	public:
		Backpr(char *, char *);   // RXgN^
		~Backpr();   // fXgN^
		void Err_back(double *);   // d݂̏C
		void Forward();   // 덷̌vZ
		void Learn(BackData &, int);   // wK
		int Recog(BackData &, int, int);   // FƊwK
};

/*************************************/
/* NXBackControl̃RXgN^ */
/*      name : ̓f[^t@C  */
/*************************************/
BackControl::BackControl(char *name)
{
	FILE *in;

	in = fopen(name, "r");

	fscanf(in, "%*s %lf %*s %d", &eps, &p_type);
	if (p_type < 0)
		fscanf(in, "%*s %s", o_file);
	fscanf(in, "%*s %d %*s %lf %*s %lf", &order, &eata, &alpha);

	fclose(in);
	seed = (unsigned long)time(NULL);
}

/************************************/
/* NXBackDatãRXgN^   */
/*      name : ̓f[^t@C */
/************************************/
BackData::BackData(char *name)
{
	int i1, i2;
	FILE *in;

	in = fopen(name, "r");
/*
    ̓p^[
*/
	fscanf(in, "%*s %d %*s %d %*s %d", &noip, &noiu, &noou);
/*
     ̈̊m
*/
	iptn = new double * [noip];
	for (i1 = 0; i1 < noip; i1++)
		iptn[i1] = new double [noiu];

	optn = new double * [noip];
	for (i1 = 0; i1 < noip; i1++)
		optn[i1] = new double [noou];
/*
     ̓p^[yъe̓p^[ɑ΂o̓p^[̓
*/
	for (i1 = 0; i1 < noip; i1++) {
		fscanf(in, "%*s");
		for (i2 = 0; i2 < noiu; i2++)
			fscanf(in, "%lf", &(iptn[i1][i2]));
		fscanf(in, "%*s");
		for (i2 = 0; i2 < noou; i2++)
			fscanf(in, "%lf", &(optn[i1][i2]));
	}

	fclose(in);
}

/**************************/
/* BackDatãfXgN^ */
/**************************/
BackData::~BackData()
{
	int i1;

	for (i1 = 0; i1 < noip; i1++)
		delete [] iptn[i1];
	delete [] iptn;

	for (i1 = 0; i1 < noip; i1++)
		delete [] optn[i1];
	delete [] optn;
}

/************************************************/
/* NXBackpr̃RXgN^                 */
/*      name_c : f[^p̓t@C     */
/*      name_s : lbg[NLq̓t@C */
/************************************************/
Backpr::Backpr(char *name_c, char *name_s) : BackControl(name_c)
{
	double x1, x2;
	int i0, i1, i2, id, k, k1, k2, k3, k4, l1, l2, n, sw;
	FILE *in;

	in = fopen(name_s, "r");
/*
     ̏
*/
	init_genrand(seed);
/*
     ̓jbgCo̓jbg̐C֐^Cv
*/
	fscanf(in, "%*s %d %*s %d %*s %d", &noiu, &noou, &f_type);
	nou = noiu + noou;   // ̓jbgƏo̓jbg̘a
/*
     Bꃆjbg̊KwƊeKw̃jbg
*/
	fscanf(in, "%*s %d", &nolvl);

	nohu        = new int [nolvl+1];
	nohu[nolvl] = noou;   // o̓jbg̐

	if (nolvl > 0) {
		fscanf(in, "%*s");
		for (i1 = 0; i1 < nolvl; i1++) {
			fscanf(in, "%d", &(nohu[i1]));
			nou += nohu[i1];
		}
	}
/*
     ̈̊m
*/
	con = new char * [nou];
	for (i1 = 0; i1 < nou; i1++) {
		con[i1] = new char [nou];
		for (i2 = 0; i2 < nou; i2++)
			con[i1][i2] =  (i1 == i2) ? -1 : 0;
	}

	w = new double * [nou];
	for (i1 = 0; i1 < nou; i1++) {
		w[i1]     = new double [nou];
		for (i2 = 0; i2 < nou; i2++)
			w[i1][i2] = 0.0;
	}

	dp    = new double [nou];
	op    = new double [nou];
	theta = new double [nou];

	for (i1 = 0; i1 < nou; i1++)
		theta[i1] = 0.2 * genrand_real3() - 0.1;
/*
     ejbg̃oCAXƃjbgԂ̐ڑ֌W
*/
					// oCAX
						// oCAXf[^̐
	fscanf(in, "%*s %d", &n);
	fscanf(in, "%*s %*s %*s");

	if (n > 0) {
						// oCAXf[^̏
		for (i0 = 0; i0 < n; i0++) {
							// jbgԍ
			fscanf(in, "%d", &k1);
							// sKȃjbgԍ̃`FbN
			if (k1 < 1 || k1 > (nou-noiu)) {
				printf("***error  jbgԍ %d sK\n", k1);
				exit(1);
			}
							// oCAX̗^
			k1--;
			fscanf(in, "%d", &id);
			con[k1][k1] = id;
							// oCAX̏ݒ
			switch (con[k1][k1]) {
				case -1:
					fscanf(in, "%lf %lf", &x1, &x2);
					theta[k1] = (x2 - x1) * genrand_real3() + x1;
					break;
				case -2:
					fscanf(in, "%lf", &(theta[k1]));
					break;
				case -3:
					fscanf(in, "%lf", &(theta[k1]));
					break;
				default:
					printf("***error  oCAX̗^sK\n");
					exit(1);
			}
		}
	}
					// ڑ@
						// ڑf[^̐
	fscanf(in, "%*s %d", &n);
	fscanf(in, "%*s %*s %*s");

	if (n > 0) {
						// ڑf[^̏
		for (i0 = 0; i0 < n; i0++) {
							// ڑ
			fscanf(in, "%d %d %d %d", &k1, &k2, &k3, &k4);
							// sK؂Ȑڑ̃`FbN
			sw = 0;
			if (k1 < 1 || k2 < 1 || k3 < 1 || k4 < 1)
				sw = 1;
			else {
				if (k1 > nou || k2 > nou || k3 > nou || k4 > nou)
					sw = 1;
				else {
					if (k1 > k2 || k3 > k4)
						sw = 1;
					else {
						if (k4 >= k1)
							sw = 1;
						else {
							l1 = -1;
							k  = 0;
							for (i1 = nolvl; i1 >= 0 && l1 < 0; i1--) {
								k += nohu[i1];
								if (k1 <= k)
									l1 = i1;
							}
							l2 = -1;
							k  = 0;
							for (i1 = nolvl; i1 >= 0 && l2 < 0; i1--) {
								k += nohu[i1];
								if (k4 <= k)
									l2 = i1;
							}
							if (l2 <= l1)
								sw = 1;
						}
					}
				}
			}

			if (sw > 0) {
				printf("***error  jbgԍsKi%d %d %d %dj\n",
                       k1, k2, k3, k4);
				exit(1);
			}
							// d݂̏l̗^
			k1--;
			k2--;
			k3--;
			k4--;

			fscanf(in, "%d", &id);

			if (id == 1)
				fscanf(in, "%lf %lf", &x1, &x2);
			else {
				if (id > 1)
					fscanf(in, "%lf", &x1);
				else {
					if (id != 0) {
						printf("***error  ڑ@sK\n");
						exit(1);
					}
				}
			}
							// d݂̏l̐ݒ
			for (i1 = k3; i1 <= k4; i1++) {
				for (i2 = k1; i2 <= k2; i2++) {
					con[i1][i2] = id;
					switch (id) {
						case 0:
							w[i1][i2] = 0.0;
							break;
						case 1:
							w[i1][i2] = (x2 - x1) * genrand_real3() + x1;
							break;
						case 2:
							w[i1][i2] = x1;
							break;
						case 3:
							w[i1][i2] = x1;
							break;
					}
				}
			}
		}
	}

	fclose(in);
}

/************************/
/* Backpr̃fXgN^ */
/************************/
Backpr::~Backpr()
{
	int i1;

	for (i1 = 0; i1 < nou; i1++)
		delete [] con[i1];
	delete [] con;

	for (i1 = 0; i1 < nou; i1++)
		delete [] w[i1];
	delete [] w;

	delete [] nohu;
	delete [] dp;
	delete [] op;
	delete [] theta;
}

/******************************************/
/* 덷̌vZCyсCd݂ƃoCAX̏C */
/*      ptn[i1] : o̓p^[            */
/******************************************/
void Backpr::Err_back(double *ptn)
{
	double x1;
	int i1, i2;

	for (i1 = 0; i1 < nou-noiu; i1++) {
					// 덷̌vZ
		if (i1 < noou) {
			if (f_type == 0)
				dp[i1] = (ptn[i1] - op[i1]) * op[i1] * (1.0 - op[i1]);
			else
				dp[i1] = 0.5 * (ptn[i1] - op[i1]) * 
                         (op[i1] - 1.0) * (op[i1] + 1.0);
		}
		else {
			x1 = 0.0;
			for (i2 = 0; i2 < i1; i2++) {
				if (con[i2][i1] > 0)
					x1 += dp[i2] * w[i2][i1];
			}
			if (f_type == 0)
				dp[i1] = op[i1] * (1.0 - op[i1]) * x1;
			else
				dp[i1] = 0.5 * (op[i1] - 1.0) * (op[i1] + 1.0) * x1;
		}
					// d݂̏C
		for (i2 = i1+1; i2 < nou; i2++) {
			if (con[i1][i2] == 1 || con[i1][i2] == 2) {
				x1         = eata * dp[i1] * op[i2] + alpha * w[i2][i1];
				w[i2][i1]  = x1;
				w[i1][i2] += x1;
			}
		}
					// oCAX̏C
		if (con[i1][i1] >= -2) {
			x1         = eata * dp[i1] + alpha * w[i1][i1];
			w[i1][i1]  = x1;
			theta[i1] += x1;
		}
	}
}

/********************************************************/
/* ^ꂽ̓p^[ɑ΂ejbg̏o͂̌vZ */
/********************************************************/
void Backpr::Forward()
{
	double sum;
	int i1, i2;

	for (i1 = nou-noiu-1; i1 >= 0; i1--) {

		sum = -theta[i1];

		for (i2 = i1+1; i2 < nou; i2++) {
			if (con[i1][i2] > 0)
				sum -= w[i1][i2] * op[i2];
		}

		op[i1] = (f_type == 0) ? 1.0 / (1.0 + exp(sum)) :
                                 1.0 - 2.0 / (1.0 + exp(sum));
	}
}

/*****************************/
/* wK̎s                */
/*      p : Fp^[     */
/*      m_tri : őwK */
/*****************************/
void Backpr::Learn(BackData &p, int m_tri)
{
	int i1, i2, k0 = -1, k1;
/*
     G[`FbN
*/
	if (noiu != p.noiu || noou != p.noou) {
		printf("***error  ͂܂͏o̓jbg̐Ⴂ܂\n");
		exit(1);
	}

	for (i1 = 0; i1 < m_tri; i1++) {
/*
     p^[^鏇Ԃ̌
*/
		if (order == 0) {       // 
			k0++;
			if (k0 >= p.noip)
				k0 = 0;
		}
		else {                  // _
			k0 = (int)(genrand_real3() * p.noip);
			if (k0 >= p.noip)
				k0 = p.noip - 1;
		}
/*
     o̓jbǧʂvZ
*/
		k1 = nou - noiu;
		for (i2 = 0; i2 < noiu; i2++)
			op[k1+i2] = p.iptn[k0][i2];

		Forward();
/*
     d݂ƃoCAX̏C
*/
		Err_back(&(p.optn[k0][0]));
	}
}

/***********************************************/
/* ^ꂽΏۂ̔FƏo                  */
/*      p : Fp^[                       */
/*      pr : =0 : o͂sȂ               */
/*           =1 : o͂s                   */
/*           =2 : o͂siwKp^[j */
/*      tri : ݂̊wK                   */
/*      return : ĔFp^[̐    */
/***********************************************/
int Backpr::Recog(BackData &p, int pr, int tri)
{
	int i1, i2, k1, No = 0, ln, sw;
	FILE *out = NULL;
/*
     t@C̃I[v
*/
	if (p_type < 0 && pr > 0) {
		if (pr == 1) {
			out = fopen(o_file, "w");
			fprintf(out, "***wKp^[***\n\n");
		}
		else {
			out = fopen(o_file, "a");
			fprintf(out, "\n***wKp^[***\n\n");
		}
	}
/*
     ep^[ɑ΂o
*/
	for (i1 = 0; i1 < p.noip; i1++) {
					// ̓p^[̐ݒ
		k1 = nou - noiu;
		for (i2 = 0; i2 < noiu; i2++)
			op[k1+i2] = p.iptn[i1][i2];
					// o͂̌vZ
		Forward();
					// ʂ̕\
		if (p_type != 0 && pr > 0) {

			printf("̓p^[%4d    ", i1+1);
			for (i2 = 0; i2 < noiu; i2++) {
				printf("%5.2f", op[k1+i2]);
				if (i2 == noiu-1)
					printf("\n");
				else {
					if(((i2+1) % 10) == 0)
						printf("\n                    ");
				}
			}

			printf("\n    o̓p^[(z)   ");
			for (i2 = 0; i2 < noou; i2++) {
				printf("%10.3f", p.optn[i1][i2]);
				if (i2 == noou-1)
					printf("\n");
				else {
					if(((i2+1) % 5) == 0)
						printf("\n                         ");
				}
			}
		}

		sw = 0;
		if (p_type != 0 && pr > 0)
			printf("                ()   ");
		for (i2 = 0; i2 < noou; i2++) {
			if (p_type != 0 && pr > 0) {
				printf("%10.3f", op[i2]);
				if (i2 == noou-1)
					printf("\n");
				else {
					if(((i2+1) % 5) == 0)
						printf("\n                         ");
				}
			}
			if (fabs(op[i2]-p.optn[i1][i2]) > eps)
				sw = 1;
		}

		if (sw > 0)
			No++;

		if (p_type < 0 && pr > 0) {

			fprintf(out, "̓p^[%4d    ", i1+1);
			for (i2 = 0; i2 < noiu; i2++) {
				fprintf(out, "%5.2f", op[k1+i2]);
				if (i2 == noiu-1)
					fprintf(out, "\n");
				else {
					if(((i2+1) % 10) == 0)
						fprintf(out, "\n                    ");
				}
			}

			fprintf(out, "\n    o̓p^[(z)   ");
			for (i2 = 0; i2 < noou; i2++) {
				fprintf(out, "%10.3f", p.optn[i1][i2]);
				if (i2 == noou-1)
					fprintf(out, "\n");
				else {
					if(((i2+1) % 5) == 0)
						fprintf(out, "\n                         ");
				}
			}

			fprintf(out, "                ()   ");
			for (i2 = 0; i2 < noou; i2++) {
				fprintf(out, "%10.3f", op[i2]);
				if (i2 == noou-1)
					fprintf(out, "\n");
				else {
					if(((i2+1) % 5) == 0)
						fprintf(out, "\n                         ");
				}
			}
		}

		if (p_type != 0 && pr > 0) {
			getchar();
			if (i1 == 0)
				getchar();
		}
	}
/*
     d݂̏o
*/
	if ((p_type < -1 || p_type > 1) && pr == 1) {

		printf("    d\n");
		for (i1 = 0; i1 < nou-noiu; i1++) {
			printf("      to%4d from   ", i1+1);
			ln = -1;
			for (i2 = 0; i2 < nou; i2++) {
				if (con[i1][i2] > 0) {
					if (ln <= 0) {
						if (ln < 0)
							ln = 0;
						else
							printf("\n                    ");
					}
					printf("%4d%11.3f", i2+1, w[i1][i2]);
					ln += 1;
					if (ln == 4)
						ln = 0;
				}
			}

			printf("\n");
		}

		printf("\n    oCAX   ");
		ln = 0;
		for (i1 = 0; i1 < nou-noiu; i1++) {
			printf("%4d%11.3f", i1+1, theta[i1]);
			ln += 1;
			if (ln == 4 && i1 != nou-noiu-1) {
				ln = 0;
				printf("\n               ");
			}
		}

		if (ln != 0)
			printf("\n");

		getchar();
	}

	if (p_type < 0 && pr == 1) {

		fprintf(out, "    d\n");
		for (i1 = 0; i1 < nou-noiu; i1++) {
			fprintf(out, "      to%4d from   ", i1+1);
			ln = -1;
			for (i2 = 0; i2 < nou; i2++) {
				if (con[i1][i2] > 0) {
					if (ln <= 0) {
						if (ln < 0)
							ln = 0;
						else
							fprintf(out, "\n                    ");
					}
					fprintf(out, "%4d%11.3f", i2+1, w[i1][i2]);
					ln += 1;
					if (ln == 4)
						ln = 0;
				}
			}

			fprintf(out, "\n");
		}

		fprintf(out, "\n    oCAX   ");
		ln = 0;
		for (i1 = 0; i1 < nou-noiu; i1++) {
			fprintf(out, "%4d%11.3f", i1+1, theta[i1]);
			ln += 1;
			if (ln == 4 && i1 != nou-noiu-1) {
				ln = 0;
				fprintf(out, "\n               ");
			}
		}

		if (ln != 0)
			fprintf(out, "\n");
	}

	if (p_type < 0 && pr > 0)
		fclose(out);

	return No;
}

/****************/
/* main program */
/****************/
int main(int argc, char *argv[])
{
	int conv;   // mF
	int m_tri;   // őwK
	int max = 0, no = 1, sw, tri;
	char f_name[100];
					// G[
	if (argc != 3) {
		printf("***error   ̓f[^t@Cw肵ĉ\n");
		exit(1);
	}

	else {
					// lbg[N̒`
		Backpr net(argv[1], argv[2]);
					// wKp^[̓
		printf("wK񐔂́H ");
		scanf("%d", &m_tri);
		printf("񖈂ɎmF܂H ");
		scanf("%d", &conv);

		printf("wKp^[̃t@ĆH ");
		scanf("%s", f_name);

		BackData dt1(f_name);
					// wK
		while (max < m_tri && no > 0) {

			tri  = ((max + conv) < m_tri) ? conv : m_tri - max;
			max += tri;

			net.Learn(dt1, tri);   // wK

			no = net.Recog(dt1, 0, max);   // wKΏۂ̔F

			printf("    %d ĔFp^[ %d\n", max, no);
		}

		no = net.Recog(dt1, 1, max);   // wKΏۂ̔FƏo
					// wKp^[̔F
		printf("wKp^[̔Fs܂Hi=1:sC=0:sȂj ");
		scanf("%d", &sw);

		if (sw > 0) {

			printf("wKp^[̃t@ĆH ");
			scanf("%s", f_name);

			BackData dt2(f_name);

			no = net.Recog(dt2, 2, max);   // wKΏۂ̔FƏo
		}
	}

	return 0;
}

/*
------------------------f[^----------------
덷 0.1 o -2 o̓t@C kekka
 0  0.5  0.8

------------------------\f[^----------------
̓jbg 2 o̓jbg 1 ֐^Cv 0
Bw̐ 1 eBw̃jbgij 1
oCAX̓jbg 1
@jbgԍFo̓jbg珇ɔԍt
@͕@F=-3:ŒC=-2:͌wKC=-1:(defaultC[-0.1,0.1])j
@lFoCAXli[Q܂́[R̎j܂͈l͈̔́iCj
1 -1 -0.05 0.05
ڑ@̐ 2
@jbgԍFjbgk1k2Ck3k4ɐڑ
@ڑ@F=0:ڑȂC=1:C=2:dݓ͌wKC=3:d݌Œ
@lFd݁iQ܂͂R̎j܂͈l͈̔́iP̎FCj
3 4 1 2 1 -0.1 0.1
2 2 1 1 1 -0.1 0.1

------------------------wKf[^----------------
p^[̐ 4 ̓jbg 2 o̓jbg 1
͂P 0 0
@o͂P 0
͂Q 0 1
@o͂Q 1
͂R 1 0
@o͂R 1
͂S 1 1
@o͂S 0

------------------------Ff[^----------------
p^[̐ 4 ̓jbg 2 o̓jbg 1
͂P 0 0
@o͂P 0
͂Q 0 1
@o͂Q 1
͂R 1 0
@o͂R 1
͂S 1 1
@o͂S 0

//---------------------MT.h---------------------------
//   A C-program for MT19937, with initialization improved 2002/1/26.
//   Coded by Takuji Nishimura and Makoto Matsumoto.
//
//   Before using, initialize the state by using init_genrand(seed)  
//   or init_by_array(init_key, key_length).
//
//   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
//   All rights reserved.                          
//
//   Redistribution and use in source and binary forms, with or without
//   modification, are permitted provided that the following conditions
//   are met:
//
//     1. Redistributions of source code must retain the above copyright
//        notice, this list of conditions and the following disclaimer.
//
//     2. Redistributions in binary form must reproduce the above copyright
//        notice, this list of conditions and the following disclaimer in the
//        documentation and/or other materials provided with the distribution.
//
//     3. The names of its contributors may not be used to endorse or promote 
//        products derived from this software without specific prior written 
//        permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
//   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
//   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
//   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
//   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//
//   Any feedback is very welcome.
//   http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html
//   email: m-mat @ math.sci.hiroshima-u.ac.jp (remove space)


//   The original version of http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/MT2002/CODES/mt19937ar.c was modified by Takahiro Omi as
//   - delete line 47 "#include<stdio.h>"
//   - delete line 174 int main(void){...}
//   - change N -> MT_N
//   - change N -> MT_N
//   - change the file name "mt19937ar.c" -> "MT.h"


// Period parameters
#define MT_N 624
#define MT_M 397
#define MATRIX_A 0x9908b0dfUL   // constant vector a
#define UPPER_MASK 0x80000000UL // most significant w-r bits
#define LOWER_MASK 0x7fffffffUL // least significant r bits

static unsigned long mt[MT_N]; // the array for the state vector
static int mti=MT_N+1; // mti==MT_N+1 means mt[MT_N] is not initialized

// initializes mt[MT_N] with a seed
void init_genrand(unsigned long s)
{
    mt[0]= s & 0xffffffffUL;
    for (mti=1; mti<MT_N; mti++) {
        mt[mti] = 
	    (1812433253UL * (mt[mti-1] ^ (mt[mti-1] >> 30)) + mti); 
        // See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier.
        // In the previous versions, MSBs of the seed affect
        // only MSBs of the array mt[].
        // 2002/01/09 modified by Makoto Matsumoto
        mt[mti] &= 0xffffffffUL;
        // for >32 bit machines
    }
}

// initialize by an array with array-length
// init_key is the array for initializing keys
// key_length is its length
// slight change for C++, 2004/2/26
void init_by_array(unsigned long init_key[], int key_length)
{
    int i, j, k;
    init_genrand(19650218UL);
    i=1; j=0;
    k = (MT_N>key_length ? MT_N : key_length);
    for (; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1664525UL))
          + init_key[j] + j; // non linear
        mt[i] &= 0xffffffffUL; // for WORDSIZE > 32 machines
        i++; j++;
        if (i>=MT_N) { mt[0] = mt[MT_N-1]; i=1; }
        if (j>=key_length) j=0;
    }
    for (k=MT_N-1; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1566083941UL))
          - i; // non linear
        mt[i] &= 0xffffffffUL; // for WORDSIZE > 32 machines
        i++;
        if (i>=MT_N) { mt[0] = mt[MT_N-1]; i=1; }
    }

    mt[0] = 0x80000000UL; // MSB is 1; assuring non-zero initial array
}

// generates a random number on [0,0xffffffff]-interval
unsigned long genrand_int32(void)
{
    unsigned long y;
    static unsigned long mag01[2]={0x0UL, MATRIX_A};
    // mag01[x] = x * MATRIX_A  for x=0,1

    if (mti >= MT_N) { // generate N words at one time
        int kk;

        if (mti == MT_N+1)   // if init_genrand() has not been called,
            init_genrand(5489UL); // a default initial seed is used

        for (kk=0;kk<MT_N-MT_M;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+MT_M] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        for (;kk<MT_N-1;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+(MT_M-MT_N)] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        y = (mt[MT_N-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
        mt[MT_N-1] = mt[MT_M-1] ^ (y >> 1) ^ mag01[y & 0x1UL];

        mti = 0;
    }
  
    y = mt[mti++];

    // Tempering
    y ^= (y >> 11);
    y ^= (y << 7) & 0x9d2c5680UL;
    y ^= (y << 15) & 0xefc60000UL;
    y ^= (y >> 18);

    return y;
}

// generates a random number on [0,0x7fffffff]-interval
long genrand_int31(void)
{
    return (long)(genrand_int32()>>1);
}

// generates a random number on [0,1]-real-interval
double genrand_real1(void)
{
    return genrand_int32()*(1.0/4294967295.0); 
    // divided by 2^32-1
}

// generates a random number on [0,1)-real-interval
double genrand_real2(void)
{
    return genrand_int32()*(1.0/4294967296.0); 
    // divided by 2^32
}

// generates a random number on (0,1)-real-interval
double genrand_real3(void)
{
    return (((double)genrand_int32()) + 0.5)*(1.0/4294967296.0); 
    // divided by 2^32
}

// generates a random number on [0,1) with 53-bit resolution
double genrand_res53(void) 
{ 
    unsigned long a=genrand_int32()>>5, b=genrand_int32()>>6; 
    return(a*67108864.0+b)*(1.0/9007199254740992.0); 
} 
// These real versions are due to Isaku Wada, 2002/01/09 added
*/
