/*********************************/
/* Hopfieldlbg[Ni TSP j */
/*      Coded by Y.Suganuma)     */
/*********************************/
using System;

class Program
{
	static void Main()
	{
		Test1 ts = new Test1();
	}
}

class Test1
{

	int n = 4;
	double A = 10.0, B = 10.0, C = 10.0, D = 2.0;
	double[][] d;

	public Test1()
	{
		d = new double [n][];
		for (int i1 = 0; i1 < n; i1++)
			d[i1] = new double [n];
					// 
		double r = Math.Sqrt(2.0);
		for (int i1 = 0; i1 < n; i1++) {
			for (int i2 = 0; i2 < n; i2++) {
				if (i1 == i2)
					d[i1][i2] = 0.0;
				else
					d[i1][i2] = 1.0;
			}
		}
		d[0][2] = r;
		d[1][3] = r;
		d[2][0] = r;
		d[3][1] = r;
					// 
		double[][] u = new double [n][];
		Random rn = new Random();
		for (int i1 = 0; i1 < n; i1++) {
			u[i1] = new double [n];
			for (int i2 = 0; i2 < n; i2++)
				u[i1][i2] = 0.1 * rn.NextDouble() - 0.05;
		}

		Console.WriteLine("ԁiójF");
		for (int i1 = 0; i1 < n; i1++) {
			for (int i2 = 0; i2 < n; i2++)
				Console.Write(" " + out_u(u[i1][i2]));
			Console.WriteLine();
		}
					// XV
		double time  = 0.0;
		double[] dx  = new double[n*n];
		double[] uu  = new double[n*n];
		double[][] g = new double [4][];
		for (int i1 = 0; i1 < 4; i1++)
			g[i1] = new double [n*n];
		int k = 0;
		for (int i1 = 0; i1 < n; i1++) {
			for (int i2 = 0; i2 < n; i2++) {
				uu[k] = u[i1][i2];
				k++;
			}
		}
		for (int i1 = 0; i1 < 100; i1++)
			time = rkg(time, 1, uu, dx, g, n*n, snx);

		Console.WriteLine("ŏIԁiójF");
		for (int i1 = 0; i1 < n; i1++) {
			for (int i2 = 0; i2 < n; i2++)
				Console.Write(" " + out_u(uu[i1*n+i2]));
			Console.WriteLine();
		}
	}

	/******************/
	/* jbg̏o */
	/******************/
	double out_u(double x)
	{
		return 0.5 * (1.0 + Math.Tanh(x));
//		return 1.0 / (1.0 + Math.Exp(-x));
	}

	/****************/
	/* W̌vZ */
	/****************/
	int snx(double time, double[] u, double[] du)
	{
		for (int x = 0; x < n; x++) {
			for (int i = 0; i < n; i++) {
				int k = n * x + i;
				du[k] = 0.0;
				for (int j = 0; j < n; j++) {
					if (j != i)
						du[k] -= A * out_u(u[n*x+j]);
				}
				for (int y = 0; y < n; y++) {
					if (y != x)
						du[k] -= B * out_u(u[n*y+i]);
				}
				double N = 0.0;
				for (int xx = 0; xx < n; xx++) {
					for (int ii = 0; ii < n; ii++)
						N += out_u(u[n*xx+ii]);
				}
				du[k] -= C * (N - n);
				for (int y = 0; y < n; y++) {
					int m1 = (i + 1) % n;
					int m2 = i - 1;
					if (m2 < 0)
						m2 = n - 1;
					du[k] -= D * d[x][y] * (out_u(u[n*y+m1]) + out_u(u[n*y+m2]));
				}
			}
		}
		return 0;
	}

	/********************************************/
	/* QENb^@  dx/dt=f(t,x)           */
	/*      time : ݂̎                   */
	/*      h : ԍݕ                      */
	/*      x : ݂̏                      */
	/*      dx : Wif(t,x):snxŌvZj */
	/*      g : ƈig[4][n]j               */
	/*      n : ̎                */
	/*      fn : ֐lvZ֐           */
	/*      return : time+h                     */
	/********************************************/
	double rkg(double time, double h, double[] x, double[] dx, double[][] g,
	           int n, Func<double, double[], double[], int> fn)
	{
		double h2 = 0.5 * h;

		fn(time, x, dx);
		for (int i1 = 0; i1 < n; i1++)
			g[0][i1] = h * dx[i1];

		time += h2;
		for (int i1 = 0; i1 < n; i1++)
			g[1][i1] = x[i1] + 0.5 * g[0][i1];
		fn(time, g[1], dx);
		for (int i1 = 0; i1 < n; i1++)
			g[1][i1] = h * dx[i1];

		for (int i1 = 0; i1 < n; i1++)
			g[2][i1] = x[i1] + 0.5 * g[1][i1];
		fn(time, g[2], dx);
		for (int i1 = 0; i1 < n; i1++)
			g[2][i1] = h * dx[i1];

		time += h2;
		for (int i1 = 0; i1 < n; i1++)
			g[3][i1] = x[i1] + g[2][i1];
		fn(time, g[3], dx);
		for (int i1 = 0; i1 < n; i1++)
			g[3][i1] = h * dx[i1];

		for (int i1 = 0; i1 < n; i1++)
			x[i1] = x[i1] + (g[0][i1] + 2.0 * g[1][i1] + 2.0 * g[2][i1] + g[3][i1]) / 6.0;

		return time;
	}
}
