/***********************************/
/* p[ZvgwK              */
/* iPocket Algorith with Ratcetj */
/*      coded by Y.Suganuma        */
/***********************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "MT.h"

/**************************/
/* PerceptronNX̒` */
/**************************/
class Perceptron {
		long max;   // őwK
		long n;   // P̐
		long p;   // ̓Z̐
		long *W_p;   // d݁i|Pbgj
		long *W;   // d
		long **E;   // P
		long *C;   // ePɑ΂鐳o
	public:
		Perceptron(long, long, long, long);
		~Perceptron();
		long Bunrui();
		void Input(char *);
		void Learn(int, char *name = "");
		long Pocket(long *);
};

/******************/
/* RXgN^ */
/******************/
Perceptron::Perceptron(long max_i, long n_i, long p_i, long seed)
{
	long i1;
/*
     ݒ
*/
	max = max_i;
	n   = n_i;
	p   = p_i;

	init_genrand(seed);
/*
     ̈̊m
*/
	E   = new long * [n];
	for (i1 = 0; i1 < n; i1++)
		E[i1] = new long [p+1];

	W_p = new long [p+1];
	W   = new long [p+1];
	C   = new long [n];
}

/****************/
/* fXgN^ */
/****************/
Perceptron::~Perceptron()
{
	int i1;

	for (i1 = 0; i1 < n; i1++)
		delete [] E[i1];
	delete [] E;

	delete [] W_p;
	delete [] W;
	delete [] C;
}

/******************************************/
/* P̕                           */
/*      return : ނP̐ */
/******************************************/
long Perceptron::Bunrui()
{
	long i1, i2, num = 0, s;

	for (i1 = 0; i1 < n; i1++) {
		s = 0;
		for (i2 = 0; i2 <= p; i2++)
			s += W[i2] * E[i1][i2];
		if ((s > 0 && C[i1] > 0) || (s < 0 && C[i1] < 0))
			num++;
	}

	return num;
}

/**************************/
/* wKf[^̓ǂݍ   */
/*      name : t@C */
/**************************/
void Perceptron::Input(char *name)
{
	long i1, i2;
	FILE *st;

	st = fopen(name, "r");

	fscanf(st, "%*s");

	for (i1 = 0; i1 < n; i1++) {
		E[i1][0] = 1;
		for (i2 = 1; i2 <= p; i2++)
			fscanf(st, "%ld", &E[i1][i2]);
		fscanf(st, "%ld", &C[i1]);
	}

	fclose(st);
}

/*********************************/
/* wKƌʂ̏o              */
/*      pr : =0 : ʂɏo     */
/*           =1 : t@Cɏo */
/*      name : o̓t@C    */
/*********************************/
void Perceptron::Learn(int pr, char *name)
{
	long i1, i2, n_tri, num, s;
	FILE *out;

	n_tri = Pocket(&num);

	if (pr == 0)
		out = stdout;
	else
		out = fopen(name, "w");

	fprintf(out, "d\n");
	for (i1 = 0; i1 <= p; i1++)
		fprintf(out, "%5ld", W_p[i1]);
	fprintf(out, "\n");

	fprintf(out,"ތ\n");
	for (i1 = 0; i1 < n; i1++) {
		s  = 0;
		for (i2 = 0; i2 <= p; i2++)
			s += E[i1][i2] * W_p[i2];
		if (s > 0)
			s = 1;
		else
			s = (s < 0) ? -1 : 0;
		for (i2 = 1; i2 <= p; i2++)
			fprintf(out, "%2ld", E[i1][i2]);
		fprintf(out, " Cor %2ld Res %2ld\n", C[i1], s);
	}

	if (n == num)
		printf("  IIׂĂ𕪗ށis񐔁F%ldj\n", n_tri);
	else
		printf("  II%ld 𕪗\n", num);
}

/********************************************/
/* Pocket Algorith with Ratcet              */
/*      num_p : ނP̐    */
/*      return : =0 : őwK          */
/*               >0  : ׂĂ𕪗ށi񐔁j */
/********************************************/
long Perceptron::Pocket(long *num_p)
{
	long count = 0, i1, k, num, run = 0, run_p = 0, s, sw = -1;
/*
     ݒ
*/
	*num_p = 0;

	for (i1 = 0; i1 <= p; i1++)
		W[i1] = 0;
/*
     s
*/
	while (sw < 0) {

		count++;
		if (count > max)
			sw = 0;

		else {
					// P̑I
			k = (long)(genrand_real3() * n);
			if (k >= n)
				k = n - 1;
					// o͂̌vZ
			s = 0;
			for (i1 = 0; i1 <= p; i1++)
				s += W[i1] * E[k][i1];
					// 
			if ((s > 0 && C[k] > 0) || (s < 0 && C[k] < 0)) {
				run++;
				if (run > run_p) {
					num = Bunrui();
					if (num > *num_p) {
						*num_p = num;
						run_p  = run;
						for (i1 = 0; i1 <= p; i1++)
							W_p[i1] = W[i1];
						if (num == n)
							sw = count;
					}
				}
			}
					// 
			else {
				run = 0;
				for (i1 = 0; i1 <= p; i1++)
					W[i1] += C[k] * E[k][i1];
			}
		}
	}

	return sw;
}

/****************/
/* main program */
/****************/
int main(int argc, char *argv[])
{
	long max, n, p;
	unsigned long seed = (unsigned)time(NULL);
	char name[100];
	FILE *st;

	if (argc > 1) {
					// {f[^̓
		st = fopen(argv[1], "r");
		fscanf(st, "%*s %ld %*s %ld %*s %ld",
               &max, &p, &n);
		fscanf(st, "%*s %s", name);
		fclose(st);
					// lbg[N̒`
		Perceptron net(max, n, p, seed);
		net.Input(name);
					// wKƌʂ̏o
		if (argc == 2)
			net.Learn(0);
		else
			net.Learn(1, argv[2]);
	}

	else {
		printf("***error   ̓f[^t@Cw肵ĉ\n");
		exit(1);
	}

	return 0;
}

/*
---------------------̓t@C------------
ő厎s 100 ̓Z̐ 2 P̐ 4
̓f[^t@C or.dat

---------------------or.dat--------------
ORŽPDŌ̃f[^ڕWo͒l
-1 -1 -1
-1  1  1
 1 -1  1
 1  1  1

//---------------------MT.h---------------------------
//   A C-program for MT19937, with initialization improved 2002/1/26.
//   Coded by Takuji Nishimura and Makoto Matsumoto.
//
//   Before using, initialize the state by using init_genrand(seed)  
//   or init_by_array(init_key, key_length).
//
//   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
//   All rights reserved.                          
//
//   Redistribution and use in source and binary forms, with or without
//   modification, are permitted provided that the following conditions
//   are met:
//
//     1. Redistributions of source code must retain the above copyright
//        notice, this list of conditions and the following disclaimer.
//
//     2. Redistributions in binary form must reproduce the above copyright
//        notice, this list of conditions and the following disclaimer in the
//        documentation and/or other materials provided with the distribution.
//
//     3. The names of its contributors may not be used to endorse or promote 
//        products derived from this software without specific prior written 
//        permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
//   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
//   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
//   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
//   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//
//   Any feedback is very welcome.
//   http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html
//   email: m-mat @ math.sci.hiroshima-u.ac.jp (remove space)


//   The original version of http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/MT2002/CODES/mt19937ar.c was modified by Takahiro Omi as
//   - delete line 47 "#include<stdio.h>"
//   - delete line 174 int main(void){...}
//   - change N -> MT_N
//   - change N -> MT_N
//   - change the file name "mt19937ar.c" -> "MT.h"


// Period parameters
#define MT_N 624
#define MT_M 397
#define MATRIX_A 0x9908b0dfUL   // constant vector a
#define UPPER_MASK 0x80000000UL // most significant w-r bits
#define LOWER_MASK 0x7fffffffUL // least significant r bits

static unsigned long mt[MT_N]; // the array for the state vector
static int mti=MT_N+1; // mti==MT_N+1 means mt[MT_N] is not initialized

// initializes mt[MT_N] with a seed
void init_genrand(unsigned long s)
{
    mt[0]= s & 0xffffffffUL;
    for (mti=1; mti<MT_N; mti++) {
        mt[mti] = 
	    (1812433253UL * (mt[mti-1] ^ (mt[mti-1] >> 30)) + mti); 
        // See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier.
        // In the previous versions, MSBs of the seed affect
        // only MSBs of the array mt[].
        // 2002/01/09 modified by Makoto Matsumoto
        mt[mti] &= 0xffffffffUL;
        // for >32 bit machines
    }
}

// initialize by an array with array-length
// init_key is the array for initializing keys
// key_length is its length
// slight change for C++, 2004/2/26
void init_by_array(unsigned long init_key[], int key_length)
{
    int i, j, k;
    init_genrand(19650218UL);
    i=1; j=0;
    k = (MT_N>key_length ? MT_N : key_length);
    for (; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1664525UL))
          + init_key[j] + j; // non linear
        mt[i] &= 0xffffffffUL; // for WORDSIZE > 32 machines
        i++; j++;
        if (i>=MT_N) { mt[0] = mt[MT_N-1]; i=1; }
        if (j>=key_length) j=0;
    }
    for (k=MT_N-1; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1566083941UL))
          - i; // non linear
        mt[i] &= 0xffffffffUL; // for WORDSIZE > 32 machines
        i++;
        if (i>=MT_N) { mt[0] = mt[MT_N-1]; i=1; }
    }

    mt[0] = 0x80000000UL; // MSB is 1; assuring non-zero initial array
}

// generates a random number on [0,0xffffffff]-interval
unsigned long genrand_int32(void)
{
    unsigned long y;
    static unsigned long mag01[2]={0x0UL, MATRIX_A};
    // mag01[x] = x * MATRIX_A  for x=0,1

    if (mti >= MT_N) { // generate N words at one time
        int kk;

        if (mti == MT_N+1)   // if init_genrand() has not been called,
            init_genrand(5489UL); // a default initial seed is used

        for (kk=0;kk<MT_N-MT_M;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+MT_M] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        for (;kk<MT_N-1;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+(MT_M-MT_N)] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        y = (mt[MT_N-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
        mt[MT_N-1] = mt[MT_M-1] ^ (y >> 1) ^ mag01[y & 0x1UL];

        mti = 0;
    }
  
    y = mt[mti++];

    // Tempering
    y ^= (y >> 11);
    y ^= (y << 7) & 0x9d2c5680UL;
    y ^= (y << 15) & 0xefc60000UL;
    y ^= (y >> 18);

    return y;
}

// generates a random number on [0,0x7fffffff]-interval
long genrand_int31(void)
{
    return (long)(genrand_int32()>>1);
}

// generates a random number on [0,1]-real-interval
double genrand_real1(void)
{
    return genrand_int32()*(1.0/4294967295.0); 
    // divided by 2^32-1
}

// generates a random number on [0,1)-real-interval
double genrand_real2(void)
{
    return genrand_int32()*(1.0/4294967296.0); 
    // divided by 2^32
}

// generates a random number on (0,1)-real-interval
double genrand_real3(void)
{
    return (((double)genrand_int32()) + 0.5)*(1.0/4294967296.0); 
    // divided by 2^32
}

// generates a random number on [0,1) with 53-bit resolution
double genrand_res53(void) 
{ 
    unsigned long a=genrand_int32()>>5, b=genrand_int32()>>6; 
    return(a*67108864.0+b)*(1.0/9007199254740992.0); 
} 
// These real versions are due to Isaku Wada, 2002/01/09 added
*/
