/************************************/
/* 㐔̉ixAXgE@j   */
/*      F(x+1)(x-2)(x-3)(x2+x+1) */
/*           =x5-3x4-2x3+3x2+7x+6=0 */
/*      coded by Y.Suganuma         */
/************************************/
using System;

class Program
{
	static void Main()
	{
		Test1 ts = new Test1();
	}
}

class Test1
{
	public Test1()
	{
					// f[^̐ݒ
		int ct      = 1000;
		int n       = 5;
		double eps  = 1.0e-10;
		double p0   = 0.0;
		double q0   = 0.0;
		double[] a  = {1.0, -3.0, -2.0, 3.0, 7.0, 6.0};
		double[] b  = new double [n+1];
		double[] c  = new double [n+1];
		double[] rl = new double [n];
		double[] im = new double [n];

					// vZ
		int ind = Bairstow(n, ct, eps, p0, q0, a, b, c, rl, im, 0);
					// o
		if (ind > 0)
			Console.WriteLine("܂łI");
		else {
			for (int i1 = 0; i1 < n; i1++)
				Console.WriteLine("   " + rl[i1] + "  i " + im[i1]);
		}
	}

	/*************************************************/
	/* W㐔̉ixAXgE@j          */
	/*      n :                                  */
	/*      ct : őJԂ                    */
	/*      eps :                        */
	/*      p0, q0 : x2+px+qɂp,q̏l      */
	/*      a : Wiō^Cl͕ωj */
	/*      b,c : ƈi(n+1)̔zj            */
	/*      rl, im : ʂ̎Ƌ                */
	/*      p : ̈ʒu                           */
	/*      return : =0 :                        */
	/*               =1 :                    */
	/*      coded by Y.Suganuma                      */
	/*************************************************/
	static int Bairstow(int n, int ct, double eps, double p0, double q0, double[] a,
	                    double[] b, double[] c, double[] rl, double[] im, int p)
	{
		int ind = 0;
	/*
	          P̏ꍇ
	*/
		if (n == 1) {
			if (Math.Abs(a[0]) < eps)
				ind = 1;
			else {
				rl[p] = -a[1] / a[0];
				im[p] = 0.0;
			}
		}
	/*
	          Q̏ꍇ
	*/
		else if (n == 2) {
			double D;
						// P
			if (Math.Abs(a[0]) < eps) {
				if (Math.Abs(a[1]) < eps)
					ind = 1;
				else {
					rl[p] = -a[2] / a[1];
					im[p] = 0.0;
				}
			}
						// Q
			else {
				D = a[1] * a[1] - 4.0 * a[0] * a[2];
				if (D < 0.0) {   // 
					D        = Math.Sqrt(-D);
					a[0]    *= 2.0;
					rl[p]    = -a[1] / a[0];
					rl[p+1]  = -a[1] / a[0];
					im[p]    = D / a[0];
					im[p+1]  = -im[p];
				}
				else {           // 
					D        = Math.Sqrt(D);
					a[0]     = 1.0 / (2.0 * a[0]);
					rl[p]    = a[0] * (-a[1] + D);
					rl[p+1]  = a[0] * (-a[1] - D);
					im[p]    = 0.0;
					im[p+1]  = 0.0;
				}
			}
		}
						// Rȏ̏ꍇ
		else {
							// 
			ind = 1;
			int count = 0;
			double D, dp, dq, p1 = p0, p2 = 0.0, q1 = q0, q2 = 0.0;
			while (ind > 0 && count <= ct) {
				for (int i1 = 0; i1 <= n; i1++) {
					if (i1 == 0)
						b[i1] = a[i1];
					else if (i1 == 1)
						b[i1] = a[i1] - p1 * b[i1-1];
					else
						b[i1] = a[i1] - p1 * b[i1-1] - q1 * b[i1-2];
				}
				for (int i1 = 0; i1 <= n; i1++) {
					if (i1 == 0)
						c[i1] = b[i1];
					else if (i1 == 1)
						c[i1] = b[i1] - p1 * c[i1-1];
					else
						c[i1] = b[i1] - p1 * c[i1-1] - q1 * c[i1-2];
				}
				D = c[n-2] * c[n-2] - c[n-3] * (c[n-1] - b[n-1]);
				if (Math.Abs(D) < eps)
					return ind;
				else {
					dp = (b[n-1] * c[n-2] - b[n] * c[n-3]) / D;
					dq = (b[n] * c[n-2] - b[n-1] * (c[n-1] - b[n-1])) / D;
					p2 = p1 + dp;
					q2 = q1 + dq;
					if (Math.Abs(dp) < eps && Math.Abs(dq) < eps)
						ind = 0;
					else {
						count++;
						p1 = p2;
						q1 = q2;
					}
				}
			}
	
			if (ind == 0) {
							// Q
				D = p2 * p2 - 4.0 * q2;
				if (D < 0.0) {   // 
					D        = Math.Sqrt(-D);
					rl[p]    = -0.5 * p2;
					rl[p+1]  = -0.5 * p2;
					im[p]    = 0.5 * D;
					im[p+1]  = -im[p];
				}
				else {           // 
					D        = Math.Sqrt(D);
					rl[p]    = 0.5 * (-p2 + D);
					rl[p+1]  = 0.5 * (-p2 - D);
					im[p]    = 0.0;
					im[p+1]  = 0.0;
				}
							// c̕
				n -= 2;
				for (int i1 = 0; i1 <= n; i1++)
					a[i1] = b[i1];
				ind = Bairstow(n, ct, eps, p0, q0, a, b, c, rl, im, p+2);
			}
		}
	
		return ind;
	}
}
