/****************************/
/* j[g@             */
/* iexp(x)-3.0*x=0̍j   */
/*      coded by Y.Suganuma */
/****************************/
#include <stdio.h>

double newton(double(*)(double), double(*)(double), double, double,
              double, int, int *);
double snx(double);
double dsnx(double);

int main()
{
	double eps1, eps2, x, x0;
	int max, ind;

	eps1 = 1.0e-7;
	eps2 = 1.0e-10;
	max  = 20;
	x0   = 0.0;

	x = newton(snx, dsnx, x0, eps1, eps2, max, &ind);

	printf("ind=%d  x=%f  f=%f  df=%f\n", ind, x, snx(x), dsnx(x));

	return 0;
}

/*****************************************************/
/* Newton@ɂ`(f(x)=0)̉            */
/*      f : f(x)vZ֐                     */
/*      df : f(x)̔vZ֐              */
/*      x0 : l                                  */
/*      eps1 : IPibx(k+1)-x(k)beps1j   */
/*      eps2 : IQibf(x(k))beps2j       */
/*      max : ő厎s                           */
/*      ind : ۂ̎s                         */
/*            i͉̎𓾂邱ƂłȂj */
/*      return :                                   */
/*****************************************************/
#include <math.h>

double newton(double(*f)(double), double(*df)(double), double x0,
              double eps1, double eps2, int max, int *ind)
{
	double g, dg, x, x1;
	int sw;

	x1   = x0;
	x    = x1;
	*ind = 0;
	sw   = 0;

	while (sw == 0 && *ind >= 0) {

		sw    = 1;
		*ind += 1;
		g     = (*f)(x1);

		if (fabs(g) > eps2) {
			if (*ind <= max) {
				dg = (*df)(x1);
				if (fabs(dg) > eps2) {
					x = x1 - g / dg;
					if (fabs(x-x1) > eps1 && fabs(x-x1) > eps1*fabs(x)) {
						x1 = x;
						sw = 0;
					}
				}
				else
					*ind = -1;
			}
			else
				*ind = -1;
		}
	}

	return x;
}

/************************/
/* ֐lif(x)ǰvZ */
/************************/
double snx(double x)
{
	double y;
	y = exp(x) - 3.0 * x;
	return y;
}

/********************/
/* ֐̔̌vZ */
/********************/
double dsnx(double x)
{
	double y;
	y = exp(x) - 3.0;
	return y;
}
