/***************************************/
/* j[g@                  */
/* iR_(0.5,1.0),(0.0,1.5),(0.5,2.0) */
/*   ʂ~̒SƔaj            */
/*      coded by Y.Suganuma            */
/***************************************/
using System;

class Program
{
	static void Main()
	{
		Test1 ts = new Test1();
	}
}

class Test1
{
	public Test1()
	{
		double[] x   = new double [3];
		double[] x0  = {0.0, 0.0, 2.0};
		double[][] w = new double [3][];
		w[0] = new double [6];
		w[1] = new double [6];
		w[2] = new double [6];
		double eps1 = 1.0e-7;
		double eps2 = 1.0e-10;
		int max     = 20;

		int ind = newton_m(x0, eps1, eps2, max, w, 3, x, snx, dsnx);

		Console.WriteLine("ind = " + ind);
		Console.Write("x");
		for (int i1 = 0; i1 < 3; i1++)
			Console.Write(" " + x[i1]);
		Console.WriteLine();
		Console.Write("f(x)");
		snx(x, x0);
		for (int i1 = 0; i1 < 3; i1++)
			Console.Write(" " + x0[i1]);
		Console.WriteLine();
	}
					// ֐lif(x)ǰvZ
	int snx(double[] x, double[] y)
	{
		y[0] = (0.5 - x[0]) * (0.5 - x[0]) + (1.0 - x[1]) * (1.0 - x[1]) - x[2] * x[2];
		y[1] = (0.0 - x[0]) * (0.0 - x[0]) + (1.5 - x[1]) * (1.5 - x[1]) - x[2] * x[2];
		y[2] = (0.5 - x[0]) * (0.5 - x[0]) + (2.0 - x[1]) * (2.0 - x[1]) - x[2] * x[2];
		return 0;
	}
					// ֐̔̌vZ
	int dsnx(double[] x, double[][] w, double eps)
	{
		for (int i1 = 0; i1 < 3; i1++) {
			for (int i2 = 0; i2 < 3; i2++)
				w[i1][i2+3] = 0.0;
			w[i1][i1+3] = 1.0;
		}

		w[0][0] = -2.0 * (0.5 - x[0]);
		w[0][1] = -2.0 * (1.0 - x[1]);
		w[0][2] = -2.0 * x[2];
		w[1][0] = -2.0 * (0.0 - x[0]);
		w[1][1] = -2.0 * (1.5 - x[1]);
		w[1][2] = -2.0 * x[2];
		w[2][0] = -2.0 * (0.5 - x[0]);
		w[2][1] = -2.0 * (2.0 - x[1]);
		w[2][2] = -2.0 * x[2];

		int ind = gauss(w, 3, 3, eps);

		return ind;
	}

	/*****************************************************/
	/* Newton@ɂ鑽`(f(x)=0)̉      */
	/*      x1 : l                                  */
	/*      eps1 : IPibx(k+1)-x(k)beps1j   */
	/*      eps2 : IQibf(x(k))beps2j       */
	/*      max : ő厎s                           */
	/*      kn1 : ֐vZNXIuWFNg       */
	/*      kn2 : ֐̔vZNXIuWFNg */
	/*      w : f(x)̔̋ts (n x 2n)      */
	/*      n : x̎                                  */
	/*      x :                                        */
	/*      return : ۂ̎s                      */
	/*            i͉̎𓾂邱ƂłȂj */
	/*****************************************************/
	int newton_m(double[] x0, double eps1, double eps2, int max,
	             double[][] w, int n, double[] x,
	             Func<double[], double[], int> fn,
	             Func<double[], double[][], double, int> dfn)
	{
		double[] g  = new double [n];
		double[] x1 = new double [n];
		for (int i1 = 0; i1 < n; i1++) {
			x1[i1] = x0[i1];
			x[i1]  = x1[i1];
		}
		int ind = 0;
		int sw  = 0;

		while (sw == 0 && ind >= 0) {

			sw = 1;
			ind++;
			fn(x1, g);

			int sw1 = 0;
			for (int i1 = 0; i1 < n && sw1 == 0; i1++) {
				if (Math.Abs(g[i1]) > eps2)
					sw1 = 1;
			}
			if (sw1 > 0) {
				if (ind <= max) {
					sw1 = dfn(x1, w, eps2);
					if (sw1 == 0) {
						for (int i1 = 0; i1 < n; i1++) {
							x[i1] = x1[i1];
							for (int i2 = 0; i2 < n; i2++)
								x[i1] -= w[i1][i2+n] * g[i2];
						}
						sw1 = 0;
						for (int i1 = 0; i1 < n && sw1 == 0; i1++) {
							if (Math.Abs(x[i1]-x1[i1]) > eps1 &&
                                Math.Abs(x[i1]-x1[i1]) > eps1*Math.Abs(x[i1]))
								sw1 = 1;
						}
						if (sw1 > 0) {
							for (int i1 = 0; i1 < n; i1++)
								x1[i1] = x[i1];
							sw = 0;
						}
					}
					else
						ind = -1;
				}
				else
					ind = -1;
			}
		}

		return ind;
	}

	/*******************************************************/
	/* `Aits߂j              */
	/*      w : ̍ӋyщE                       */
	/*      n : ̐                                 */
	/*      m : ̉Eӂ̗̐                       */
	/*      eps : ts݂̑𔻒肷K               */
	/*      return : =0 :                              */
	/*               =1 : ts񂪑݂Ȃ               */
	/*******************************************************/
	int gauss(double[][] w, int n, int m, double eps)
	{
		int ind = 0;
		int nm  = n + m;

		for (int i1 = 0; i1 < n && ind == 0; i1++) {

			double y1 = .0;
			int m1    = i1 + 1;
			int m2    = 0;
						// s{bgvf̑I
			for (int i2 = i1; i2 < n; i2++) {
				double y2 = Math.Abs(w[i2][i1]);
				if (y1 < y2) {
					y1 = y2;
					m2 = i2;
				}
			}
						// ts񂪑݂Ȃ
			if (y1 < eps)
				ind = 1;
						// ts񂪑݂
			else {
							// s̓ւ
				for (int i2 = i1; i2 < nm; i2++) {
					y1        = w[i1][i2];
					w[i1][i2] = w[m2][i2];
					w[m2][i2] = y1;
				}
							// |o
				y1 = 1.0 / w[i1][i1];

				for (int i2 = m1; i2 < nm; i2++)
					w[i1][i2] *= y1;

				for (int i2 = 0; i2 < n; i2++) {
					if (i2 != i1) {
						for (int i3 = m1; i3 < nm; i3++)
							w[i2][i3] -= w[i2][i1] * w[i1][i3];
					}
				}
			}
		}

		return ind;
	}
}
