/********************************/
/* Ԗ@iRXvC֐j */
/*      coded by Y.Suganuma     */
/********************************/
#include <stdio.h>

double spline(int, double *, double *, double,
              double *, double *, double *, double *, double *, double *);

int main()
{
	double *h, *b, *d, *g, *u, *r, *x, *y, sp, x1, y1;
	int n;
					// ݒ
	n = 5;
	h = new double [n];
	b = new double [n];
	d = new double [n];
	g = new double [n];
	u = new double [n];
	r = new double [n+1];
	x = new double [n+1];
	y = new double [n+1];

	x[0] = 0.0;
	x[1] = 1.0;
	x[2] = 2.0;
	x[3] = 3.0;
	x[4] = 4.0;
	x[5] = 5.0;
	y[0] = 0.0;
	y[1] = 1.0;
	y[2] = 4.0;
	y[3] = 9.0;
	y[4] = 16.0;
	y[5] = 25.0;
					// sƏo
	x1 = 0.0;
	sp = 0.1;
	while (x1 <= 5.01) {
		y1 = spline(n, x, y, x1, h, b, d, g, u, r);
		printf("%f %f\n", x1, y1);
		x1 += sp;
	}

	delete [] h;
	delete [] b;
	delete [] d;
	delete [] g;
	delete [] u;
	delete [] r;
	delete [] x;
	delete [] y;

	return 0;
}

/**********************************/
/* RXvC֐ɂ   */
/*      n : Ԃ̐              */
/*      x, y : _̍W           */
/*      x1 : Ԓl߂l     */
/*      h, b, d, g, u, r : ƈ */
/*      return : Ԓl           */
/*      coded by Y.Suganuma       */
/**********************************/
double spline(int n, double *x, double *y, double x1,
              double *h, double *b, double *d, double *g, double *u, double *r)
{
	int i = -1, i1, k;
	double y1, qi, si, xx;
					// Ԃ̌
	for (i1 = 1; i1 < n && i < 0; i1++) {
		if (x1 < x[i1])
			i = i1 - 1;
	}
	if (i < 0)
		i = n - 1;
					// XebvP
	for (i1 = 0; i1 < n; i1++)
		h[i1] = x[i1+1] - x[i1];
	for (i1 = 1; i1 < n; i1++) {
		b[i1] = 2.0 * (h[i1] + h[i1-1]);
		d[i1] = 3.0 * ((y[i1+1] - y[i1]) / h[i1] - (y[i1] - y[i1-1]) / h[i1-1]);
	}
					// XebvQ
	g[1] = h[1] / b[1];
	for (i1 = 2; i1 < n-1; i1++)
		g[i1] = h[i1] / (b[i1] - h[i1-1] * g[i1-1]);
	u[1] = d[1] / b[1];
	for (i1 = 2; i1 < n; i1++)
		u[i1] = (d[i1] - h[i1-1] * u[i1-1]) / (b[i1] - h[i1-1] * g[i1-1]);
					// XebvR
	k      = (i > 1) ? i : 1;
	r[0]   = 0.0;
	r[n]   = 0.0;
	r[n-1] = u[n-1];
	for (i1 = n-2; i1 >= k; i1--)
		r[i1] = u[i1] - g[i1] * r[i1+1];
					// XebvS
	xx = x1 - x[i];
	qi = (y[i+1] - y[i]) / h[i] - h[i] * (r[i+1] + 2.0 * r[i]) / 3.0;
	si = (r[i+1] - r[i]) / (3.0 * h[i]);
	y1 = y[i] + xx * (qi + xx * (r[i]  + si * xx));

	return y1;
}
