/********************************/
/* Ԗ@iRXvC֐j */
/*      coded by Y.Suganuma     */
/********************************/
#include <stdio.h>

/****************/
/* NX̒` */
/****************/
class Spline
{
		double *r, *q, *s, *x, *y;
		int n;

	public:

		/**************************/
		/* RXgN^         */
		/*      n1 : Ԃ̐     */
		/*      x1, y1 : _̍W */
		/**************************/
		Spline(int n1, double *x1, double *y1)
		{
			int i1;
						// ̈̊m
			n = n1;

			double *h = new double [n];
			double *b = new double [n];
			double *d = new double [n];
			double *g = new double [n];
			double *u = new double [n];
			q = new double [n];
			s = new double [n];
			r = new double [n+1];
			x = new double [n+1];
			y = new double [n+1];

			for (i1 = 0; i1 <= n; i1++) {
				x[i1] = x1[i1];
				y[i1] = y1[i1];
			}
						// XebvP
			for (i1 = 0; i1 < n; i1++)
				h[i1] = x[i1+1] - x[i1];
			for (i1 = 1; i1 < n; i1++) {
				b[i1] = 2.0 * (h[i1] + h[i1-1]);
				d[i1] = 3.0 * ((y[i1+1] - y[i1]) / h[i1] - (y[i1] - y[i1-1]) / h[i1-1]);
			}
						// XebvQ
			g[1] = h[1] / b[1];
			for (i1 = 2; i1 < n-1; i1++)
				g[i1] = h[i1] / (b[i1] - h[i1-1] * g[i1-1]);
			u[1] = d[1] / b[1];
			for (i1 = 2; i1 < n; i1++)
				u[i1] = (d[i1] - h[i1-1] * u[i1-1]) / (b[i1] - h[i1-1] * g[i1-1]);
						// XebvR
			r[0]   = 0.0;
			r[n]   = 0.0;
			r[n-1] = u[n-1];
			for (i1 = n-2; i1 >= 1; i1--)
				r[i1] = u[i1] - g[i1] * r[i1+1];
						// XebvS
			for (i1 = 0; i1 < n; i1++) {
				q[i1] = (y[i1+1] - y[i1]) / h[i1] - h[i1] * (r[i1+1] + 2.0 * r[i1]) / 3.0;
				s[i1] = (r[i1+1] - r[i1]) / (3.0 * h[i1]);
			}

			delete [] h;
			delete [] b;
			delete [] d;
			delete [] g;
			delete [] u;
		}

		/****************/
		/* fXgN^ */
		/****************/
		~Spline()
		{
			delete [] q;
			delete [] s;
			delete [] r;
			delete [] x;
			delete [] y;
		}

		/******************************/
		/* ԒľvZ               */
		/*      x1 : Ԓl߂l */
		/*      return : Ԓl       */
		/******************************/
		double value(double x1)
		{
			int i = -1, i1;
			double y1, xx;
						// Ԃ̌
			for (i1 = 1; i1 < n && i < 0; i1++) {
				if (x1 < x[i1])
					i = i1 - 1;
			}
			if (i < 0)
				i = n - 1;
						// vZ
			xx = x1 - x[i];
			y1 = y[i] + xx * (q[i] + xx * (r[i]  + s[i] * xx));

			return y1;
		}
};

/*************/
/* main ֐ */
/*************/
int main()
{
	double *x, *y, sp, x1, y1;
	int n;
					// ݒ
	n = 5;
	x = new double [n+1];
	y = new double [n+1];

	x[0] = 0.0;
	x[1] = 1.0;
	x[2] = 2.0;
	x[3] = 3.0;
	x[4] = 4.0;
	x[5] = 5.0;
	y[0] = 0.0;
	y[1] = 1.0;
	y[2] = 4.0;
	y[3] = 9.0;
	y[4] = 16.0;
	y[5] = 25.0;

	Spline spline(n, x, y);
					// sƏo
	x1 = 0.0;
	sp = 0.1;
	while (x1 <= 5.01) {
		y1 = spline.value(x1);
		printf("%f %f\n", x1, y1);
		x1 += sp;
	}

	delete [] x;
	delete [] y;

	return 0;
}
