/********************************************************************/
/* f(x) = sin(3.0*x) + 0.5 * sin(9.0*x) + sin(15.0*x + 50) ̍ől */
/*      coded by Y.Suganuma                                         */
/********************************************************************/

/***********************/
/* NXSpecies̒` */
/***********************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "MT.h"

class Species {

	protected:

		double max;   // őKx
		double mean;   // ϓKx
		double *pi;   // Kx
		double *ro;   // [bg
		int allele_u;   // Η`q
		int allele_l;   // Η`q
		int size;   // ̑
		int max_ch;   // q̐̍ől
		int max_len;   // ő`q
		int min_len;   // ŏ`qi̎́Cő`qŌŒj
		int max_n;   // őKx̌̔ԍ
		int dup_a;   // `q̏d
                     //   =0 : dȂ
                     //   =1 : d
		int dup_s;   // ̂̏diF̂̌́j
                     //   =0 : dȂ
                     //   =1 : d
		int **ind;   // Wci̂̏W܂j
		int *len;   // e̂̈`q
		int *kou1;   // EˑRψٗpƏꏊP
		int *kou2;   // EˑRψٗpƏꏊQ
		int *s_w;   // pwWiIꂽ񐔁j
		int **edge;   // GbWgݑւp[NGA
		char *pi_w;   // KxvZwW
                     //   =0 : gp
                     //   =1 : KxvZOiˑRψق͂̌̂ɓKpj
                     //   =2 : KxvZς݁iɐeƂ݂Ȃj

		int Position(int);
		int Select(int method=-1, double bias=0.0, double step=1.0);

	public:
					// RXgN^
		Species(char *, long);
					// fXgN^
		~Species();
					// WIȏݒ
		void Init_std();
					// WIȏo
		void Out_std(int, int, int, char *);
					// 
						// ẽRs[
		void C_copy(int method=2, int pair=0, int k_method=-1,
                    double k_bias=0.0, double k_step=1.0);
						// _
		void C_point(double, int k_point=1, int k_vr=0, int k_method=-1,
                     double k_bias=0.0, double k_step=1.0);
						// l
		void C_uniform(double, int k_method=-1, double k_bias=0.0,
                       double k_step=1.0);
						// ω
		void C_mean(double, int k_method=-1, double k_bias=0.0,
                    double k_step=1.0);
						// z
		void C_cycle(double, int k_method=-1, double k_bias=0.0,
                     double k_step=1.0);
						// I
		void C_part(double, int k_method=-1, double k_bias=0.0,
                    double k_step=1.0);
						// 
		void C_seq(double, int k_method=-1, double k_bias=0.0,
                   double k_step=1.0);
						// l
		void C_useq(double, int k_method=-1, double k_bias=0.0,
                    double k_step=1.0);
						// lʒu
		void C_upos(double, int k_method=-1, double k_bias=0.0,
                    double k_step=1.0);
						// GbWgݑւ
		void C_edge(double, int k_method=-1, double k_bias=0.0,
                    double k_step=1.0);
						// TucA[
		void C_sub(double, int count=10);
					// ˑRψ
						// Η`qւ̒u
		void M_alle(double);
						// ړ
		void M_move(double);
						// t
		void M_inv(double, int wd=0);
						// XNu
		void M_scram(double pr, int wd=0);
						// ]
		void M_chg(double pr, int wd=0);
						// d
		void M_dup(double pr, int wd=0);
						// ۓ
		void M_per(double pr, int method=0, double m=0.0, double s=1.0);
						// }
		void M_ins(double pr, int wd=0);
						// 폜
		void M_del(double pr, int wd=0);
                    // G[gE[bgI
		void S_roul(int elite=0, int s_method=1, double s_bias=0.0,
                    double s_step=1.0);
};

double norm_d(double, double);

/****************************/
/* RXgN^           */
/*      name : t@C   */
/*      seed : ̏l */
/****************************/
Species::Species(char *name, long seed)
{
	int i1, kind, num;
	FILE *in;
/*
     f[^̓
*/
	in = fopen(name, "r");

	fscanf(in,"%*s %d %*s %d", &allele_u, &allele_l);
	fscanf(in,"%*s %d %*s %d", &max_len, &min_len);
	fscanf(in,"%*s %d %*s %d", &dup_a, &dup_s);
	fscanf(in,"%*s %d %*s %d", &size, &max_ch);
/*
     f[^̃`FbN
*/
	if (size <= 0) {
		printf("***error  ̑O (Constructor)\n");
		exit(1);
	}

	if (max_ch < 0) {
		printf("***error  q̐O (Constructor)\n");
		exit(1);
	}

	if (max_len <= 0 || min_len == 0) {
		printf("***error  `qO (Constructor)\n");
		exit(1);
	}

	if (max_len < min_len) {
		printf("***error  ő`qŏ`q (Constructor)\n");
		exit(1);
	}

	if (allele_u <= allele_l) {
		printf("***error  Η`qΗ`q (Constructor)\n");
		exit(1);
	}

	kind = allele_u - allele_l + 1;
	if (dup_a == 0 && max_len > kind) {
		printf("***error  `q̏dhƂ͂łȂ (Constructor)\n");
		exit(1);
	}
/*
     ̈̊m
*/
	num = size + max_ch;

	ind = new int * [num];
	for (i1 = 0; i1 < num; i1++)
		ind[i1] = new int [max_len];

	edge = new int * [max_len];
	for (i1 = 0; i1 < max_len; i1++)
		edge[i1] = new int [5];

	pi   = new double [num];
	ro   = new double [num];
	len  = new int [num];
	kou1 = new int [max_len];
	kou2 = new int [max_len];
	s_w  = new int [num];
	pi_w = new char [num];
/*
     ̏ݒ
*/
	init_genrand(seed);
}

/****************/
/* fXgN^ */
/****************/
Species::~Species()
{
	int i1;

	for (i1 = 0; i1 < size+max_ch; i1++)
		delete [] ind[i1];
	delete [] ind;

	for (i1 = 0; i1 < max_len; i1++)
		delete [] edge[i1];
	delete [] edge;

	delete [] pi;
	delete [] len;
	delete [] kou1;
	delete [] kou2;
	delete [] pi_w;
	delete [] s_w;
	delete [] ro;
}

/**************************************************/
/* ꏊT                                     */
/*      n : >=0 : nԖڂ̐e{                 */
/*          -1 : 󂢂ĂꏊT             */
/*      return : ȅꏊC܂́C󂢂Ăꏊ */
/*               i݂ȂƂ͕̒lj       */
/**************************************************/
int Species::Position(int n)
{
	int i1, k = -1, sw = 0;
/*
     󂢂ĂꏊT
*/
	if (n < 0) {
		for (i1 = 0; i1 < size+max_ch && k < 0; i1++) {
			if (pi_w[i1] == 0)
				k = i1;
		}
		if (k < 0) {
			printf("***error  󂢂ĂꏊȂ --Position--\n");
			exit(1);
		}
	}
/*
     Ԗڂ̐eipi_w[i]=2j{
*/
	else {
		for (i1 = 0; i1 < size+max_ch && sw == 0; i1++) {
			if (pi_w[i1] == 2) {
				k++;
				if (k == n) {
					sw = 1;
					k  = i1;
				}
			}
		}
	}

	return k;
}

/*******************************************************************/
/* ̂̑I                                                      */
/*      method : I@                                          */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      bias : C܂́Cmethod=2̏ꍇ͏l(default=0)       */
/*      step : (default=1)                                       */
/*      return : ̔ԍ                                          */
/*******************************************************************/
int Species::Select(int method, double bias, double step)
{
	double sum = 0.0, x;
	int i1, k, min, n, sw;
					// [bg̗p
	switch (method) {
						// _
		case -1:
			n = 0;
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1)
					n++;
			}
			sum = 1.0 / n;
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1)
					ro[i1] = sum;
			}
			break;
						// ]l̂܂ܗp
		case 0:
			n = 0;
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1) {
					sum += pi[i1];
					n++;
				}
			}
			if (fabs(sum) > 1.0e-10) {
				sum = 1.0 / fabs(sum);
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1)
						ro[i1] = pi[i1] * sum;
				}
			}
			else {
				sum = 1.0 / n;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1)
						ro[i1] = sum;
				}
			}
			break;
						// ŏl̍
		case 1:
			min = -1;
			n   = 0;
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1) {
					n++;
					if (min < 0 || pi[i1] < pi[min])
						min = i1;
				}
			}
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1) {
					ro[i1] = pi[i1] - pi[min];
					if (ro[i1] < bias)
						ro[i1] = bias;
					sum += ro[i1];
				}
			}
			if (sum > 1.0e-10) {
				sum = 1.0 / sum;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1)
						ro[i1] *= sum;
				}
			}
			else {
				sum = 1.0 / n;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1)
						ro[i1] = sum;
				}
			}
			break;
						// `
		case 2:
			n = 0;
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1) {
					ro[i1] = -1.0;
					n++;
				}
				else
					ro[i1] = 1.0;
			}
			sw  = 0;
			sum = bias;
			while (sw == 0) {
				min = -1;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (ro[i1] < 0.0 && (min < 0 || pi[i1] < pi[min]))
						min = i1;
				}
				if (min < 0)
					sw = 1;
				else {
					ro[min]  = sum;
					sum     += step;
				}
			}
			sum = 1.0 / (0.5 * (2.0 * bias + step * (n - 1)) * n);
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1)
					ro[i1] *= sum;
			}
			break;
	}

	sum = 0.0;
	for (i1 = 0; i1 < size+max_ch; i1++) {
		if (pi_w[i1] > 1) {
			sum    += ro[i1];
			ro[i1]  = sum;
		}
	}
					// I
	x  = genrand_real3();
	sw = 0;
	k  = 0;
	for (i1 = 0; i1 < size+max_ch && sw == 0; i1++) {
		if (pi_w[i1] > 1) {
			if (x <= ro[i1]) {
				sw = 1;
				k  = i1;
			}
		}
	}

	return k;
}

/********************/
/* WIȏݒ */
/********************/
void Species::Init_std()
{
	int i1, i2, i3, length, lid, sw1, sw2;
/*
     ݒ
*/
	for (i1 = 0; i1 < size+max_ch; i1++) {
		if (i1 < size)
			pi_w[i1] = 1;   // Kx̌vZO
		else
			pi_w[i1] = 0;   // gp
	}
/*
     `q̌
*/
	for (i1 = 0; i1 < size; i1++) {

		sw1 = 0;

		while (sw1 == 0) {
					// `q̌
			if (min_len < 0)
				length = max_len;
			else {
				length = (int)(genrand_real3() * (max_len - min_len + 1) + min_len);
				if (length > max_len)
					length = max_len;
			}
			len[i1] = length;
					// `q̌
			for (i2 = 0; i2 < length; i2++) {
				sw2 = 0;
				while (sw2 == 0) {
					lid = (int)(genrand_real3() * (allele_u - allele_l + 1) + allele_l);
					if (lid > allele_u)
						lid = allele_u;
					ind[i1][i2] = lid;
						// d`q̃`FbN
					sw2 = 1;
					if (dup_a == 0) {
						for (i3 = 0; i3 < i2 && sw2 > 0; i3++) {
							if (lid == ind[i1][i3])
								sw2 = 0;
						}
					}
				}
			}
					// d̂̃`FbN
			sw1 = 1;
			if (dup_s == 0) {
				for (i2 = 0; i2 < i1 && sw1 > 0; i2++) {
					if (len[i1] == len[i2]) {
						sw2 = 0;
						for (i3 = 0; i3 < len[i1] && sw2 == 0; i3++) {
							if (ind[i1][i3] != ind[i2][i3])
								sw2 = 1;
						}
						if (sw2 == 0)
							sw1 = 0;
					}
				}
			}
		}
	}
}

/****************************************************/
/* WIȏo                                     */
/*      sw : o̓x                             */
/*             =0 : ŏIo͂                    */
/*             n>0 : 㖈ɏói̓t@Cj */
/*      out_m : o͕@                            */
/*                =0 : ׂĂ̌̂o           */
/*                =1 : őKx̌̂o   */
/*      gen : ݂̐ԍ                        */
/*      name : o̓t@C                       */
/****************************************************/
void Species::Out_std(int sw, int out_m, int gen, char *name)
{
	int i1, i2, k = 0, pr;
	char *now;
	time_t aclock;
	FILE *out;

	if (sw >= 0) {
		printf("   o͐́i0:o͂ȂCn:ʂɂÂC-1:t@CjH ");
		scanf("%d", &pr);
	}
	else
		pr = -1;

	if (pr != 0) {
					// o͐̌ƕ]l̏o
		if (pr > 0) {
			out = stdout;
			getchar();
		}
		else {
			time(&aclock);
			now = ctime(&aclock);
			out = fopen(name, "a");
			fprintf(out, "*** %d Kx max %f (%d) mean %f  %s\n",
                    gen, max, max_n, mean, now);
		}
					// ڍ׏o
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if ((pi_w[i1] > 1) && (out_m ==0 || out_m == 1 && i1 == max_n)) {
				fprintf(out, "%d allele", i1);
				for (i2 = 0; i2 < len[i1]; i2++)
					fprintf(out, " %d", ind[i1][i2]);
				fprintf(out, " value %f\n", pi[i1]);
				if (pr > 0) {
					k++;
					if (k == pr) {
						getchar();
						k = 0;
					}
				}
			}
		}

		if (pr < 0)
			fclose(out);
	}
}

/*******************************************************************/
/* iẽRs[j                                              */
/*      method : =2 : LiQ̐eQ̎qj(default)      */
/*               =1 : P̐eP̎q                       */
/*      pair : method=2 ̎͐ẽyA(default=max_ch/2)         */
/*             method=1 ̎͐e̐iq̐j                 */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_copy(int method, int pair, int k_method,
                     double k_bias, double k_step)
{
   int i1, i2, i3, k, p, p1, p2, sw;
/*
     ݒƃf[^`FbN
*/
	if (method != 1)
		method = 2;

	if (pair <= 0)
		pair = (method==2) ? max_ch/2 : max_ch;
	else {
		if (method == 2 && 2*pair > max_ch || method == 1 && pair > max_ch) {
			printf("***error  q (C_copy)\n");
			exit(1);
		}
	}
/*
     s
*/
	for (i1 = 0; i1 < pair; i1++) {
					// ȇI
		p1 = Select(k_method, k_bias, k_step);
		sw = 0;

		while (sw == 0) {
			p2 = Select(k_method, k_bias, k_step);
			if (p1 != p2)
				sw = 1;
		}
					// Rs[
		for (i2 = 0; i2 < method; i2++) {
			p       = (i2 == 0) ? p1 : p2;
			k       = Position(-1);
			len[k]  = len[p];
			pi_w[k] = 1;
			for (i3 = 0; i3 < len[k]; i3++)
				ind[k][i3] = ind[p][i3];
		}
	}
}

/*******************************************************************/
/* i_j                                                */
/*      kosa : m                                            */
/*      k_point : _̐(default=1)                            */
/*                i̎́C1-k_pointԂ̃_j          */
/*      k_vr : =0 : eƂʒuŌ(default)                */
/*             =1 : eقȂʒuŌi`q͉ρj       */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_point(double kosa, int k_point, int k_vr, int k_method,
                      double k_bias, double k_step)
{
	int abs_p, c1, c2, i1, i2, i3, k1, k2, mn = 0, num, p1, p2, pair,
        sw, t11, t12, t21, t22;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch / 2;

	if (dup_a == 0) {
		printf("***error  @sK (C_point)\n");
		exit(1);
	}

	abs_p = abs(k_point);
	if (abs_p == 0 || abs_p > max_len-1 || min_len > 0 && abs_p > min_len-1) {
		printf("***error  _̐sK (C_point)\n");
		exit(1);
	}

	if (k_vr > 0 && min_len < 0) {
		printf("***error  `q͉ςłȂ΂ȂȂ (C_point)\n");
		exit(1);
	}
/*
     
*/
	num = k_point;

	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(2, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// ʒu̐̌
			if (k_point < 0) {
				num = (int)(genrand_real3() * abs_p + 1);
				if (num > abs_p)
					num = abs_p;
			}
						// ʒǔi_̌Ōj
			for (i2 = 0; i2 < num; i2++) {
							// eP̌ʒu
				sw = 0;
				while (sw == 0) {
					sw       = 1;
					kou1[i2] = (int)(genrand_real3() * (len[p1] - 1));
					if (kou1[i2] > len[p1]-2)
						kou1[i2] = len[p1] - 2;
					if (k_vr == 0 && kou1[i2] > len[p2]-2)
						kou1[i2] = len[p2] - 2;
					for (i3 = 0; i3 < i2 && sw > 0; i3++) {
						if (kou1[i3] == kou1[i2])
							sw = 0;
					}
				}
							// eQ̌ʒu
				if (k_vr > 0) {
					sw = 0;
					while (sw == 0) {
						sw       = 1;
						kou2[i2] = (int)(genrand_real3() * (len[p2] - 1));
						if (kou2[i2] > len[p2]-2)
							kou2[i2] = len[p2] - 2;
						for (i3 = 0; i3 < i2 && sw > 0; i3++) {
							if (kou2[i3] == kou2[i2])
								sw = 0;
						}
					}
				}
			}
						// ̎s
						//   ePt11t12qPc1փRs[
						//   eQt21t22qQc2փRs[
						//     ́C
						//   ePt11t12qQc2փRs[
						//   eQt21t22qPc1փRs[
						//     EEEEE
			c1  = 0;
			c2  = 0;
			t11 = 0;
			t21 = 0;
							// `q
			k1       = Position(-1);
			pi_w[k1] = 1;
			len[k1]  = len[p1];
			k2       = Position(-1);
			pi_w[k2] = 1;
			len[k2]  = len[p2];

			for (i2 = 0; i2 < num+1; i2++ ) {
							// ̌ʒu߂
				if (i2 == num) {            // Ō
					t12 = len[p1];
					t22 = len[p2];
				}
				else {
								// eP
					t12 = max_len;
					for (i3 = 0; i3 < num; i3++) {
						if (kou1[i3] >= 0 && kou1[i3] <= t12) {
							t12 = kou1[i3];
							mn  = i3;
						}
					}
					kou1[mn] = -1;
					t12++;
								// eQ
					if (k_vr == 0)
						t22 = t12;
					else {
						t22 = max_len;
						for (i3 = 0; i3 < num; i3++) {
							if (kou2[i3] >= 0 && kou2[i3] <= t22) {
								t22 = kou2[i3];
								mn  = i3;
							}
						}
						kou2[mn] = -1;
						t22++;
					}
				}
							// wӏ̃Rs[
				for (i3 = t11; i3 < t12; i3++) {
					if (i2%2 == 0) {
						if (c1 < max_len) {
							ind[k1][c1] = ind[p1][i3];
							c1++;
						}
					}
					else {
						if (c2 < max_len) {
							ind[k2][c2] = ind[p1][i3];
							c2++;
						}
					}
				}

				for (i3 = t21; i3 < t22; i3++) {
					if (i2%2 == 0) {
						if (c2 < max_len) {
							ind[k2][c2] = ind[p2][i3];
							c2++;
						}
					}
					else {
						if (c1 < max_len) {
							ind[k1][c1] = ind[p2][i3];
							c1++;
						}
					}
				}
							// ʒüړ
				t11 = t12;
				t21 = t22;
			}
		}
	}
}

/*******************************************************************/
/* ilD[0,1]𓙊mŔC1ł΁C            */
/*       ePC0łΐeQ̈`qqP󂯌pj             */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_uniform(double kosa, int k_method, double k_bias,
                        double k_step)
{
	int i1, i2, k1, k2, p1, p2, pair, sw;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch / 2;

	if (dup_a == 0) {
		printf("***error  @sK (C_uniform)\n");
		exit(1);
	}

	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_uniform)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(2, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// `q
			k1       = Position(-1);
			pi_w[k1] = 1;
			len[k1]  = len[p1];
			k2       = Position(-1);
			pi_w[k2] = 1;
			len[k2]  = len[p2];
						// 
			for (i2 = 0; i2 < len[p1]; i2++) {
				if (genrand_real3() > 0.5) {
					ind[k1][i2] = ind[p1][i2];
					ind[k2][i2] = ind[p2][i2];
				}
				else {
					ind[k1][i2] = ind[p2][i2];
					ind[k2][i2] = ind[p1][i2];
				}
			}
		}
	}
}

/*******************************************************************/
/* iωDQ̐e̕ϒl󂯌pj                  */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_mean(double kosa, int k_method, double k_bias,
                     double k_step)
{
	int i1, i2, k, p1, p2, sw;
/*
     ݒƃf[^̃`FbN
*/
	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_mean)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < max_ch; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(1, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// `q
			k       = Position(-1);
			len[k]  = len[p1];
			pi_w[k] = 1;
						// 
			for (i2 = 0; i2 < len[k]; i2++)
				ind[k][i2] = (ind[p1][i2] + ind[p2][i2]) / 2;
		}
	}
}

/*******************************************************************/
/* izD_ɂP_IC̈ʒuɂ`q  */
/*       ̂܂܊eqID̈ʒuɂeQiPj̈`  */
/*       qC̈`q̐ePiQj̏ꏊɁCqPiQj󂯌p  */
/*       iCdoublȅꍇ́C̎葱̂jD̎  */
/*       CłɎ󂯌p`q̈ʒuI܂ŌJ  */
/*       ԂCc̈`qɂẮCqPiQj́CeQiPj  */
/*       `q̏ԒʂɎ󂯌pj                          */
/*         2 4 1 3 6 5    + + 1 + + 5    3 2 1 4 6 5               */
/*             *                                               */
/*         3 2 5 4 1 6    + + 5 + 1 +    2 4 5 3 1 6               */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_cycle(double kosa, int k_method, double k_bias,
                      double k_step)
{
   int i1, i2, i3, k1, k2, p, pair, p1, p2, sw;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch / 2;

	if (dup_a != 0) {
		printf("***error  @sK (C_cycle)\n");
		exit(1);
	}

	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_cycle)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(2, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// ݒ
			for (i2 = 0; i2 < len[p1]; i2++) {
				kou1[i2] = 0;
				kou2[i2] = 0;
			}
						// `q
			k1       = Position(-1);
			pi_w[k1] = 1;
			len[k1]  = len[p1];
			k2       = Position(-1);
			pi_w[k2] = 1;
			len[k2]  = len[p2];
						// 
			sw = 0;

			while (sw == 0) {
				sw = 1;
				p  = (int)(genrand_real3() * len[p1]);
				if (p >= len[p1])
					p = len[p1] - 1;
				if (kou1[p] == 0 && kou2[p] == 0) {
					kou1[p]    = 1;
					kou2[p]    = 1;
					ind[k1][p] = ind[p1][p];
					ind[k2][p] = ind[p2][p];
					for (i2 = 0; i2 < len[p1] && sw > 0; i2++) {
						if (ind[p2][p] == ind[p1][i2]) {
							ind[k1][i2] = ind[p1][i2];
							kou1[i2]    = 1;
							sw          = 0;
						}
					}
					sw = 1;
					for (i2 = 0; i2 < len[p2] && sw > 0; i2++) {
						if (ind[p1][p] == ind[p2][i2]) {
							ind[k2][i2] = ind[p2][i2];
							kou2[i2]    = 1;
							sw          = 0;
						}
					}
				}
			}

			sw = 0;
			i2 = 0;
			i3 = 0;
			while (sw == 0) {
				while (sw == 0 && i2 < len[p1]) {
					if (kou1[i2] == 0)
						sw = 1;
					else
						i2++;
				}
				sw = 0;
				while (sw == 0 && i3 < len[p2]) {
					if (kou2[i3] == 0)
						sw = 1;
					else
						i3++;
				}
				if (i2 < len[p1] && i3 < len[p2]) {
					ind[k1][i2] = ind[p2][i3];
					ind[k2][i3] = ind[p1][i2];
					sw          = 0;
					i2++;
					i3++;
				}
				else
					sw = 1;
			}
		}
	}
}

/*******************************************************************/
/* iID_ɂP_IC̈ʒuɂeP  */
/*       eQ̈`qoDɁCePƐeQ̐F̏ŁC  */
/*       ̂Q̈`q̈ʒuD̑CI_  */
/*       Eɂ邷ׂĂ̈`qɑ΂Ď{                  */
/*         2 4 1 3 6 5    2 4 5 3 6 1                              */
/*             *                                          */
/*         3 2 5 4 1 6    3 2 1 4 5 6                              */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_part(double kosa, int k_method, double k_bias,
                     double k_step)
{
	int i1, i2, i3, k1, k2, lv, p, pair, p1, p2, sw;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch / 2;

	if (dup_a != 0) {
		printf("***error  @sK (C_part)\n");
		exit(1);
	}

	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_part)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(2, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// `q
			k1       = Position(-1);
			pi_w[k1] = 1;
			len[k1]  = len[p1];
			k2       = Position(-1);
			pi_w[k2] = 1;
			len[k2]  = len[p2];
						// 
			p = (int)(genrand_real3() * len[p1]);
			if (p >= len[p1])
				p = len[p1] - 1;

			for (i2 = 0; i2 < len[p1]; i2++) {
				ind[k1][i2] = ind[p1][i2];
				ind[k2][i2] = ind[p2][i2];
			}

			for (i2 = p; i2 < len[p1]; i2++) {
				sw = 0;
				lv = ind[k1][i2];
				for (i3 = 0; i3 < len[p1] && sw == 0; i3++) {
					if (ind[k2][i2] == ind[k1][i3]) {
						ind[k1][i2] = ind[k1][i3];
						ind[k1][i3] = lv;
						sw          = 1;
					}
				}
				sw = 0;
				for (i3 = 0; i3 < len[p1] && sw == 0; i3++) {
					if (lv == ind[k2][i3]) {
						ind[k2][i3] = ind[k2][i2];
						ind[k2][i2] = lv;
						sw          = 1;
					}
				}
			}
		}
	}
}

/*******************************************************************/
/* iD_ɐ؂ڂ肵CqPɑ΂C؂ڂ  */
/*       ł́CeP̈`q̂܂܎󂯌pCEł́CeP  */
/*       ̈`qeQ̈`q̏oɕבւD            */
/*         2 4 1 3 6 5    2 4 1 3 5 6                              */
/*             *                                                 */
/*         3 2 5 4 1 6    3 2 5 4 1 6                              */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_seq(double kosa, int k_method, double k_bias,
                    double k_step)
{
	int i1, i2, i3, i4, k1, k2, p, pair, pp, p1, p2, sw;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch / 2;

	if (dup_a != 0) {
		printf("***error  @sK (C_seq)\n");
		exit(1);
	}

	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_seq)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(2, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// `q
			k1       = Position(-1);
			pi_w[k1] = 1;
			len[k1]  = len[p1];
			k2       = Position(-1);
			pi_w[k2] = 1;
			len[k2]  = len[p2];
						// 
			p = (int)(genrand_real3() * (len[p1] - 1));
			if (p >= len[p1]-1)
				p = len[p1] - 2;

			for (i2 = 0; i2 <= p; i2++) {
				ind[k1][i2] = ind[p1][i2];
				ind[k2][i2] = ind[p2][i2];
			}

			pp = 0;
			for (i2 = p+1; i2 < len[p1]; i2++) {
				sw = 0;
				for (i3 = pp; i3 < len[p2] && sw == 0; i3++) {
					for (i4 = p+1; i4 < len[p1] && sw == 0; i4++) {
						if (ind[p2][i3] == ind[p1][i4]) {
							sw          = 1;
							pp          = i3 + 1;
							ind[k1][i2] = ind[p1][i4];
						}
					}
				}
			}
			pp = 0;
			for (i2 = p+1; i2 < len[p2]; i2++) {
				sw = 0;
				for (i3 = pp; i3 < len[p1] && sw == 0; i3++) {
					for (i4 = p+1; i4 < len[p2] && sw == 0; i4++) {
						if (ind[p1][i3] == ind[p2][i4]) {
							sw          = 1;
							pp          = i3 + 1;
							ind[k2][i2] = ind[p2][i4];
						}
					}
				}
			}
		}
	}
}

/*******************************************************************/
/* ilDʒȕW_ɑIC̐ȇI  */
/*       ꂽʒuɂ`q̏ɏ]āC̐ë`q  */
/*       בւ                                              */
/*         2 4 1 3 6 5    2 4 1 3 6 5                              */
/*           *   *                                               */
/*         3 2 5 4 1 6    4 2 5 3 1 6                              */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_useq(double kosa, int k_method, double k_bias,
                     double k_step)
{
   int i1, i2, i3, i4, k1, k2, p, pair, p1, p2, sw;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch / 2;

	if (dup_a != 0) {
		printf("***error  @sK (C_useq)\n");
		exit(1);
	}

	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_useq)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(2, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// `q
			k1       = Position(-1);
			pi_w[k1] = 1;
			len[k1]  = len[p1];
			k2       = Position(-1);
			pi_w[k2] = 1;
			len[k2]  = len[p2];
						// 
			for (i2 = 0; i2 < len[p1]; i2++) {
				ind[k1][i2] = ind[p1][i2];
				ind[k2][i2] = ind[p2][i2];
				kou1[i2]    = (genrand_real3() < 0.5) ? 0 : 1;
			}

			p = 0;
			for (i2 = 0; i2 < len[p1]; i2++) {
				if (kou1[i2] > 0) {
					sw = 0;
					for (i3 = p; i3 < len[p2] && sw == 0; i3++) {
						for (i4 = 0; i4 < len[p1] && sw == 0; i4++) {
							if (ind[p2][i3] == ind[p1][i4] && kou1[i4] > 0) {
								sw          = 1;
								p           = i3 + 1;
								ind[k1][i2] = ind[p1][i4];
							}
						}
					}
				}
			}
			p = 0;
			for (i2 = 0; i2 < len[p2]; i2++) {
				if (kou1[i2] > 0) {
					sw = 0;
					for (i3 = p; i3 < len[p1] && sw == 0; i3++) {
						for (i4 = 0; i4 < len[p2] && sw == 0; i4++) {
							if (ind[p1][i3] == ind[p2][i4] && kou1[i4] > 0) {
								sw          = 1;
								p           = i3 + 1;
								ind[k2][i2] = ind[p2][i4];
							}
						}
					}
				}
			}
		}
	}
}

/*******************************************************************/
/* ilʒuDʒȕW_ɑIC̐ȇI  */
/*       ꂽʒuɂ`q̈ʒuɁC̐e̓`q  */
/*       zuDc̈`q́CeƓɔzuD        */
/*         2 4 1 3 6 5    + + 5 + 1 +    2 4 5 3 1 6               */
/*             *   *                                           */
/*         3 2 5 4 1 6    + + 1 + 6 +    3 2 1 5 6 4               */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_upos(double kosa, int k_method, double k_bias,
                     double k_step)
{
   int i1, i2, i3, k1, k2, p, pair, p1, p2, sw;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch / 2;

	if (dup_a != 0) {
		printf("***error  @sK (C_upos)\n");
		exit(1);
	}

	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_upos)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(2, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// `q
			k1       = Position(-1);
			pi_w[k1] = 1;
			len[k1]  = len[p1];
			k2       = Position(-1);
			pi_w[k2] = 1;
			len[k2]  = len[p2];
						// 
			for (i2 = 0; i2 < len[p1]; i2++) {
				kou1[i2] = (genrand_real3() < 0.5) ? 0 : 1;
				if (kou1[i2] > 0) {
					ind[k1][i2] = ind[p2][i2];
					ind[k2][i2] = ind[p1][i2];
				}
			}

			p = 0;
			for (i2 = 0; i2 < len[p1]; i2++) {
				sw = 0;
				for (i3 = 0; i3 < len[p1] && sw == 0; i3++) {
					if (kou1[i3] > 0 && ind[p1][i2] == ind[k1][i3])
						sw = 1;
				}
				if (sw == 0) {
					for (i3 = p; i3 < len[p1] && sw == 0; i3++) {
						if (kou1[i3] == 0) {
							ind[k1][i3] = ind[p1][i2];
							p           = i3 + 1;
							sw          = 1;
						}
					}
				}
			}
			p = 0;
			for (i2 = 0; i2 < len[p2]; i2++) {
				sw = 0;
				for (i3 = 0; i3 < len[p2] && sw == 0; i3++) {
					if (kou1[i3] > 0 && ind[p2][i2] == ind[k2][i3])
						sw = 1;
				}
				if (sw == 0) {
					for (i3 = p; i3 < len[p2] && sw == 0; i3++) {
						if (kou1[i3] == 0) {
							ind[k2][i3] = ind[p2][i2];
							p           = i3 + 1;
							sw          = 1;
						}
					}
				}
			}
		}
	}
}

/*******************************************************************/
/* iGbWgݑւDȉ̎菇ɏ]čsDΗ`q  */
/*       0`(max_len-1)łKvj                          */
/*         (0) GbW}bv쐬DGbW}bvƂ́CQ̐e  */
/*             āCm[hǂɐڑĂ̂\  */
/*             łCႦ΁CQ̐eC                        */
/*                 [A B C D E F]                                   */
/*                 [B D C A E F]                                   */
/*             łꍇ́C                                      */
/*                 A : B F C E                                     */
/*                 B : A C D F                                     */
/*                 C : B D A                                       */
/*                 D : C E B                                       */
/*                 E : D F A                                       */
/*                 F : A E B                                       */
/*             ƂȂD                                            */
/*         (1) êQ̏o_̓PŏD_  */
/*             ̓Xebv(4)̊ɏ]đIԁĩ݂m[hj   */
/*         (2) GbW}bvC݂̃m[h                */
/*         (3) ݂̃m[hڑ̃m[hĂC(4)   */
/*             iށDȂ΁C(5)ɐi                       */
/*         (4) ݂̃m[hĂڑm[h̓Cł  */
/*             ڑm[hm[hIȉ  */
/*             ́C_jC݂̃m[hƂC(2)ɐi */
/*         (5) ڑ̃m[hcĂ΃_ɑIC(2) */
/*             ߂DȂ΁CI                        */
/*      kosa : m                                            */
/*      k_method : I@                                        */
/*                 =-1 : _(default)                         */
/*                 =0 : Kx̂܂܎gp                       */
/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                 =2 : ]lɏʂCŐ`       */
/*      k_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)     */
/*      k_step : (default=1)                                     */
/*******************************************************************/
void Species::C_edge(double kosa, int k_method, double k_bias,
                     double k_step)
{
	int e[2], i1, i2, i3, i4, i5, k, kk, k0 = 0, k1, k2, min, num,
        p, pair, p1, p2, sw;
/*
     ݒƃf[^̃`FbN
*/
	pair = max_ch;

	if (dup_a != 0) {
		printf("***error  @sK (C_edge)\n");
		exit(1);
	}

	if (min_len > 0) {
		printf("***error  `q͌Œ蒷łȂ΂ȂȂ (C_edge)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < pair; i1++) {
					// Ȃꍇ
		if (genrand_real3() > kosa)
			C_copy(1, 1);
					// ꍇ
		else {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;
			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// `q
			k       = Position(-1);
			pi_w[k] = 1;
			len[k]  = len[p1];
						// GbW}bv̏
			for (i2 = 0; i2 < len[k]; i2++) {
				edge[i2][0] = 0;
				for (i3 = 1; i3 <= 4; i3++)
					edge[i2][i3] = -1;
			}
						// 
							// GbW}bv̍쐬
			for (i2 = 0; i2 < len[k]; i2++) {

				sw = 0;
				for (i3 = 0; i3 < len[k] && sw == 0; i3++) {
					if (i2 == ind[p1][i3]) {
						sw = 1;
						if (i3 == 0) {
							e[0] = ind[p1][len[k]-1];
							e[1] = ind[p1][1];
						}
						else {
							if (i3 == len[k]-1) {
								e[0] = ind[p1][i3-1];
								e[1] = ind[p1][0];
							}
							else {
								e[0] = ind[p1][i3-1];
								e[1] = ind[p1][i3+1];
							}
						}
						for (i4 = 0; i4 < 2; i4++) {
							edge[i2][0]++;
							edge[i2][edge[i2][0]] = e[i4];
						}
					}
				}

				sw = 0;
				for (i3 = 0; i3 < len[k] && sw == 0; i3++) {
					if (i2 == ind[p2][i3]) {
						sw = 1;
						if (i3 == 0) {
							e[0] = ind[p2][len[k]-1];
							e[1] = ind[p2][1];
						}
						else {
							if (i3 == len[k]-1) {
								e[0] = ind[p2][i3-1];
								e[1] = ind[p2][0];
							}
							else {
								e[0] = ind[p2][i3-1];
								e[1] = ind[p2][i3+1];
							}
						}
						for (i4 = 0; i4 < 2; i4++) {
							sw = 1;
							for (i5 = 1; i5 <= edge[i2][0] && sw == 1; i5++) {
								if (edge[i2][i5] == e[i4])
									sw = 2;
							}
							if (sw == 1) {
								edge[i2][0]++;
								edge[i2][edge[i2][0]] = e[i4];
							}
						}
					}
				}
			}
							// ̎s
								// o_̌
			k1 = ind[p1][0];
			k2 = ind[p2][0];
			if (edge[k1][0] == edge[k2][0])
				kk = (genrand_real3() > 0.5) ? k2 : k1;
			else
				kk = (edge[k1][0] < edge[k2][0]) ? k1 : k2;
			ind[k][0] = kk;
			p         = 1;

			while (p < len[k]) {
								// m[h̏
				for (i2 = 0; i2 < len[k]; i2++) {
					sw = 0;
					if (edge[i2][0] > 0) {
						for (i3 = 1; i3 <= 4 && sw == 0; i3++) {
							if (edge[i2][i3] == kk) {
								sw           = 1;
								edge[i2][i3] = -1;
								edge[i2][0]--;
							}
						}
					}
				}
								// ̌݃m[h̑I
				min = 10;
				num = 0;
				for (i2 = 1; i2 <= 4; i2++) {
					if (edge[kk][i2] >= 0) {
						k1 = edge[kk][i2];
						if (edge[k1][0] >= 0 && edge[k1][0] < min) {
							num = 1;
							min = edge[k1][0];
							k0  = k1;
						}
						else {
							if (edge[k1][0] == min)
								num++;
						}
					}
				}
				if (num > 1) {
					k1 = (int)(genrand_real3() * num) + 1;
					if (k1 > num)
						k1 = num;
					k2 = 0;
					k0 = -1;
					for (i2 = 1; i2 <= 4 && k0 < 0; i2++) {
						if (edge[kk][i2] >= 0) {
							if (edge[edge[kk][i2]][0] == min) {
								k2++;
								if (k1 == k2)
									k0 = edge[kk][i2];
							}
						}
					}
				}
				else {
					if (num <= 0) {
						num = 0;
						for (i2 = 0; i2 < len[k]; i2++) {
							if (i2 != kk && edge[i2][0] >= 0)
								num++;
						}
						if (num <= 0) {
							printf("***error  invalid data (C_edge)\n");
							exit(1);
						}
						else {
							k1 = (int)(genrand_real3() * num) + 1;
							if (k1 > num)
								k1 = num;
							k2 = 0;
							k0 = -1;
							for (i2 = 0; i2 < len[k] && k0 < 0; i2++) {
								if (i2 != kk && edge[i2][0] >= 0) {
									k2++;
									if (k1 == k2)
										k0 = i2;
								}
							}
						}
					}
				}
				edge[kk][0] = -1;
				ind[k][p]   = k0;
				kk          = k0;
				p++;
			}
		}
	}
}

/*************************************************************/
/* iTucA[DQ_̊głDC*/
/*       `q̃O[vȂsȂDƂ*/
/*         ***abcd**                                         */
/*         *cdab****                                         */
/*       ̂悤ȗe̎sCȉ̂S̎q*/
/*       j                                                */
/*         ***cdab**                                         */
/*         *abcd****                                         */
/*         ***badc**                                         */
/*         *dcba****                                         */
/*       őCS񐔁̑(̑|P) ̎q */
/*       \̂ŁCq̐ƂĂ̒l*/
/*       ȏ̃f[^͂ĂKvD              */
/*      kosa : m                                      */
/*      count : P̃yA[ɑ΂(default=10)     */
/*************************************************************/
void Species::C_sub(double kosa, int count)
{
	int i1, i2, i3, i4, i5, k1, k2, k3, k4, p1, p2,
        t11, t12, t21, t22 = 0, sw;
/*
     ݒƃf[^̃`FbN
*/
	if ((4*count*size*(size-1)) > max_ch) {
		printf("***error  q (C_sub)\n");
		exit(1);
	}
/*
     
*/
	for (i1 = 0; i1 < size-1; i1++) {
					// eP
		p1 = Position(i1);

		if (p1 >= 0) {

			for (i2 = i1; i2 < size; i2++) {
					// eQ
				p2 = Position(i2);

				if (p2 >= 0) {
					// Ȃꍇ
					if (genrand_real3() > kosa)
						C_copy(2, 1);
					// ꍇ
					else {
						// 񐔂̐
						for (i3 = 0; i3 < count; i3++) {
							// ʒǔi_̌Ōj
								// eP̌ʒu
							t11 = (int)(genrand_real3() * len[p1]);
							if (t11 > (len[p1]-1))
								t11 = len[p1] - 1;
							sw = 0;
							while (sw == 0) {
								t12 = (int)(genrand_real3() * len[p1]);
								if (t12 > (len[p1]-1))
									t12 = len[p1] - 1;
								if (t12 != t11)
									sw = 1;
							}
							if (t11 > t12) {
								k1  = t11;
								t11 = t12;
								t12 = k1;
							}
								// eQ̌ʒu
							sw  = 0;
							t21 = -1;
							for (i4 = 0; i4 < len[p2] && t21 < 0; i4++) {
								for (i5 = t11; i5 <= t12 && t21 < 0; i5++) {
									if (ind[p2][i4] == ind[p1][i5])
										t21 = i4;
								}
							}
							if (t21 >= 0) {
								t22 = t21 + t12 - t11;
								if (t22 < len[p2]) {
									sw = 1;
									for (i4 = t21+1; i4 <= t22 && sw > 0; i4++) {
										sw = 0;
										for (i5 = t11; i5 <= t12 && sw == 0; i5++) {
											if (ind[p2][i4] == ind[p1][i5])
												sw = 1;
										}
									}
								}
							}
								// ̎s
							if (sw > 0) {

								k1       = Position(-1);
								pi_w[k1] = 1;
								len[k1]  = len[p1];
								k2       = Position(-1);
								pi_w[k2] = 1;
								len[k2]  = len[p1];
								k3       = Position(-1);
								pi_w[k3] = 1;
								len[k3]  = len[p2];
								k4       = Position(-1);
								pi_w[k4] = 1;
								len[k4]  = len[p2];

								for (i4 = 0; i4 < t11; i4++) {
									ind[k1][i4] = ind[p1][i4];
									ind[k2][i4] = ind[p1][i4];
								}
								for (i4 = t11; i4 <= t12; i4++) {
									ind[k1][i4] = ind[p2][t21+i4-t11];
									ind[k2][i4] = ind[p2][t22-i4+t11];
								}
								for (i4 = t12+1; i4 < len[p1]; i4++) {
									ind[k1][i4] = ind[p1][i4];
									ind[k2][i4] = ind[p1][i4];
								}
								for (i4 = 0; i4 < t21; i4++) {
									ind[k3][i4] = ind[p2][i4];
									ind[k4][i4] = ind[p2][i4];
								}
								for (i4 = t21; i4 <= t22; i4++) {
									ind[k3][i4] = ind[p1][t11+i4-t21];
									ind[k4][i4] = ind[p1][t12-i4+t21];
								}
								for (i4 = t22+1; i4 < len[p2]; i4++) {
									ind[k3][i4] = ind[p2][i4];
									ind[k4][i4] = ind[p2][i4];
								}
							}
						}
					}
				}
			}
		}
	}
}

/**************************************/
/* ˑRψفiΗ`qƂ̒uj */
/*      pr : ˑRψٗ               */
/**************************************/
void Species::M_alle(double pr)
{
	int i1, i2, lid;
/*
     f[^̃`FbNƏݒ
*/
	if (dup_a == 0) {
		printf("***error  ˑRψٕ@sK (M_alle)\n");
		exit(1);
	}
/*
     s
*/
	for (i1 = 0; i1 < size+max_ch; i1++) {
		if (pi_w[i1] == 1) {
			for (i2 = 0; i2 < len[i1]; i2++) {
				if (genrand_real3() <= pr) {
					lid = (int)(genrand_real3() * (allele_u - allele_l + 1) + allele_l);
					if (lid > allele_u)
						lid = allele_u;
					if (lid != ind[i1][i2])
						ind[i1][i2] = lid;
				}
			}
		}
	}
}

/**********************************************************************/
/* ˑRψفiړDQ_ICQԖڂ̈`qPԖڂ̈`q̑O */
/*           ړj                                               */
/*      pr : ˑRψٗ                                               */
/**********************************************************************/
void Species::M_move(double pr)
{
	int i1, i2, ld, p1, p2, sw;

	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1 && genrand_real3() <= pr) {
/*
     ʒǔ
*/
					// p1
			p1 = (int)(genrand_real3() * len[i1]);
			if (p1 >= len[i1])
				p1 = len[i1] - 1;
					// p2
			sw = 0;
			while (sw == 0) {
				p2 = (int)(genrand_real3() * len[i1]);
				if (p2 >= len[i1])
					p2 = len[i1] - 1;
				if (p2 != p1)
					sw = 1;
			}
/*
     s
*/
			if (p2 > p1) {
				ld = ind[i1][p2];
				for (i2 = p2; i2 > p1; i2--)
					ind[i1][i2] = ind[i1][i2-1];
				ind[i1][p1] = ld;
			}
			else {
				ld = ind[i1][p2];
				for (i2 = p2; i2 < p1-1; i2++)
					ind[i1][i2] = ind[i1][i2+1];
				ind[i1][p1-1] = ld;
			}
		}
	}
}

/********************************************************/
/* ˑRψفitʁDQ_Ԃ̈`qtɕבւj */
/*      pr : ˑRψٗ                                 */
/*      wd : >0 : Œ                              */
/*           =0 : _(default)                 */
/********************************************************/
void Species::M_inv(double pr, int wd)
{
	int i1, lid, p, p1, p2, sw;

	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1 && genrand_real3() <= pr) {
/*
     Ԃ̌
*/
			if (wd == 0) {
				p1 = (int)(genrand_real3() * len[i1]);
				if (p1 >= len[i1])
					p1 = len[i1] - 1;
				sw = 0;
				while (sw == 0) {
					p2 = (int)(genrand_real3() * len[i1]);
					if (p2 >= len[i1])
						p2 = len[i1] - 1;
					if (p2 != p1)
						sw = 1;
				}
				if (p1 > p2) {
					p  = p1;
					p1 = p2;
					p2 = p;
				}
			}

			else {
				p1 = len[i1];
				while (p1 > len[i1]-2)
					p1 = (int)(genrand_real3() * len[i1]);
				p2 = p1 + wd - 1;
				if (p2 >= len[i1])
					p2 = len[i1] - 1;
			}
/*
     s
*/
			sw = 0;
			while (sw == 0) {
				lid         = ind[i1][p1];
				ind[i1][p1] = ind[i1][p2];
				ind[i1][p2] = lid;
				p1++;
				p2--;
				if (p1 >= p2)
					sw = 1;
			}
		}
	}
}

/**********************************************************************/
/* ˑRψفiXNuDQ_Ԃ̈`q_ɕבւj */
/*      pr : ˑRψٗ                                               */
/*      wd : >0 : Œ                                            */
/*           =0 : _(default)                               */
/**********************************************************************/
void Species::M_scram(double pr, int wd)
{
	int i1, i2, ld, p, p1, p2, sw;

	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1 && genrand_real3() <= pr) {
/*
     Ԃ̌
*/
			if (wd == 0) {
				p1 = (int)(genrand_real3() * len[i1]);
				if (p1 >= len[i1])
					p1 = len[i1] - 1;
				sw = 0;
				while (sw == 0) {
					p2 = (int)(genrand_real3() * len[i1]);
					if (p2 >= len[i1])
						p2 = len[i1] - 1;
					if (p2 != p1)
						sw = 1;
				}
				if (p1 > p2) {
					p  = p1;
					p1 = p2;
					p2 = p;
				}
			}

			else {
				p1 = len[i1];
				while (p1 > len[i1]-2)
					p1 = (int)(genrand_real3() * len[i1]);
				p2 = p1 + wd - 1;
				if (p2 >= len[i1])
					p2 = len[i1] - 1;
			}
/*
     s
*/
			for (i2 = p1; i2 <= p2; i2++) {
				p = (int)(genrand_real3() * (p2 - p1 + 1) + p1);
				if (p > p2)
					p = p2;
				ld          = ind[i1][i2];
				ind[i1][i2] = ind[i1][p];
				ind[i1][p]  = ld;
			}
		}
	}
}

/**********************************************************************/
/* ˑRψفi]DQ_Ԃ̈`q𑼂̈ʒû̂ƒuD */
/*           d͂̂܂܂Ƃj                               */
/*      pr : ˑRψٗ                                               */
/*      wd : >0 : Œ                                            */
/*           =0 : _(default)                               */
/**********************************************************************/
void Species::M_chg(double pr, int wd)
{
	int i1, i2, ld, p, p1, p2, p3, p4, sw;

	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1 && genrand_real3() <= pr) {
/*
     ԓ̌i[p1,p2][p3,p4]̓ւj
*/
					// p1
			p1 = (int)(genrand_real3() * len[i1]);
			if (p1 >= len[i1])
				p1 = len[i1] - 1;
					// p3
			sw = 0;
			while (sw == 0) {
				p3 = (int)(genrand_real3() * len[i1]);
				if (p3 >= len[i1])
					p3 = len[i1] - 1;
				if (p3 != p1)
					sw = 1;
			}
					// p1,p2ɂ
			if (p1 > p3) {
				p  = p1;
				p1 = p3;
				p3 = p;
			}
					// p4, p2
			p4 = (wd == 0) ? (int)(genrand_real3() * (len[i1] - p3)) + p3 :
                             p1 + wd - 1;
			if (p4 >= len[i1])
				p4 = len[i1] - 1;
			p2 = p1 + (p4 - p3);
					// d̃`FbN
			if (p2 >= p3) {
				p  = p3 - 1;
				p3 = p2 + 1;
				p2 = p;
				p4 = p3 + (p2 - p1);
			}
/*
     s
*/
			p = p3;
			for (i2 = p1; i2 <= p2; i2++) {
				ld          = ind[i1][i2];
				ind[i1][i2] = ind[i1][p];
				ind[i1][p]  = ld;
				p++;
			}
		}
	}
}

/**********************************************************************/
/* ˑRψفidDQ_Ԃ̈`q𑼂̈ʒuɃRs[               */
/*      pr : ˑRψٗ                                               */
/*      wd : >0 : Œ                                            */
/*           =0 : _(deafult)                               */
/**********************************************************************/
void Species::M_dup(double pr, int wd)
{
	int i1, i2, p, p1, p2, p3, p4, sw;
/*
     f[^̃`FbN
*/
	if (dup_a == 0) {
		printf("***error  ˑRψٕ@sK (M_dup)\n");
		exit(1);
	}
/*
     s
*/
	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1 && genrand_real3() <= pr) {
					// Ԃ̌i[p1,p2][p3,p4]ɃRs[j
						// p1
			p1 = (int)(genrand_real3() * len[i1]);
			if (p1 >= len[i1])
				p1 = len[i1] - 1;
						// p3
			sw = 0;
			while (sw == 0) {
				p3 = (int)(genrand_real3() * len[i1]);
				if (p3 >= len[i1])
					p3 = len[i1] - 1;
				if (p3 != p1)
					sw = 1;
			}
						// Ԃ߂
			if (p3 > p1) {
				p4 = (wd == 0) ? (int)(genrand_real3() * (len[i1] - p3)) + p3 :
                                 p3 + wd - 1;
				if (p4 >= len[i1])
					p4 = len[i1] - 1;
				p2 = p1 + (p4 - p3);
			}
			else {
				p2 = (wd == 0) ? (int)(genrand_real3() * (len[i1] - p1)) + p1 :
                                 p1 + wd - 1;
				if (p2 >= len[i1])
					p2 = len[i1] - 1;
				p4 = p3 + (p2 - p1);
			}
					// s
			p = p4;
			for (i2 = p2; i2 >= p1; i2--) {
				ind[i1][p] = ind[i1][i2];
				p--;
			}
		}
	}
}

/******************************************************/
/* ˑRψفiۓDlʂωj         */
/*      pr : ˑRψٗ                               */
/*      method : =0 : Kz(default)               */
/*               =1 : lz                        */
/*      m : ς܂͈lz̉(default=0.0)     */
/*      s : W΍܂͈lz̏(default=1.0) */
/******************************************************/
void Species::M_per(double pr, int method, double m, double s)
{
	double w, wd = 0.0, x1;
	int i1, i2;
/*
     f[^̃`FbNƏݒ
*/
	if (dup_a == 0) {
		printf("***error  ˑRψٕ@sK (M_per)\n");
		exit(1);
	}

	if (method > 0)
		wd = s - m;
/*
     s
*/
	for (i1 = 0; i1 < size+max_ch; i1++) {
		if (pi_w[i1] == 1) {
			for (i2 = 0; i2 < len[i1]; i2++) {
				if (genrand_real3() <= pr) {
					if (method == 0)
						w = norm_d(m, s);
					else {
						w = genrand_real3() * wd;
						if (genrand_real3() < 0.5)
							w = -w;
					}
					x1 = (double)ind[i1][i2] + w;
					if (x1 > allele_u)
						x1 = allele_u;
					else {
						if (x1 < allele_l)
							x1 = allele_l;
					}
					ind[i1][i2] = (int)x1;
				}
			}
		}
	}
}

/**********************************************************************/
/* ˑRψفi}D钷̈`q}j                       */
/*      pr : ˑRψٗ                                               */
/*      wd : >0 : Œ                                            */
/*           =0 : _(default)                               */
/**********************************************************************/
void Species::M_ins(double pr, int wd)
{
	int i1, i2, l, ld, p;
/*
     f[^̃`FbN
*/
	if (dup_a == 0 || min_len < 0) {
		printf("***error  ˑRψٕ@sK (M_ins)\n");
		exit(1);
	}
/*
     s
*/
	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1 && genrand_real3() <= pr) {
					// }ʒǔ
			p = (int)(genrand_real3() * (len[i1]+1));
			if (p > len[i1])
				p = len[i1];
					// }`q̌
			l = (wd == 0) ? (int)(genrand_real3() * (max_len - len[i1] + 1)) : wd;
			if (l > max_len-len[i1])
				l = max_len - len[i1];
			else {
				if (l <= 0)
					l = 1;
			}
					// s
						// }ꏊ̊m
			if (p < len[i1]) {
				for (i2 = len[i1]+l-1; i2 >= p; i2--)
					ind[i1][i2] = ind[i1][i2-l];
			}
						// }ꏊ̈`q̌
			for (i2 = p; i2 < p+l; i2++) {
				ld = (int)(genrand_real3() * (allele_u - allele_l + 1) + allele_l);
				if (ld > allele_u)
					ld = allele_u;
				ind[i1][i2] = ld;
			}

			len[i1]  += l;
		}
	}
}

/**********************************************************************/
/* ˑRψفi폜D钷̈`q폜j                       */
/*      pr : ˑRψٗ                                               */
/*      wd : >0 : Œ                                            */
/*           =0 : _(default)                               */
/**********************************************************************/
void Species::M_del(double pr, int wd)
{
	int i1, i2, l, max, p;
/*
     f[^̃`FbN
*/
	if (dup_a == 0 || min_len < 0) {
		printf("***error  ˑRψٕ@sK (M_del)\n");
		exit(1);
	}
/*
     s
*/
	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1 && genrand_real3() <= pr) {
					// 폜ʒǔ
			p = (int)(genrand_real3() * len[i1]);
			if (p >= len[i1])
				p = len[i1] - 1;
					// 폜`q̌
			max = (len[i1]-min_len < len[i1]-p) ? len[i1] - min_len : len[i1] - p;
			l   = (wd == 0) ? (int)(genrand_real3() * max + 1) : wd;
			if (l > max)
				l = max;
					// s
			for (i2 = 0; i2 < len[i1]-p-l; i2++)
				ind[i1][p+i2] = ind[i1][p+i2+l];

			len[i1]  -= l;
		}
	}
}

/*********************************************************************/
/* iG[gE[bgIj                                  */
/*      elite : G[gŎc̐(default=0)                      */
/*      s_method : [bg̍쐬@(default=1)                 */
/*                   =0 : Kx̂܂܎gp                       */
/*                   =1 : ŏl̍iCȉ̏ꍇ̓j */
/*                   =2 : ]lɏʂCŐ`       */
/*      s_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)       */
/*      s_step : (default=1)                                       */
/*********************************************************************/
void Species::S_roul(int elite, int s_method, double s_bias, double s_step)
{
	int count = 0, i1, i2, i3, k = 0, max, n = 0, p, sw;
/*
     l̃`FbNƏݒ
*/
	if (s_method != 0 && s_method != 2)
		s_method = 1;

	if (elite > size) {
		printf("***error  G[gŎc (S_roul)\n");
		exit(1);
	}

	if (s_method == 2 && s_step <= 0.0)
		s_step = 1.0;

	for (i1 = 0; i1 < size+max_ch; i1++)
		s_w[i1] = 0;
/*
     d̂폜
*/
	if (dup_s == 0) {
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (pi_w[i1] > 0) {
				for (i2 = i1+1; i2 < size+max_ch; i2++) {
					if (pi_w[i2] > 0 && len[i1] == len[i2]) {
						sw = 0;
						for (i3 = 0; i3 < len[i1] && sw == 0; i3++) {
							if (ind[i1][i3] != ind[i2][i3])
								sw = 1;
						}
						if (sw == 0)
							pi_w[i2] = 0;
					}
				}
			}
		}
	}

	for (i1 = 0; i1 < size+max_ch; i1++) {
		if (pi_w[i1] > 1)
			n++;
	}

	if (n < 0 || dup_s == 0 && n < size) {
		printf("***error  c̂Ȃ (S_roul)\n");
		exit(1);
	}
/*
     Ďc̂I
*/
					// G[g̑I
	sw = 0;

	while (k < elite && k < n && sw == 0) {
		max = -1;
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (pi_w[i1] > 1 && s_w[i1] == 0) {
				if (max < 0 || pi[i1] > pi[max])
					max = i1;
			}
		}
		if (max < 0)
			sw = 1;
		else {
			s_w[max] = 1;
			k++;
		}
	}
					// [bgI
	while (count < size+max_ch && k < size) {
		p = Select(s_method, s_bias, s_step);
		if (dup_s == 0 && s_w[p] > 0)
			count++;
		else {
			count = 0;
			s_w[p]++;
			k++;
		}
	}
						// IɎsꍇ̏
	if (dup_s == 0 && k < size) {
		for (i1 = 0; i1 < size+max_ch && k < size; i1++) {
			if (pi_w[i1] > 1 && s_w[i1] == 0) {
				s_w[i1] = 1;
				k++;
			}
		}
	}
						// Iꂽ̂̏
	for (i1 = 0; i1 < size+max_ch; i1++) {
		if (s_w[i1] == 0)
			pi_w[i1] = 0;
	}

	for (i1 = 0; i1 < size+max_ch; i1++) {
		if (s_w[i1] > 0) {
			if (s_w[i1] > 1) {
				for (i2 = 2; i2 <= s_w[i1]; i2++) {
					k       = Position(-1);
					len[k]  = len[i1];
					pi_w[k] = 2;
					pi[k]   = pi[i1];
					for (i3 = 0; i3 < len[i1]; i3++)
						ind[k][i3] = ind[i1][i3];
				}
			}
		}
	}
}

/***********************************/
/* Kzϗʂ̔              */
/*      m :                    */
/*      s : W΍               */
/*           return : Kzϗ */
/***********************************/
double norm_d(double m, double s)
{
	double x = 0.0;
	int i1;

	for (i1 = 0; i1 < 12; i1++)
		x += genrand_real3();

	x = s * (x - 6.0) + m;

	return x;
}

/************************/
/* NXFunction̒` */
/************************/
class Function : public Species {

		double cv;   // 2i10i̕ϊW
		int max_gen;   // ő吢㐔
		int kosa_m;   // @
                      //   =-1 : gpȂ
                      //   =0 : ẽRs[
                      //   =1 : _
                      //   =2 : l
                      //   =3 : ω
		double kosa;   // m
		int k_point;   // _̐i̎́C1-pointԂ̃_j
		int k_vr;   // =0 : eƂʒuŌ
                    // =1 : eقȂʒuŌi`q͉ρj
		int k_method;   // ̎̐ȇI@
                        //   =-1 : _
                        //   =0 : Kx̂܂܎gp
                        //   =1 : ŏl̍iCȉ̏ꍇ̓j
                        //   =2 : ]lɏʂCŐ`
		double k_bias;   // C܂́Cmethod=2̏ꍇ͏l
		double k_step;   // 
		int mute_m;   // ˑRψٕ@
                      //   =-1 : ˑRψقgpȂ
                      //   =0 : Η`qւ̒u
                      //   =1 : ړ
                      //   =2 : t
                      //   =3 : XNu
                      //   =4 : ]
                      //   =5 : d
                      //   =6 : ۓ
		double mute;   // ˑRψٗ
		int wd;   // ˑRψقɎgp镔`q
		double m_mean;   // ۓ̕ϒl
		double m_std;   // ۓ̕W΍
		int elite;   // G[gIŎc
		int s_method;   // [bg̍쐬@
                        //   =0 : Kx̂܂܎gp
                        //   =1 : ŏl̍iCȉ̏ꍇ̓j
                        //   =2 : ]lɏʂCŐ`
		double s_bias;   // C܂́Cs_method=2̏ꍇ͏l
		double s_step;   // 
		int out_d;   // \Ԋu
		int out_lvl;   // o̓x
                       //   =0 : ŏIo͂
                       //   n>0 : 㖈ɏói̎̓t@Cj
		int out_m;   // o͕@
                     //   =0 : ׂĂo
                     //   =1 : őKx̌̂o
		char o_file[100];   // o̓t@C

	public:
					// RXgN^
		Function (char *, char *, long);
					// fXgN^
		~Function ();
					// Ŝ̎s
		void Control();
					// Kx̌vZ
		void Adap();
					// o
		void Output(int);
};

/***************************************/
/* RXgN^                      */
/*      name1 : Species`t@C  */
/*      name2 : Function`t@C */
/*      seed : ̏l            */
/***************************************/
Function::Function (char *name1, char *name2, long seed) : Species (name1, seed)
{
	FILE *in;

	in = fopen(name2, "r");

	fscanf(in, "%*s %d %*s %d", &out_lvl, &out_m);
	fscanf(in, "%*s %s %*s %d", o_file, &out_d);
	fscanf(in, "%*s %d %*s %lf %*s %d %*s %d %*s %d %*s %lf %*s %lf",
           &kosa_m, &kosa, &k_point, &k_vr, &k_method, &k_bias, &k_step);
	fscanf(in, "%*s %d %*s %lf %*s %d %*s %lf %*s %lf",
           &mute_m, &mute, &wd, &m_mean, &m_std);
	fscanf(in, "%*s %d %*s %d %*s %lf %*s %lf",
           &elite, &s_method, &s_bias, &s_step);
	fscanf(in, "%*s %d", &max_gen);

	cv = 1.0 / (pow(2.0, (double)max_len) - 1.0);

	fclose(in);
}

/****************/
/* fXgN^ */
/****************/
Function::~Function()
{
	int i1;

	for (i1 = 0; i1 < size+max_ch; i1++)
		delete [] ind[i1];
	delete [] ind;

	for (i1 = 0; i1 < max_len; i1++)
		delete [] edge[i1];
	delete [] edge;

	delete [] pi;
	delete [] len;
	delete [] kou1;
	delete [] kou2;
	delete [] pi_w;
	delete [] s_w;
	delete [] ro;
}

/**************/
/* Ŝ̐ */
/**************/
void Function::Control()
{
	int gen = 1, k1;
					// Wc̔
	Init_std();
					// ]
	Adap();
					// o
	printf("*** %d Kx max %f (%d) mean %f\n",
           gen, max, max_n, mean);

	if (abs(out_lvl) > 0)
		Output(gen);
					// 
	for (gen = 2; gen <= max_gen; gen++) {
						// 
		switch (kosa_m) {
			case -1:
				break;
			case 0:
				C_copy();   // ẽRs[
				break;
			case 1:
				C_point(kosa, k_point);   // _
				break;
			case 2:
				C_uniform(kosa);   // l
				break;
			case 3:
				C_mean(kosa);   // ω
				break;
			default:
				break;
		}
						// ˑRψ
		switch (mute_m) {
			case -1:
				break;
			case 0:
				M_alle(mute);   // Η`qւ̒u
				break;
			case 1:
				M_move(mute);   // ړ
				break;
			case 2:
				M_inv(mute, wd);   // t
				break;
			case 3:
				M_scram(mute, wd);   // XNu
				break;
			case 4:
				M_chg(mute, wd);   // ]
				break;
			case 5:
				M_dup(mute, wd);   // d
				break;
			case 6:
				M_per(mute, wd, m_mean, m_std);   // ۓ
				break;
			default:
				break;
		}
						// Kx
		Adap();
						// 
		S_roul(elite);
						// o
		if (gen%out_d == 0)
			printf("*** %d Kx max %f (%d) mean %f\n",
                   gen, max, max_n, mean);

		if (abs(out_lvl) > 0) {
			if (gen%abs(out_lvl) == 0)
				Output(gen);
		}
	}

	gen--;
	k1    = out_m;
	out_m = 0;
	printf("*** %d Kx max %f (%d) mean %f\n",
            gen, max, max_n, mean);
	Output(gen);
	out_m = k1;
}

/****************/
/* Kx̌vZ */
/****************/
void Function::Adap()
{
	double x, y;
	int i1, i2, n = 0;

	max   = 0.0;
	max_n = -1;
	mean  = 0.0;

	for (i1 = 0; i1 < size+max_ch; i1++) {

		if (pi_w[i1] == 1) {
			x = 0.0;
			y = 0.0;
			for (i2 = len[i1]-1; i2 >= 0; i2--) {
				if (ind[i1][i2] > 0)
					x += pow(2.0, y);
				y += 1.0;
			}
			x        *= cv;
			pi[i1]    = sin(3.0*x) + 0.5 * sin(9.0*x) + sin(15.0*x+50.0);
			pi_w[i1]  = 2;
		}

		if (pi_w[i1] > 0) {
			mean += pi[i1];
			n++;
			if (max_n < 0 || pi[i1] > max) {
				max   = pi[i1];
				max_n = i1;
			}
		}
	}

	mean /= n;
}

/*****************************/
/* ʂ̏o                */
/*      gen : ݂̐ԍ */
/*****************************/
void Function::Output(int gen)
{
	double x, y;
	int i1, i2, k = 0, pr;
	char *now;
	time_t aclock;
	FILE *out;

	if (out_lvl >= 0) {
		printf("   o͐́i0:o͂ȂCn:ʂɂÂC-1:t@CjH ");
		scanf("%d", &pr);
	}
	else
		pr = -1;

	if (pr != 0) {
					// o͐̌ƕ]l̏o
		if (pr > 0) {
			out = stdout;
			getchar();
		}
		else {
			time(&aclock);
			now = ctime(&aclock);
			out = fopen(o_file, "a");
			fprintf(out, "*** %d Kx max %f (%d) mean %f  %s\n",
                    gen, max, max_n, mean, now);
		}
					// ڍ׏o
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if ((pi_w[i1] > 1) && (out_m ==0 || out_m == 1 && i1 == max_n)) {
				fprintf(out, "%d allele", i1);
				for (i2 = 0; i2 < len[i1]; i2++)
					fprintf(out, " %d", ind[i1][i2]);
				x = 0.0;
				y = 0.0;
				for (i2 = len[i1]-1; i2 >= 0; i2--) {
					if (ind[i1][i2] > 0)
						x += pow(2.0, y);
					y += 1.0;
				}
				x *= cv;
				fprintf(out, " x %f y %f\n", x, pi[i1]);
				if (pr > 0) {
					k++;
					if (k == pr) {
						getchar();
						k = 0;
					}
				}
			}
		}

		if (pr < 0)
			fclose(out);
	}
}

/****************/
/* main program */
/****************/
int main(int argc, char *argv[])
{
	long *seed;
	int i1, n;
	char **i_file1, **i_file2;
	FILE *in;
	Function *fn;
					// ̓~X
	if (argc <= 1) {
		printf("***error  t@C͂ĉ\n");
		exit(1);
	}
					// ͂nj
	else {
						// t@C̃I[v
		in = fopen(argv[1], "r");
		if (in == NULL) {
			printf("***error  t@CsKł\n");
			exit(1);
		}
						// ̓f[^t@C̓
		fscanf(in, "%d", &n);   // f[^̐

		seed    = new long [n];
		i_file1 = new char * [n];
		i_file2 = new char * [n];

		for (i1 = 0; i1 < n; i1++) {
			i_file1[i1] = new char [100];
			i_file2[i1] = new char [100];
			seed[i1]    = 1000 * i1 + 1234567;
			fscanf(in, "%s %s", i_file1[i1], i_file2[i1]);
		}

		fclose(in);
						// sȉlςj
		for (i1 = 0; i1 < n; i1++) {

			printf("\n+++++P[X %d+++++\n", i1+1);

			fn = new Function (i_file1[i1], i_file2[i1], seed[i1]);

			fn->Control();
		}
	}

	return 0;
}

//------------------P[XX^fBf[^(data_cf.txt)------
/*
3
data1_f.txt data2_f.txt
data1_f.txt data2_f.txt
data1_f.txt data2_f.txt
*/

//------------------SpeciesLqf[^(data1_f.txt)---------
/*
Η`q 1 Η`q 0
ő`q 15 ŏ`qi̎́Cő`qŌŒj -1
`q̏d 1 ̂̏diF̂̌́j 0
WcTCY 20 q 20
*/

//------------------FunctionLqf[^(data2_f.txt)--------
/*
o̓x(̓t@C) 20 o͕@(0:ׂāC1:ő) 0
o̓t@C out1.txt \Ԋu 1
@ 1 m 1.0 _ 2 ʒu 0 @ 1 oCAX 0 Xebv 1
ˑRψٕ@ 0 ˑRψٗ 0.05  1  0.0 W΍ 1.0
G[g 2 @ 1 oCAX 0 Xebv 1
ő吢㐔 200
*/

//---------------------MT.h---------------------------
//   A C-program for MT19937, with initialization improved 2002/1/26.
//   Coded by Takuji Nishimura and Makoto Matsumoto.
//
//   Before using, initialize the state by using init_genrand(seed)  
//   or init_by_array(init_key, key_length).
//
//   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
//   All rights reserved.                          
//
//   Redistribution and use in source and binary forms, with or without
//   modification, are permitted provided that the following conditions
//   are met:
//
//     1. Redistributions of source code must retain the above copyright
//        notice, this list of conditions and the following disclaimer.
//
//     2. Redistributions in binary form must reproduce the above copyright
//        notice, this list of conditions and the following disclaimer in the
//        documentation and/or other materials provided with the distribution.
//
//     3. The names of its contributors may not be used to endorse or promote 
//        products derived from this software without specific prior written 
//        permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
//   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
//   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
//   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
//   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//
//   Any feedback is very welcome.
//   http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html
//   email: m-mat @ math.sci.hiroshima-u.ac.jp (remove space)


//   The original version of http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/MT2002/CODES/mt19937ar.c was modified by Takahiro Omi as
//   - delete line 47 "#include<stdio.h>"
//   - delete line 174 int main(void){...}
//   - change N -> MT_N
//   - change N -> MT_N
//   - change the file name "mt19937ar.c" -> "MT.h"


/*
// Period parameters
#define MT_N 624
#define MT_M 397
#define MATRIX_A 0x9908b0dfUL   // constant vector a
#define UPPER_MASK 0x80000000UL // most significant w-r bits
#define LOWER_MASK 0x7fffffffUL // least significant r bits

static unsigned long mt[MT_N]; // the array for the state vector
static int mti=MT_N+1; // mti==MT_N+1 means mt[MT_N] is not initialized

// initializes mt[MT_N] with a seed
void init_genrand(unsigned long s)
{
    mt[0]= s & 0xffffffffUL;
    for (mti=1; mti<MT_N; mti++) {
        mt[mti] = 
	    (1812433253UL * (mt[mti-1] ^ (mt[mti-1] >> 30)) + mti); 
        // See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier.
        // In the previous versions, MSBs of the seed affect
        // only MSBs of the array mt[].
        // 2002/01/09 modified by Makoto Matsumoto
        mt[mti] &= 0xffffffffUL;
        // for >32 bit machines
    }
}

// initialize by an array with array-length
// init_key is the array for initializing keys
// key_length is its length
// slight change for C++, 2004/2/26
void init_by_array(unsigned long init_key[], int key_length)
{
    int i, j, k;
    init_genrand(19650218UL);
    i=1; j=0;
    k = (MT_N>key_length ? MT_N : key_length);
    for (; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1664525UL))
          + init_key[j] + j; // non linear
        mt[i] &= 0xffffffffUL; // for WORDSIZE > 32 machines
        i++; j++;
        if (i>=MT_N) { mt[0] = mt[MT_N-1]; i=1; }
        if (j>=key_length) j=0;
    }
    for (k=MT_N-1; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1566083941UL))
          - i; // non linear
        mt[i] &= 0xffffffffUL; // for WORDSIZE > 32 machines
        i++;
        if (i>=MT_N) { mt[0] = mt[MT_N-1]; i=1; }
    }

    mt[0] = 0x80000000UL; // MSB is 1; assuring non-zero initial array
}

// generates a random number on [0,0xffffffff]-interval
unsigned long genrand_int32(void)
{
    unsigned long y;
    static unsigned long mag01[2]={0x0UL, MATRIX_A};
    // mag01[x] = x * MATRIX_A  for x=0,1

    if (mti >= MT_N) { // generate N words at one time
        int kk;

        if (mti == MT_N+1)   // if init_genrand() has not been called,
            init_genrand(5489UL); // a default initial seed is used

        for (kk=0;kk<MT_N-MT_M;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+MT_M] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        for (;kk<MT_N-1;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+(MT_M-MT_N)] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        y = (mt[MT_N-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
        mt[MT_N-1] = mt[MT_M-1] ^ (y >> 1) ^ mag01[y & 0x1UL];

        mti = 0;
    }
  
    y = mt[mti++];

    // Tempering
    y ^= (y >> 11);
    y ^= (y << 7) & 0x9d2c5680UL;
    y ^= (y << 15) & 0xefc60000UL;
    y ^= (y >> 18);

    return y;
}

// generates a random number on [0,0x7fffffff]-interval
long genrand_int31(void)
{
    return (long)(genrand_int32()>>1);
}

// generates a random number on [0,1]-real-interval
double genrand_real1(void)
{
    return genrand_int32()*(1.0/4294967295.0); 
    // divided by 2^32-1
}

// generates a random number on [0,1)-real-interval
double genrand_real2(void)
{
    return genrand_int32()*(1.0/4294967296.0); 
    // divided by 2^32
}

// generates a random number on (0,1)-real-interval
double genrand_real3(void)
{
    return (((double)genrand_int32()) + 0.5)*(1.0/4294967296.0); 
    // divided by 2^32
}

// generates a random number on [0,1) with 53-bit resolution
double genrand_res53(void) 
{ 
    unsigned long a=genrand_int32()>>5, b=genrand_int32()>>6; 
    return(a*67108864.0+b)*(1.0/9007199254740992.0); 
} 
// These real versions are due to Isaku Wada, 2002/01/09 added
*/
