/********************************************************************/
/* f(x) = sin(3.0*x) + 0.5 * sin(9.0*x) + sin(15.0*x + 50) ̍ől */
/*      coded by Y.Suganuma                                         */
/********************************************************************/
using System;
using System.IO;

/***********************/
/* NXSpecies̒` */
/***********************/
class Species {

	protected double max;   // őKx
	protected double mean;   // ϓKx
	protected double [] pi;   // Kx
	protected double [] ro;   // [bg
	protected int allele_u;   // Η`q
	protected int allele_l;   // Η`q
	protected int size;   // ̑
	protected int max_ch;   // q̐̍ől
	protected int max_len;   // ő`q
	protected int min_len;   // ŏ`qi̎́Cő`qŌŒj
	protected int max_n;   // őKx̌̔ԍ
	protected int dup_a;   // `q̏d
                           //   =0 : dȂ
                           //   =1 : d
	protected int dup_s;   // ̂̏diF̂̌́j
                           //   =0 : dȂ
                           //   =1 : d
	protected int [][] ind;   // Wci̂̏W܂j
	protected int [] len;   // e̂̈`q
	protected int [] kou1;   // EˑRψٗpƏꏊP
	protected int [] kou2;   // EˑRψٗpƏꏊQ
	protected int [] s_w;   // pwWiIꂽ񐔁j
	protected int [][] edge;   // GbWgݑւp[NGA
	protected byte [] pi_w;   // KxvZwW
                              //   =0 : gp
                              //   =1 : KxvZOiˑRψق͂̌̂ɓKpj
                              //   =2 : KxvZς݁iɐeƂ݂Ȃj
	protected Random rn;   // 

	/***********************************/
	/* Kzϗʂ̔              */
	/*      m :                    */
	/*      s : W΍               */
	/*           return : Kzϗ */
	/***********************************/
	double norm_d(double m, double s)
	{
		double x = 0.0;
		for (int i1 = 0; i1 < 12; i1++)
			x += rn.NextDouble();

		x = s * (x - 6.0) + m;

		return x;
	}

	/**************************************************/
	/* ꏊT                                     */
	/*      n : >=0 : nԖڂ̐e{                 */
	/*          -1 : 󂢂ĂꏊT             */
	/*      return : ȅꏊC܂́C󂢂Ăꏊ */
	/*               i݂ȂƂ͕̒lj       */
	/**************************************************/
	int Position(int n)
	{
		int i1, k = -1, sw = 0;
				//
				//  󂢂ĂꏊT
				//
		if (n < 0) {
			for (i1 = 0; i1 < size+max_ch && k < 0; i1++) {
				if (pi_w[i1] == 0)
					k = i1;
			}
			if (k < 0) {
				Console.WriteLine("***error  󂢂ĂꏊȂ --Position--");
				Environment.Exit(1);
			}
		}
				//
				// Ԗڂ̐eipi_w[i]=2j{
				//
		else {
			for (i1 = 0; i1 < size+max_ch && sw == 0; i1++) {
				if (pi_w[i1] == 2) {
					k++;
					if (k == n) {
						sw = 1;
						k  = i1;
					}
				}
			}
		}

		return k;
	}

	/*******************************************************************/
	/* ̂̑I                                                      */
	/*      method : I@                                          */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      bias : C܂́Cmethod=2̏ꍇ͏l                  */
	/*      step :                                                   */
	/*      return : ̔ԍ                                          */
	/*******************************************************************/
	int Select(int method, double bias, double step)
	{
		double sum = 0.0, x;
		int i1, k, min, n, sw;
						// [bg̗p
		switch (method) {
							// _
			case -1:
				n = 0;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1)
						n++;
				}
				sum = 1.0 / n;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1)
						ro[i1] = sum;
				}
				break;
							// ]l̂܂ܗp
			case 0:
				n = 0;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1) {
						sum += pi[i1];
						n++;
					}
				}
				if (Math.Abs(sum) > 1.0e-10) {
					sum = 1.0 / Math.Abs(sum);
					for (i1 = 0; i1 < size+max_ch; i1++) {
						if (pi_w[i1] > 1)
							ro[i1] = pi[i1] * sum;
					}
				}
				else {
					sum = 1.0 / n;
					for (i1 = 0; i1 < size+max_ch; i1++) {
						if (pi_w[i1] > 1)
							ro[i1] = sum;
					}
				}
				break;
							// ŏl̍
			case 1:
				min = -1;
				n   = 0;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1) {
						n++;
						if (min < 0 || pi[i1] < pi[min])
							min = i1;
					}
				}
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1) {
						ro[i1] = pi[i1] - pi[min];
						if (ro[i1] < bias)
							ro[i1] = bias;
						sum += ro[i1];
					}
				}
				if (sum > 1.0e-10) {
					sum = 1.0 / sum;
					for (i1 = 0; i1 < size+max_ch; i1++) {
						if (pi_w[i1] > 1)
							ro[i1] *= sum;
					}
				}
				else {
					sum = 1.0 / n;
					for (i1 = 0; i1 < size+max_ch; i1++) {
						if (pi_w[i1] > 1)
							ro[i1] = sum;
					}
				}
				break;
							// `
			case 2:
				n = 0;
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1) {
						ro[i1] = -1.0;
						n++;
					}
					else
						ro[i1] = 1.0;
				}
				sw  = 0;
				sum = bias;
				while (sw == 0) {
					min = -1;
					for (i1 = 0; i1 < size+max_ch; i1++) {
						if (ro[i1] < 0.0 && (min < 0 || pi[i1] < pi[min]))
							min = i1;
					}
					if (min < 0)
						sw = 1;
					else {
						ro[min]  = sum;
						sum     += step;
					}
				}
				sum = 1.0 / (0.5 * (2.0 * bias + step * (n - 1)) * n);
				for (i1 = 0; i1 < size+max_ch; i1++) {
					if (pi_w[i1] > 1)
						ro[i1] *= sum;
				}
				break;
		}

		sum = 0.0;
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (pi_w[i1] > 1) {
				sum    += ro[i1];
				ro[i1]  = sum;
			}
		}
						// I
		x  = rn.NextDouble();
		sw = 0;
		k  = 0;
		for (i1 = 0; i1 < size+max_ch && sw == 0; i1++) {
			if (pi_w[i1] > 1) {
				if (x <= ro[i1]) {
					sw = 1;
					k  = i1;
				}
			}
		}

		return k;
	}

	/****************************/
	/* RXgN^           */
	/*      name : t@C   */
	/*      seed : ̏l */
	/****************************/
	public Species (String name, int seed)
	{
		string[] lines = File.ReadAllLines(name);
		char[] charSep = new char[] {' '};
				//
				// f[^̓
				//
						// 1s
		string[] str = lines[0].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		allele_u     = int.Parse(str[1]);
		allele_l     = int.Parse(str[3]);
						// 2s
		str     = lines[1].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		max_len = int.Parse(str[1]);
		min_len = int.Parse(str[3]);
						// 3s
		str   = lines[2].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		dup_a = int.Parse(str[1]);
		dup_s = int.Parse(str[3]);
						// 4s
		str    = lines[3].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		size   = int.Parse(str[1]);
		max_ch = int.Parse(str[3]);
				//
				// f[^̃`FbN
				//
		if (size <= 0) {
			Console.WriteLine("***error  ̑O (Constructor)");
			Environment.Exit(1);
		}

		if (max_ch < 0) {
			Console.WriteLine("***error  q̐O (Constructor)");
			Environment.Exit(1);
		}

		if (max_len <= 0 || min_len == 0) {
			Console.WriteLine("***error  `qO (Constructor)");
			Environment.Exit(1);
		}

		if (max_len < min_len) {
			Console.WriteLine("***error  ő`qŏ`q (Constructor)");
			Environment.Exit(1);
		}

		if (allele_u <= allele_l) {
			Console.WriteLine("***error  Η`qΗ`q (Constructor)");
			Environment.Exit(1);
		}

		int kind = allele_u - allele_l + 1;
		if (dup_a == 0 && max_len > kind) {
			Console.WriteLine("***error  `q̏dhƂ͂łȂ (Constructor)");
			Environment.Exit(1);
		}
				//
				// ̈̊m
				//
		int num  = size + max_ch;

		ind  = new int [num][];
		for (int i1 = 0; i1 < num; i1++)
			ind[i1]  = new int [max_len];
		edge = new int [max_len][];
		for (int i1 = 0; i1 < max_len; i1++)
			edge[i1] = new int [5];
		pi   = new double [num];
		ro   = new double [num];
		len  = new int [num];
		kou1 = new int [max_len];
		kou2 = new int [max_len];
		s_w  = new int [num];
		pi_w = new byte [num];
				//
				// ̏ݒ
				//
		rn = new Random(seed);
	}

	/********************/
	/* WIȏݒ */
	/********************/
	protected void Init_std()
	{
		int i1, i2, i3, length, lid, sw1, sw2;
				//
				// ݒ
				//
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (i1 < size)
				pi_w[i1] = 1;   // Kx̌vZO
			else
				pi_w[i1] = 0;   // gp
		}
				//
				// `q̌
				//
		for (i1 = 0; i1 < size; i1++) {

			sw1 = 0;

			while (sw1 == 0) {
						// `q̌
				if (min_len < 0)
					length = max_len;
				else {
					length = (int)(rn.NextDouble() * (max_len - min_len + 1) + min_len);
					if (length > max_len)
						length = max_len;
				}
				len[i1] = length;
						// `q̌
				for (i2 = 0; i2 < length; i2++) {
					sw2 = 0;
					while (sw2 == 0) {
						lid = (int)(rn.NextDouble() * (allele_u - allele_l + 1) + allele_l);
						if (lid > allele_u)
							lid = allele_u;
						ind[i1][i2] = lid;
							// d`q̃`FbN
						sw2 = 1;
						if (dup_a == 0) {
							for (i3 = 0; i3 < i2 && sw2 > 0; i3++) {
								if (lid == ind[i1][i3])
									sw2 = 0;
							}
						}
					}
				}
						// d̂̃`FbN
				sw1 = 1;
				if (dup_s == 0) {
					for (i2 = 0; i2 < i1 && sw1 > 0; i2++) {
						if (len[i1] == len[i2]) {
							sw2 = 0;
							for (i3 = 0; i3 < len[i1] && sw2 == 0; i3++) {
								if (ind[i1][i3] != ind[i2][i3])
									sw2 = 1;
							}
							if (sw2 == 0)
								sw1 = 0;
						}
					}
				}
			}
		}
	}

	/****************************************************/
	/* WIȏo                                     */
	/*      sw : o̓x                             */
	/*             =0 : ŏIo͂                    */
	/*             n>0 : 㖈ɏói̓t@Cj */
	/*      out_m : o͕@                            */
	/*                =0 : ׂĂ̌̂o           */
	/*                =1 : őKx̌̂o   */
	/*      gen : ݂̐ԍ                        */
	/*      name : o̓t@C                       */
	/****************************************************/
	void Out_std(int sw, int out_m, int gen, String name)
	{
		int pr = -1;
		if (sw >= 0) {
			Console.Write("   o͐́i0:o͂ȂCn:ʂɂÂC-1:t@CjH ");
			pr = int.Parse(Console.ReadLine());
		}

		if (pr != 0) {

			StreamWriter OUT = new StreamWriter(name, true);
						// o͐̌ƕ]l̏o
			if (pr < 0) {
				DateTime now = DateTime.Now;   // ݎ̊l
				OUT.WriteLine("*** " + gen + " Kx max " + max +
                              " (" + max_n + ") mean " + mean + "  " + now);
			}
						// ڍ׏o
			int k = 0;
			for (int i1 = 0; i1 < size+max_ch; i1++) {
				if ((pi_w[i1] > 1) && (out_m ==0 || out_m == 1 && i1 == max_n)) {
					if (pr < 0) {
						OUT.Write(i1 + " allele");
						for (int i2 = 0; i2 < len[i1]; i2++)
							OUT.Write(" " + ind[i1][i2]);
						OUT.WriteLine(" value " + pi[i1]);
					}
					else {
						Console.Write(i1 + " allele");
						for (int i2 = 0; i2 < len[i1]; i2++)
							Console.Write(" " + ind[i1][i2]);
						Console.WriteLine(" value " + pi[i1]);
					}
					if (pr > 0) {
						k++;
						if (k == pr) {
							Console.ReadLine();
							k = 0;
						}
					}
				}
			}

			OUT.Close();
		}
	}

	/*******************************************************************/
	/* iẽRs[j                                              */
	/*      method : =2 : LiQ̐eQ̎qj               */
	/*               =1 : P̐eP̎q                       */
	/*      pair : method=2 ̎͐ẽyA                           */
	/*             method=1 ̎͐e̐iq̐j                 */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_copy(int method, int pair, int k_method, double k_bias,
                double k_step)
	{
	   int i1, i2, i3, k, p, p1, p2 = 0, sw;
				//
				// ݒƃf[^`FbN
				//
		if (method != 1)
			method = 2;

		if (pair <= 0)
			pair = (method==2) ? max_ch/2 : max_ch;
		else {
			if (method == 2 && 2*pair > max_ch || method == 1 && pair > max_ch) {
				Console.WriteLine("***error  q (C_copy)");
				Environment.Exit(1);
			}
		}
				//
				// s
				//
		for (i1 = 0; i1 < pair; i1++) {
						// ȇI
			p1 = Select(k_method, k_bias, k_step);
			sw = 0;

			while (sw == 0) {
				p2 = Select(k_method, k_bias, k_step);
				if (p1 != p2)
					sw = 1;
			}
						// Rs[
			for (i2 = 0; i2 < method; i2++) {
				p       = (i2 == 0) ? p1 : p2;
				k       = Position(-1);
				len[k]  = len[p];
				pi_w[k] = 1;
				for (i3 = 0; i3 < len[k]; i3++)
					ind[k][i3] = ind[p][i3];
			}
		}
	}

	/*******************************************************************/
	/* i_j                                                */
	/*      kosa : m                                            */
	/*      k_point : _̐                                       */
	/*                i̎́C1-k_pointԂ̃_j          */
	/*      k_vr : =0 : eƂʒuŌ                         */
	/*             =1 : eقȂʒuŌi`q͉ρj       */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_point(double kosa, int k_point, int k_vr, int k_method,
                 double k_bias, double k_step)
	{
		int abs_p, c1, c2, i1, i2, i3, k1, k2, mn = 0, num, p1, p2 = 0,
            pair, sw, t11, t12, t21, t22;
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch / 2;

		if (dup_a == 0) {
			Console.WriteLine("***error  @sK (C_point)");
			Environment.Exit(1);
		}

		abs_p = Math.Abs(k_point);
		if (abs_p == 0 || abs_p > max_len-1 || min_len > 0 && abs_p > min_len-1) {
			Console.WriteLine("***error  _̐sK (C_point)");
			Environment.Exit(1);
		}

		if (k_vr > 0 && min_len < 0) {
			Console.WriteLine("***error  `q͉ςłȂ΂ȂȂ (C_point)");
			Environment.Exit(1);
		}
				//
				// 
				//
		num = k_point;

		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// ʒu̐̌
				if (k_point < 0) {
					num = (int)(rn.NextDouble() * abs_p + 1);
					if (num > abs_p)
						num = abs_p;
				}
							// ʒǔi_̌Ōj
				for (i2 = 0; i2 < num; i2++) {
								// eP̌ʒu
					sw = 0;
					while (sw == 0) {
						sw       = 1;
						kou1[i2] = (int)(rn.NextDouble() * (len[p1] - 1));
						if (kou1[i2] > len[p1]-2)
							kou1[i2] = len[p1] - 2;
						if (k_vr == 0 && kou1[i2] > len[p2]-2)
							kou1[i2] = len[p2] - 2;
						for (i3 = 0; i3 < i2 && sw > 0; i3++) {
							if (kou1[i3] == kou1[i2])
								sw = 0;
						}
					}
								// eQ̌ʒu
					if (k_vr > 0) {
						sw = 0;
						while (sw == 0) {
							sw       = 1;
							kou2[i2] = (int)(rn.NextDouble() * (len[p2] - 1));
							if (kou2[i2] > len[p2]-2)
								kou2[i2] = len[p2] - 2;
							for (i3 = 0; i3 < i2 && sw > 0; i3++) {
								if (kou2[i3] == kou2[i2])
									sw = 0;
							}
						}
					}
				}
							// ̎s
							//   ePt11t12qPc1փRs[
							//   eQt21t22qQc2փRs[
							//     ́C
							//   ePt11t12qQc2փRs[
							//   eQt21t22qPc1փRs[
							//     EEEEE
				c1  = 0;
				c2  = 0;
				t11 = 0;
				t21 = 0;
								// `q
				k1       = Position(-1);
				pi_w[k1] = 1;
				len[k1]  = len[p1];
				k2       = Position(-1);
				pi_w[k2] = 1;
				len[k2]  = len[p2];

				for (i2 = 0; i2 < num+1; i2++ ) {
								// ̌ʒu߂
					if (i2 == num) {            // Ō
						t12 = len[p1];
						t22 = len[p2];
					}
					else {
									// eP
						t12 = max_len;
						for (i3 = 0; i3 < num; i3++) {
							if (kou1[i3] >= 0 && kou1[i3] <= t12) {
								t12 = kou1[i3];
								mn  = i3;
							}
						}
						kou1[mn] = -1;
						t12++;
									// eQ
						if (k_vr == 0)
							t22 = t12;
						else {
							t22 = max_len;
							for (i3 = 0; i3 < num; i3++) {
								if (kou2[i3] >= 0 && kou2[i3] <= t22) {
									t22 = kou2[i3];
									mn  = i3;
								}
							}
							kou2[mn] = -1;
							t22++;
						}
					}
								// wӏ̃Rs[
					for (i3 = t11; i3 < t12; i3++) {
						if (i2%2 == 0) {
							if (c1 < max_len) {
								ind[k1][c1] = ind[p1][i3];
								c1++;
							}
						}
						else {
							if (c2 < max_len) {
								ind[k2][c2] = ind[p1][i3];
								c2++;
							}
						}
					}

					for (i3 = t21; i3 < t22; i3++) {
						if (i2%2 == 0) {
							if (c2 < max_len) {
								ind[k2][c2] = ind[p2][i3];
								c2++;
							}
						}
						else {
							if (c1 < max_len) {
								ind[k1][c1] = ind[p2][i3];
								c1++;
							}
						}
					}
								// ʒüړ
					t11 = t12;
					t21 = t22;
				}
			}
		}
	}

	/*******************************************************************/
	/* ilD[0,1]𓙊mŔC1ł΁C            */
	/*       ePC0łΐeQ̈`qqP󂯌pj             */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_uniform(double kosa, int k_method, double k_bias, double k_step)
	{
		int i1, i2, k1, k2, p1, p2 = 0, pair, sw;
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch / 2;

		if (dup_a == 0) {
			Console.WriteLine("***error  @sK (C_uniform)");
			Environment.Exit(1);
		}

		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_uniform)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// `q
				k1       = Position(-1);
				pi_w[k1] = 1;
				len[k1]  = len[p1];
				k2       = Position(-1);
				pi_w[k2] = 1;
				len[k2]  = len[p2];
							// 
				for (i2 = 0; i2 < len[p1]; i2++) {
					if (rn.NextDouble() > 0.5) {
						ind[k1][i2] = ind[p1][i2];
						ind[k2][i2] = ind[p2][i2];
					}
					else {
						ind[k1][i2] = ind[p2][i2];
						ind[k2][i2] = ind[p1][i2];
					}
				}
			}
		}
	}

	/*******************************************************************/
	/* iωDQ̐e̕ϒl󂯌pj                  */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_mean(double kosa, int k_method, double k_bias, double k_step)
	{
		int i1, i2, k, p1, p2 = 0, sw;
				//
				// ݒƃf[^̃`FbN
				//
		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_mean)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < max_ch; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(1, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// `q
				k       = Position(-1);
				len[k]  = len[p1];
				pi_w[k] = 1;
							// 
				for (i2 = 0; i2 < len[k]; i2++)
					ind[k][i2] = (ind[p1][i2] + ind[p2][i2]) / 2;
			}
		}
	}

	/*******************************************************************/
	/* izD_ɂP_IC̈ʒuɂ`q  */
	/*       ̂܂܊eqID̈ʒuɂeQiPj̈`  */
	/*       qC̈`q̐ePiQj̏ꏊɁCqPiQj󂯌p  */
	/*       iCdoublȅꍇ́C̎葱̂jD̎  */
	/*       CłɎ󂯌p`q̈ʒuI܂ŌJ  */
	/*       ԂCc̈`qɂẮCqPiQj́CeQiPj  */
	/*       `q̏ԒʂɎ󂯌pj                          */
	/*         2 4 1 3 6 5    + + 1 + + 5    3 2 1 4 6 5               */
	/*             *                                               */
	/*         3 2 5 4 1 6    + + 5 + 1 +    2 4 5 3 1 6               */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_cycle(double kosa, int k_method, double k_bias, double k_step)
	{
	   int i1, i2, i3, k1, k2, p, pair, p1, p2 = 0, sw;
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch / 2;
	
		if (dup_a != 0) {
			Console.WriteLine("***error  @sK (C_cycle)");
			Environment.Exit(1);
		}
	
		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_cycle)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// ݒ
				for (i2 = 0; i2 < len[p1]; i2++) {
					kou1[i2] = 0;
					kou2[i2] = 0;
				}
							// `q
				k1       = Position(-1);
				pi_w[k1] = 1;
				len[k1]  = len[p1];
				k2       = Position(-1);
				pi_w[k2] = 1;
				len[k2]  = len[p2];
							// 
				sw = 0;
	
				while (sw == 0) {
					sw = 1;
					p  = (int)(rn.NextDouble() * len[p1]);
					if (p >= len[p1])
						p = len[p1] - 1;
					if (kou1[p] == 0 && kou2[p] == 0) {
						kou1[p]    = 1;
						kou2[p]    = 1;
						ind[k1][p] = ind[p1][p];
						ind[k2][p] = ind[p2][p];
						for (i2 = 0; i2 < len[p1] && sw > 0; i2++) {
							if (ind[p2][p] == ind[p1][i2]) {
								ind[k1][i2] = ind[p1][i2];
								kou1[i2]    = 1;
								sw          = 0;
							}
						}
						sw = 1;
						for (i2 = 0; i2 < len[p2] && sw > 0; i2++) {
							if (ind[p1][p] == ind[p2][i2]) {
								ind[k2][i2] = ind[p2][i2];
								kou2[i2]    = 1;
								sw          = 0;
							}
						}
					}
				}
	
				sw = 0;
				i2 = 0;
				i3 = 0;
				while (sw == 0) {
					while (sw == 0 && i2 < len[p1]) {
						if (kou1[i2] == 0)
							sw = 1;
						else
							i2++;
					}
					sw = 0;
					while (sw == 0 && i3 < len[p2]) {
						if (kou2[i3] == 0)
							sw = 1;
						else
							i3++;
					}
					if (i2 < len[p1] && i3 < len[p2]) {
						ind[k1][i2] = ind[p2][i3];
						ind[k2][i3] = ind[p1][i2];
						sw          = 0;
						i2++;
						i3++;
					}
					else
						sw = 1;
				}
			}
		}
	}

	/*******************************************************************/
	/* iID_ɂP_IC̈ʒuɂeP  */
	/*       eQ̈`qoDɁCePƐeQ̐F̏ŁC  */
	/*       ̂Q̈`q̈ʒuD̑CI_  */
	/*       Eɂ邷ׂĂ̈`qɑ΂Ď{                  */
	/*         2 4 1 3 6 5    2 4 5 3 6 1                              */
	/*             *                                          */
	/*         3 2 5 4 1 6    3 2 1 4 5 6                              */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_part(double kosa, int k_method, double k_bias, double k_step)
	{
		int i1, i2, i3, k1, k2, lv, p, pair, p1, p2 = 0, sw;
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch / 2;
	
		if (dup_a != 0) {
			Console.WriteLine("***error  @sK (C_part)");
			Environment.Exit(1);
		}
	
		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_part)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// `q
				k1       = Position(-1);
				pi_w[k1] = 1;
				len[k1]  = len[p1];
				k2       = Position(-1);
				pi_w[k2] = 1;
				len[k2]  = len[p2];
							// 
				p = (int)(rn.NextDouble() * len[p1]);
				if (p >= len[p1])
					p = len[p1] - 1;
	
				for (i2 = 0; i2 < len[p1]; i2++) {
					ind[k1][i2] = ind[p1][i2];
					ind[k2][i2] = ind[p2][i2];
				}
	
				for (i2 = p; i2 < len[p1]; i2++) {
					sw = 0;
					lv = ind[k1][i2];
					for (i3 = 0; i3 < len[p1] && sw == 0; i3++) {
						if (ind[k2][i2] == ind[k1][i3]) {
							ind[k1][i2] = ind[k1][i3];
							ind[k1][i3] = lv;
							sw          = 1;
						}
					}
					sw = 0;
					for (i3 = 0; i3 < len[p1] && sw == 0; i3++) {
						if (lv == ind[k2][i3]) {
							ind[k2][i3] = ind[k2][i2];
							ind[k2][i2] = lv;
							sw          = 1;
						}
					}
				}
			}
		}
	}

	/*******************************************************************/
	/* iD_ɐ؂ڂ肵CqPɑ΂C؂ڂ  */
	/*       ł́CeP̈`q̂܂܎󂯌pCEł́CeP  */
	/*       ̈`qeQ̈`q̏oɕבւD            */
	/*         2 4 1 3 6 5    2 4 1 3 5 6                              */
	/*             *                                                 */
	/*         3 2 5 4 1 6    3 2 5 4 1 6                              */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_seq(double kosa, int k_method, double k_bias, double k_step)
	{
		int i1, i2, i3, i4, k1, k2, p, pair, pp, p1, p2 = 0, sw;
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch / 2;
	
		if (dup_a != 0) {
			Console.WriteLine("***error  @sK (C_seq)");
			Environment.Exit(1);
		}
	
		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_seq)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// `q
				k1       = Position(-1);
				pi_w[k1] = 1;
				len[k1]  = len[p1];
				k2       = Position(-1);
				pi_w[k2] = 1;
				len[k2]  = len[p2];
							// 
				p = (int)(rn.NextDouble() * (len[p1] - 1));
				if (p >= len[p1]-1)
					p = len[p1] - 2;
	
				for (i2 = 0; i2 <= p; i2++) {
					ind[k1][i2] = ind[p1][i2];
					ind[k2][i2] = ind[p2][i2];
				}
	
				pp = 0;
				for (i2 = p+1; i2 < len[p1]; i2++) {
					sw = 0;
					for (i3 = pp; i3 < len[p2] && sw == 0; i3++) {
						for (i4 = p+1; i4 < len[p1] && sw == 0; i4++) {
							if (ind[p2][i3] == ind[p1][i4]) {
								sw          = 1;
								pp          = i3 + 1;
								ind[k1][i2] = ind[p1][i4];
							}
						}
					}
				}
				pp = 0;
				for (i2 = p+1; i2 < len[p2]; i2++) {
					sw = 0;
					for (i3 = pp; i3 < len[p1] && sw == 0; i3++) {
						for (i4 = p+1; i4 < len[p2] && sw == 0; i4++) {
							if (ind[p1][i3] == ind[p2][i4]) {
								sw          = 1;
								pp          = i3 + 1;
								ind[k2][i2] = ind[p2][i4];
							}
						}
					}
				}
			}
		}
	}

	/*******************************************************************/
	/* ilDʒȕW_ɑIC̐ȇI  */
	/*       ꂽʒuɂ`q̏ɏ]āC̐ë`q  */
	/*       בւ                                              */
	/*         2 4 1 3 6 5    2 4 1 3 6 5                              */
	/*           *   *                                               */
	/*         3 2 5 4 1 6    4 2 5 3 1 6                              */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_useq(double kosa, int k_method, double k_bias, double k_step)
	{
	   int i1, i2, i3, i4, k1, k2, p, pair, p1, p2 = 0, sw;
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch / 2;
	
		if (dup_a != 0) {
			Console.WriteLine("***error  @sK (C_useq)\n");
			Environment.Exit(1);
		}
	
		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_useq)\n");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// `q
				k1       = Position(-1);
				pi_w[k1] = 1;
				len[k1]  = len[p1];
				k2       = Position(-1);
				pi_w[k2] = 1;
				len[k2]  = len[p2];
							// 
				for (i2 = 0; i2 < len[p1]; i2++) {
					ind[k1][i2] = ind[p1][i2];
					ind[k2][i2] = ind[p2][i2];
					kou1[i2]    = (rn.NextDouble() < 0.5) ? 0 : 1;
				}
	
				p = 0;
				for (i2 = 0; i2 < len[p1]; i2++) {
					if (kou1[i2] > 0) {
						sw = 0;
						for (i3 = p; i3 < len[p2] && sw == 0; i3++) {
							for (i4 = 0; i4 < len[p1] && sw == 0; i4++) {
								if (ind[p2][i3] == ind[p1][i4] && kou1[i4] > 0) {
									sw          = 1;
									p           = i3 + 1;
									ind[k1][i2] = ind[p1][i4];
								}
							}
						}
					}
				}
				p = 0;
				for (i2 = 0; i2 < len[p2]; i2++) {
					if (kou1[i2] > 0) {
						sw = 0;
						for (i3 = p; i3 < len[p1] && sw == 0; i3++) {
							for (i4 = 0; i4 < len[p2] && sw == 0; i4++) {
								if (ind[p1][i3] == ind[p2][i4] && kou1[i4] > 0) {
									sw          = 1;
									p           = i3 + 1;
									ind[k2][i2] = ind[p2][i4];
								}
							}
						}
					}
				}
			}
		}
	}

	/*******************************************************************/
	/* ilʒuDʒȕW_ɑIC̐ȇI  */
	/*       ꂽʒuɂ`q̈ʒuɁC̐e̓`q  */
	/*       zuDc̈`q́CeƓɔzuD        */
	/*         2 4 1 3 6 5    + + 5 + 1 +    2 4 5 3 1 6               */
	/*             *   *                                           */
	/*         3 2 5 4 1 6    + + 1 + 6 +    3 2 1 5 6 4               */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_upos(double kosa, int k_method, double k_bias, double k_step)
	{
	   int i1, i2, i3, k1, k2, p, pair, p1, p2 = 0, sw;
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch / 2;
	
		if (dup_a != 0) {
			Console.WriteLine("***error  @sK (C_upos)");
			Environment.Exit(1);
		}
	
		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_upos)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// `q
				k1       = Position(-1);
				pi_w[k1] = 1;
				len[k1]  = len[p1];
				k2       = Position(-1);
				pi_w[k2] = 1;
				len[k2]  = len[p2];
							// 
				for (i2 = 0; i2 < len[p1]; i2++) {
					kou1[i2] = (rn.NextDouble() < 0.5) ? 0 : 1;
					if (kou1[i2] > 0) {
						ind[k1][i2] = ind[p2][i2];
						ind[k2][i2] = ind[p1][i2];
					}
				}
	
				p = 0;
				for (i2 = 0; i2 < len[p1]; i2++) {
					sw = 0;
					for (i3 = 0; i3 < len[p1] && sw == 0; i3++) {
						if (kou1[i3] > 0 && ind[p1][i2] == ind[k1][i3])
							sw = 1;
					}
					if (sw == 0) {
						for (i3 = p; i3 < len[p1] && sw == 0; i3++) {
							if (kou1[i3] == 0) {
								ind[k1][i3] = ind[p1][i2];
								p           = i3 + 1;
								sw          = 1;
							}
						}
					}
				}
				p = 0;
				for (i2 = 0; i2 < len[p2]; i2++) {
					sw = 0;
					for (i3 = 0; i3 < len[p2] && sw == 0; i3++) {
						if (kou1[i3] > 0 && ind[p2][i2] == ind[k2][i3])
							sw = 1;
					}
					if (sw == 0) {
						for (i3 = p; i3 < len[p2] && sw == 0; i3++) {
							if (kou1[i3] == 0) {
								ind[k2][i3] = ind[p2][i2];
								p           = i3 + 1;
								sw          = 1;
							}
						}
					}
				}
			}
		}
	}

	/*******************************************************************/
	/* iGbWgݑւDȉ̎菇ɏ]čsDΗ`q  */
	/*       0`(max_len-1)łKvj                          */
	/*         (0) GbW}bv쐬DGbW}bvƂ́CQ̐e  */
	/*             āCm[hǂɐڑĂ̂\  */
	/*             łCႦ΁CQ̐eC                        */
	/*                 [A B C D E F]                                   */
	/*                 [B D C A E F]                                   */
	/*             łꍇ́C                                      */
	/*                 A : B F C E                                     */
	/*                 B : A C D F                                     */
	/*                 C : B D A                                       */
	/*                 D : C E B                                       */
	/*                 E : D F A                                       */
	/*                 F : A E B                                       */
	/*             ƂȂD                                            */
	/*         (1) êQ̏o_̓PŏD_  */
	/*             ̓Xebv(4)̊ɏ]đIԁĩ݂m[hj   */
	/*         (2) GbW}bvC݂̃m[h                */
	/*         (3) ݂̃m[hڑ̃m[hĂC(4)   */
	/*             iށDȂ΁C(5)ɐi                       */
	/*         (4) ݂̃m[hĂڑm[h̓Cł  */
	/*             ڑm[hm[hIȉ  */
	/*             ́C_jC݂̃m[hƂC(2)ɐi */
	/*         (5) ڑ̃m[hcĂ΃_ɑIC(2) */
	/*             ߂DȂ΁CI                        */
	/*      kosa : m                                            */
	/*      k_method : I@                                        */
	/*                 =-1 : _                                  */
	/*                 =0 : Kx̂܂܎gp                       */
	/*                 =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                 =2 : ]lɏʂCŐ`       */
	/*      k_bias : C܂́Cmethod=2̏ꍇ͏l                */
	/*      k_step :                                                 */
	/*******************************************************************/
	protected void C_edge(double kosa, int k_method, double k_bias, double k_step)
	{
		int i1, i2, i3, i4, i5, k, kk, k0 = 0, k1, k2, min, num,
	        p, pair, p1, p2 = 0, sw;
		int[] e = new int [2];
				//
				// ݒƃf[^̃`FbN
				//
		pair = max_ch;
	
		if (dup_a != 0) {
			Console.WriteLine("***error  @sK (C_edge)");
			Environment.Exit(1);
		}
	
		if (min_len > 0) {
			Console.WriteLine("***error  `q͌Œ蒷łȂ΂ȂȂ (C_edge)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < pair; i1++) {
						// Ȃꍇ
			if (rn.NextDouble() > kosa)
				C_copy(1, 1, -1, 0.0, 0.0);
						// ꍇ
			else {
							// ȇI
				p1 = Select(k_method, k_bias, k_step);
				sw = 0;
				while (sw == 0) {
					p2 = Select(k_method, k_bias, k_step);
					if (p1 != p2)
						sw = 1;
				}
							// `q
				k       = Position(-1);
				pi_w[k] = 1;
				len[k]  = len[p1];
							// GbW}bv̏
				for (i2 = 0; i2 < len[k]; i2++) {
					edge[i2][0] = 0;
					for (i3 = 1; i3 <= 4; i3++)
						edge[i2][i3] = -1;
				}
							// 
								// GbW}bv̍쐬
				for (i2 = 0; i2 < len[k]; i2++) {
	
					sw = 0;
					for (i3 = 0; i3 < len[k] && sw == 0; i3++) {
						if (i2 == ind[p1][i3]) {
							sw = 1;
							if (i3 == 0) {
								e[0] = ind[p1][len[k]-1];
								e[1] = ind[p1][1];
							}
							else {
								if (i3 == len[k]-1) {
									e[0] = ind[p1][i3-1];
									e[1] = ind[p1][0];
								}
								else {
									e[0] = ind[p1][i3-1];
									e[1] = ind[p1][i3+1];
								}
							}
							for (i4 = 0; i4 < 2; i4++) {
								edge[i2][0]++;
								edge[i2][edge[i2][0]] = e[i4];
							}
						}
					}
	
					sw = 0;
					for (i3 = 0; i3 < len[k] && sw == 0; i3++) {
						if (i2 == ind[p2][i3]) {
							sw = 1;
							if (i3 == 0) {
								e[0] = ind[p2][len[k]-1];
								e[1] = ind[p2][1];
							}
							else {
								if (i3 == len[k]-1) {
									e[0] = ind[p2][i3-1];
									e[1] = ind[p2][0];
								}
								else {
									e[0] = ind[p2][i3-1];
									e[1] = ind[p2][i3+1];
								}
							}
							for (i4 = 0; i4 < 2; i4++) {
								sw = 1;
								for (i5 = 1; i5 <= edge[i2][0] && sw == 1; i5++) {
									if (edge[i2][i5] == e[i4])
										sw = 2;
								}
								if (sw == 1) {
									edge[i2][0]++;
									edge[i2][edge[i2][0]] = e[i4];
								}
							}
						}
					}
				}
								// ̎s
									// o_̌
				k1 = ind[p1][0];
				k2 = ind[p2][0];
				if (edge[k1][0] == edge[k2][0])
					kk = (rn.NextDouble() > 0.5) ? k2 : k1;
				else
					kk = (edge[k1][0] < edge[k2][0]) ? k1 : k2;
				ind[k][0] = kk;
				p         = 1;
	
				while (p < len[k]) {
									// m[h̏
					for (i2 = 0; i2 < len[k]; i2++) {
						sw = 0;
						if (edge[i2][0] > 0) {
							for (i3 = 1; i3 <= 4 && sw == 0; i3++) {
								if (edge[i2][i3] == kk) {
									sw           = 1;
									edge[i2][i3] = -1;
									edge[i2][0]--;
								}
							}
						}
					}
									// ̌݃m[h̑I
					min = 10;
					num = 0;
					for (i2 = 1; i2 <= 4; i2++) {
						if (edge[kk][i2] >= 0) {
							k1 = edge[kk][i2];
							if (edge[k1][0] >= 0 && edge[k1][0] < min) {
								num = 1;
								min = edge[k1][0];
								k0  = k1;
							}
							else {
								if (edge[k1][0] == min)
									num++;
							}
						}
					}
					if (num > 1) {
						k1 = (int)(rn.NextDouble() * num) + 1;
						if (k1 > num)
							k1 = num;
						k2 = 0;
						k0 = -1;
						for (i2 = 1; i2 <= 4 && k0 < 0; i2++) {
							if (edge[kk][i2] >= 0) {
								if (edge[edge[kk][i2]][0] == min) {
									k2++;
									if (k1 == k2)
										k0 = edge[kk][i2];
								}
							}
						}
					}
					else {
						if (num <= 0) {
							num = 0;
							for (i2 = 0; i2 < len[k]; i2++) {
								if (i2 != kk && edge[i2][0] >= 0)
									num++;
							}
							if (num <= 0) {
								Console.WriteLine("***error  invalid data (C_edge)");
								Environment.Exit(1);
							}
							else {
								k1 = (int)(rn.NextDouble() * num) + 1;
								if (k1 > num)
									k1 = num;
								k2 = 0;
								k0 = -1;
								for (i2 = 0; i2 < len[k] && k0 < 0; i2++) {
									if (i2 != kk && edge[i2][0] >= 0) {
										k2++;
										if (k1 == k2)
											k0 = i2;
									}
								}
							}
						}
					}
					edge[kk][0] = -1;
					ind[k][p]   = k0;
					kk          = k0;
					p++;
				}
			}
		}
	}

	/*************************************************************/
	/* iTucA[DQ_̊głDC*/
	/*       `q̃O[vȂsȂDƂ*/
	/*         ***abcd**                                         */
	/*         *cdab****                                         */
	/*       ̂悤ȗe̎sCȉ̂S̎q*/
	/*       j                                                */
	/*         ***cdab**                                         */
	/*         *abcd****                                         */
	/*         ***badc**                                         */
	/*         *dcba****                                         */
	/*       őCS񐔁̑(̑|P) ̎q */
	/*       \̂ŁCq̐ƂĂ̒l*/
	/*       ȏ̃f[^͂ĂKvD              */
	/*      kosa : m                                      */
	/*      count : P̃yA[ɑ΂                 */
	/*************************************************************/
	protected void C_sub(double kosa, int count)
	{
		int i1, i2, i3, i4, i5, k1, k2, k3, k4, p1, p2,
	        t11, t12 = 0, t21, t22 = 0, sw;
				//
				// ݒƃf[^̃`FbN
				//
		if ((4*count*size*(size-1)) > max_ch) {
			Console.WriteLine("***error  q (C_sub)");
			Environment.Exit(1);
		}
				//
				// 
				//
		for (i1 = 0; i1 < size-1; i1++) {
						// eP
			p1 = Position(i1);
	
			if (p1 >= 0) {
	
				for (i2 = i1; i2 < size; i2++) {
						// eQ
					p2 = Position(i2);
	
					if (p2 >= 0) {
						// Ȃꍇ
						if (rn.NextDouble() > kosa)
							C_copy(2, 1, -1, 0.0, 0.0);
						// ꍇ
						else {
							// 񐔂̐
							for (i3 = 0; i3 < count; i3++) {
								// ʒǔi_̌Ōj
									// eP̌ʒu
								t11 = (int)(rn.NextDouble() * len[p1]);
								if (t11 > (len[p1]-1))
									t11 = len[p1] - 1;
								sw = 0;
								while (sw == 0) {
									t12 = (int)(rn.NextDouble() * len[p1]);
									if (t12 > (len[p1]-1))
										t12 = len[p1] - 1;
									if (t12 != t11)
										sw = 1;
								}
								if (t11 > t12) {
									k1  = t11;
									t11 = t12;
									t12 = k1;
								}
									// eQ̌ʒu
								sw  = 0;
								t21 = -1;
								for (i4 = 0; i4 < len[p2] && t21 < 0; i4++) {
									for (i5 = t11; i5 <= t12 && t21 < 0; i5++) {
										if (ind[p2][i4] == ind[p1][i5])
											t21 = i4;
									}
								}
								if (t21 >= 0) {
									t22 = t21 + t12 - t11;
									if (t22 < len[p2]) {
										sw = 1;
										for (i4 = t21+1; i4 <= t22 && sw > 0; i4++) {
											sw = 0;
											for (i5 = t11; i5 <= t12 && sw == 0; i5++) {
												if (ind[p2][i4] == ind[p1][i5])
													sw = 1;
											}
										}
									}
								}
									// ̎s
								if (sw > 0) {
	
									k1       = Position(-1);
									pi_w[k1] = 1;
									len[k1]  = len[p1];
									k2       = Position(-1);
									pi_w[k2] = 1;
									len[k2]  = len[p1];
									k3       = Position(-1);
									pi_w[k3] = 1;
									len[k3]  = len[p2];
									k4       = Position(-1);
									pi_w[k4] = 1;
									len[k4]  = len[p2];
	
									for (i4 = 0; i4 < t11; i4++) {
										ind[k1][i4] = ind[p1][i4];
										ind[k2][i4] = ind[p1][i4];
									}
									for (i4 = t11; i4 <= t12; i4++) {
										ind[k1][i4] = ind[p2][t21+i4-t11];
										ind[k2][i4] = ind[p2][t22-i4+t11];
									}
									for (i4 = t12+1; i4 < len[p1]; i4++) {
										ind[k1][i4] = ind[p1][i4];
										ind[k2][i4] = ind[p1][i4];
									}
									for (i4 = 0; i4 < t21; i4++) {
										ind[k3][i4] = ind[p2][i4];
										ind[k4][i4] = ind[p2][i4];
									}
									for (i4 = t21; i4 <= t22; i4++) {
										ind[k3][i4] = ind[p1][t11+i4-t21];
										ind[k4][i4] = ind[p1][t12-i4+t21];
									}
									for (i4 = t22+1; i4 < len[p2]; i4++) {
										ind[k3][i4] = ind[p2][i4];
										ind[k4][i4] = ind[p2][i4];
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	/**************************************/
	/* ˑRψفiΗ`qƂ̒uj */
	/*      pr : ˑRψٗ               */
	/**************************************/
	protected void M_alle(double pr)
	{
		int i1, i2, lid;
				//
				// f[^̃`FbNƏݒ
				//
		if (dup_a == 0) {
			Console.WriteLine("***error  ˑRψٕ@sK (M_alle)");
			Environment.Exit(1);
		}
				//
				// s
				//
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (pi_w[i1] == 1) {
				for (i2 = 0; i2 < len[i1]; i2++) {
					if (rn.NextDouble() <= pr) {
						lid = (int)(rn.NextDouble() * (allele_u - allele_l + 1) + allele_l);
						if (lid > allele_u)
							lid = allele_u;
						if (lid != ind[i1][i2])
							ind[i1][i2] = lid;
					}
				}
			}
		}
	}

	/**********************************************************************/
	/* ˑRψفiړDQ_ICQԖڂ̈`qPԖڂ̈`q̑O */
	/*           ړj                                               */
	/*      pr : ˑRψٗ                                               */
	/**********************************************************************/
	protected void M_move(double pr)
	{
		int i1, i2, ld, p1, p2 = 0, sw;

		for (i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1 && rn.NextDouble() <= pr) {
				//
				// ʒǔ
				//
						// p1
				p1 = (int)(rn.NextDouble() * len[i1]);
				if (p1 >= len[i1])
					p1 = len[i1] - 1;
						// p2
				sw = 0;
				while (sw == 0) {
					p2 = (int)(rn.NextDouble() * len[i1]);
					if (p2 >= len[i1])
						p2 = len[i1] - 1;
					if (p2 != p1)
						sw = 1;
				}
				//
				// s
				//
				if (p2 > p1) {
					ld = ind[i1][p2];
					for (i2 = p2; i2 > p1; i2--)
						ind[i1][i2] = ind[i1][i2-1];
					ind[i1][p1] = ld;
				}
				else {
					ld = ind[i1][p2];
					for (i2 = p2; i2 < p1-1; i2++)
						ind[i1][i2] = ind[i1][i2+1];
					ind[i1][p1-1] = ld;
				}
			}
		}
	}

	/********************************************************/
	/* ˑRψفitʁDQ_Ԃ̈`qtɕבւj */
	/*      pr : ˑRψٗ                                 */
	/*      wd : >0 : Œ                              */
	/*           =0 : _                          */
	/********************************************************/
	protected void M_inv(double pr, int wd)
	{
		int i1, lid, p, p1, p2 = 0, sw;

		for (i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1 && rn.NextDouble() <= pr) {
				//
				// Ԃ̌
				//
				if (wd == 0) {
					p1 = (int)(rn.NextDouble() * len[i1]);
					if (p1 >= len[i1])
						p1 = len[i1] - 1;
					sw = 0;
					while (sw == 0) {
						p2 = (int)(rn.NextDouble() * len[i1]);
						if (p2 >= len[i1])
							p2 = len[i1] - 1;
						if (p2 != p1)
							sw = 1;
					}
					if (p1 > p2) {
						p  = p1;
						p1 = p2;
						p2 = p;
					}
				}

				else {
					p1 = len[i1];
					while (p1 > len[i1]-2)
						p1 = (int)(rn.NextDouble() * len[i1]);
					p2 = p1 + wd - 1;
					if (p2 >= len[i1])
						p2 = len[i1] - 1;
				}
				//
				// s
				//
				sw = 0;
				while (sw == 0) {
					lid         = ind[i1][p1];
					ind[i1][p1] = ind[i1][p2];
					ind[i1][p2] = lid;
					p1++;
					p2--;
					if (p1 >= p2)
						sw = 1;
				}
			}
		}
	}

	/**********************************************************************/
	/* ˑRψفiXNuDQ_Ԃ̈`q_ɕבւj */
	/*      pr : ˑRψٗ                                               */
	/*      wd : >0 : Œ                                            */
	/*           =0 : _                                        */
	/**********************************************************************/
	protected void M_scram(double pr, int wd)
	{
		int i1, i2, ld, p, p1, p2 = 0, sw;

		for (i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1 && rn.NextDouble() <= pr) {
				//
				// Ԃ̌
				//
				if (wd == 0) {
					p1 = (int)(rn.NextDouble() * len[i1]);
					if (p1 >= len[i1])
						p1 = len[i1] - 1;
					sw = 0;
					while (sw == 0) {
						p2 = (int)(rn.NextDouble() * len[i1]);
						if (p2 >= len[i1])
							p2 = len[i1] - 1;
						if (p2 != p1)
							sw = 1;
					}
					if (p1 > p2) {
						p  = p1;
						p1 = p2;
						p2 = p;
					}
				}

				else {
					p1 = len[i1];
					while (p1 > len[i1]-2)
						p1 = (int)(rn.NextDouble() * len[i1]);
					p2 = p1 + wd - 1;
					if (p2 >= len[i1])
						p2 = len[i1] - 1;
				}
				//
				// s
				//
				for (i2 = p1; i2 <= p2; i2++) {
					p = (int)(rn.NextDouble() * (p2 - p1 + 1) + p1);
					if (p > p2)
						p = p2;
					ld          = ind[i1][i2];
					ind[i1][i2] = ind[i1][p];
					ind[i1][p]  = ld;
				}
			}
		}
	}

	/**********************************************************************/
	/* ˑRψفi]DQ_Ԃ̈`q𑼂̈ʒû̂ƒuD */
	/*           d͂̂܂܂Ƃj                               */
	/*      pr : ˑRψٗ                                               */
	/*      wd : >0 : Œ                                            */
	/*           =0 : _                                        */
	/**********************************************************************/
	protected void M_chg(double pr, int wd)
	{
		int i1, i2, ld, p, p1, p2, p3 = 0, p4, sw;

		for (i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1 && rn.NextDouble() <= pr) {
				// 
				// ԓ̌i[p1,p2][p3,p4]̓ւj
				//
						// p1
				p1 = (int)(rn.NextDouble() * len[i1]);
				if (p1 >= len[i1])
					p1 = len[i1] - 1;
						// p3
				sw = 0;
				while (sw == 0) {
					p3 = (int)(rn.NextDouble() * len[i1]);
					if (p3 >= len[i1])
						p3 = len[i1] - 1;
					if (p3 != p1)
						sw = 1;
				}
						// p1,p2ɂ
				if (p1 > p3) {
					p  = p1;
					p1 = p3;
					p3 = p;
				}
						// p4, p2
				p4 = (wd == 0) ? (int)(rn.NextDouble() * (len[i1] - p3)) + p3 :
                                 p1 + wd - 1;
				if (p4 >= len[i1])
					p4 = len[i1] - 1;
				p2 = p1 + (p4 - p3);
						// d̃`FbN
				if (p2 >= p3) {
					p  = p3 - 1;
					p3 = p2 + 1;
					p2 = p;
					p4 = p3 + (p2 - p1);
				}
				//
				// s
				//
				p = p3;
				for (i2 = p1; i2 <= p2; i2++) {
					ld          = ind[i1][i2];
					ind[i1][i2] = ind[i1][p];
					ind[i1][p]  = ld;
					p++;
				}
			}
		}
	}

	/**********************************************************************/
	/* ˑRψفidDQ_Ԃ̈`q𑼂̈ʒuɃRs[               */
	/*      pr : ˑRψٗ                                               */
	/*      wd : >0 : Œ                                            */
	/*           =0 : _                                        */
	/**********************************************************************/
	protected void M_dup(double pr, int wd)
	{
		int i1, i2, p, p1, p2, p3 = 0, p4, sw;
				//
				// f[^̃`FbN
				//
		if (dup_a == 0) {
			Console.WriteLine("***error  ˑRψٕ@sK (M_dup)");
			Environment.Exit(1);
		}
				//
				// s
				//
		for (i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1 && rn.NextDouble() <= pr) {
						// Ԃ̌i[p1,p2][p3,p4]ɃRs[j
							// p1
				p1 = (int)(rn.NextDouble() * len[i1]);
				if (p1 >= len[i1])
					p1 = len[i1] - 1;
							// p3
				sw = 0;
				while (sw == 0) {
					p3 = (int)(rn.NextDouble() * len[i1]);
					if (p3 >= len[i1])
						p3 = len[i1] - 1;
					if (p3 != p1)
						sw = 1;
				}
							// Ԃ߂
				if (p3 > p1) {
					p4 = (wd == 0) ? (int)(rn.NextDouble() * (len[i1] - p3)) + p3 :
                                     p3 + wd - 1;
					if (p4 >= len[i1])
						p4 = len[i1] - 1;
					p2 = p1 + (p4 - p3);
				}
				else {
					p2 = (wd == 0) ? (int)(rn.NextDouble() * (len[i1] - p1)) + p1 :
                                     p1 + wd - 1;
					if (p2 >= len[i1])
						p2 = len[i1] - 1;
					p4 = p3 + (p2 - p1);
				}
						// s
				p = p4;
				for (i2 = p2; i2 >= p1; i2--) {
					ind[i1][p] = ind[i1][i2];
					p--;
				}
			}
		}
	}

	/******************************************************/
	/* ˑRψفiۓDlʂωj         */
	/*      pr : ˑRψٗ                               */
	/*      method : =0 : Kz                        */
	/*               =1 : lz                        */
	/*      m : ς܂͈lz̉                  */
	/*      s : W΍܂͈lz̏              */
	/******************************************************/
	protected void M_per(double pr, int method, double m, double s)
	{
		double w, wd = 0.0, x1;
		int i1, i2;
				//
				// f[^̃`FbNƏݒ
				//
		if (dup_a == 0) {
			Console.WriteLine("***error  ˑRψٕ@sK (M_per)");
			Environment.Exit(1);
		}

		if (method > 0)
			wd = s - m;
				//
				// s
				//
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (pi_w[i1] == 1) {
				for (i2 = 0; i2 < len[i1]; i2++) {
					if (rn.NextDouble() <= pr) {
						if (method == 0)
							w = norm_d(m, s);
						else {
							w = rn.NextDouble() * wd;
							if (rn.NextDouble() < 0.5)
								w = -w;
						}
						x1 = (double)ind[i1][i2] + w;
						if (x1 > allele_u)
							x1 = allele_u;
						else {
							if (x1 < allele_l)
								x1 = allele_l;
						}
						ind[i1][i2] = (int)x1;
					}
				}
			}
		}
	}

	/**********************************************************************/
	/* ˑRψفi}D钷̈`q}j                       */
	/*      pr : ˑRψٗ                                               */
	/*      wd : >0 : Œ                                            */
	/*           =0 : _                                        */
	/**********************************************************************/
	protected void M_ins(double pr, int wd)
	{
		int i1, i2, l, ld, p;
				//
				// f[^̃`FbN
				//
		if (dup_a == 0 || min_len < 0) {
			Console.WriteLine("***error  ˑRψٕ@sK (M_ins)");
			Environment.Exit(1);
		}
				//
				// s
				//
		for (i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1 && rn.NextDouble() <= pr) {
						// }ʒǔ
				p = (int)(rn.NextDouble() * (len[i1]+1));
				if (p > len[i1])
					p = len[i1];
						// }`q̌
				l = (wd == 0) ? (int)(rn.NextDouble() * (max_len - len[i1] + 1)) : wd;
				if (l > max_len-len[i1])
					l = max_len - len[i1];
				else {
					if (l <= 0)
						l = 1;
				}
						// s
							// }ꏊ̊m
				if (p < len[i1]) {
					for (i2 = len[i1]+l-1; i2 >= p; i2--)
						ind[i1][i2] = ind[i1][i2-l];
				}
							// }ꏊ̈`q̌
				for (i2 = p; i2 < p+l; i2++) {
					ld = (int)(rn.NextDouble() * (allele_u - allele_l + 1) + allele_l);
					if (ld > allele_u)
						ld = allele_u;
					ind[i1][i2] = ld;
				}

				len[i1]  += l;
			}
		}
	}

	/**********************************************************************/
	/* ˑRψفi폜D钷̈`q폜j                       */
	/*      pr : ˑRψٗ                                               */
	/*      wd : >0 : Œ                                            */
	/*           =0 : _                                        */
	/**********************************************************************/
	protected void M_del(double pr, int wd)
	{
		int i1, i2, l, max, p;
				//
				// f[^̃`FbN
				//
		if (dup_a == 0 || min_len < 0) {
			Console.WriteLine("***error  ˑRψٕ@sK (M_del)");
			Environment.Exit(1);
		}
				//
				// s
				//
		for (i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1 && rn.NextDouble() <= pr) {
						// 폜ʒǔ
				p = (int)(rn.NextDouble() * len[i1]);
				if (p >= len[i1])
					p = len[i1] - 1;
						// 폜`q̌
				max = (len[i1]-min_len < len[i1]-p) ? len[i1] - min_len : len[i1] - p;
				l   = (wd == 0) ? (int)(rn.NextDouble() * max + 1) : wd;
				if (l > max)
					l = max;
						// s
				for (i2 = 0; i2 < len[i1]-p-l; i2++)
					ind[i1][p+i2] = ind[i1][p+i2+l];

				len[i1]  -= l;
			}
		}
	}

	/*********************************************************************/
	/* iG[gE[bgIj                                  */
	/*      elite : G[gŎc̐(default=0)                      */
	/*      s_method : [bg̍쐬@(default=1)                 */
	/*                   =0 : Kx̂܂܎gp                       */
	/*                   =1 : ŏl̍iCȉ̏ꍇ̓j */
	/*                   =2 : ]lɏʂCŐ`       */
	/*      s_bias : C܂́Cmethod=2̏ꍇ͏l(default=0)       */
	/*      s_step : (default=1)                                       */
	/*********************************************************************/
	protected void S_roul(int elite, int s_method, double s_bias, double s_step)
	{
		int count = 0, i1, i2, i3, k = 0, max, n = 0, p, sw;
				//
				// l̃`FbNƏݒ
				//
		if (s_method != 0 && s_method != 2)
			s_method = 1;

		if (elite > size) {
			Console.WriteLine("***error  G[gŎc (S_roul)");
			Environment.Exit(1);
		}

		if (s_method == 2 && s_step <= 0.0)
			s_step = 1.0;

		for (i1 = 0; i1 < size+max_ch; i1++)
			s_w[i1] = 0;
				//
				// d̂폜
				//
		if (dup_s == 0) {
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 0) {
					for (i2 = i1+1; i2 < size+max_ch; i2++) {
						if (pi_w[i2] > 0 && len[i1] == len[i2]) {
							sw = 0;
							for (i3 = 0; i3 < len[i1] && sw == 0; i3++) {
								if (ind[i1][i3] != ind[i2][i3])
									sw = 1;
							}
							if (sw == 0)
								pi_w[i2] = 0;
						}
					}
				}
			}
		}

		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (pi_w[i1] > 1)
				n++;
		}

		if (n < 0 || dup_s == 0 && n < size) {
			Console.WriteLine("***error  c̂Ȃ (S_roul)");
			Environment.Exit(1);
		}
				//
				// Ďc̂I
				//
						// G[g̑I
		sw = 0;

		while (k < elite && k < n && sw == 0) {
			max = -1;
			for (i1 = 0; i1 < size+max_ch; i1++) {
				if (pi_w[i1] > 1 && s_w[i1] == 0) {
					if (max < 0 || pi[i1] > pi[max])
						max = i1;
				}
			}
			if (max < 0)
				sw = 1;
			else {
				s_w[max] = 1;
				k++;
			}
		}
						// [bgI
		while (count < size+max_ch && k < size) {
			p = Select(s_method, s_bias, s_step);
			if (dup_s == 0 && s_w[p] > 0)
				count++;
			else {
				count = 0;
				s_w[p]++;
				k++;
			}
		}
							// IɎsꍇ̏
		if (dup_s == 0 && k < size) {
			for (i1 = 0; i1 < size+max_ch && k < size; i1++) {
				if (pi_w[i1] > 1 && s_w[i1] == 0) {
					s_w[i1] = 1;
					k++;
				}
			}
		}
							// Iꂽ̂̏
		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (s_w[i1] == 0)
				pi_w[i1] = 0;
		}

		for (i1 = 0; i1 < size+max_ch; i1++) {
			if (s_w[i1] > 0) {
				if (s_w[i1] > 1) {
					for (i2 = 2; i2 <= s_w[i1]; i2++) {
						k       = Position(-1);
						len[k]  = len[i1];
						pi_w[k] = 2;
						pi[k]   = pi[i1];
						for (i3 = 0; i3 < len[i1]; i3++)
							ind[k][i3] = ind[i1][i3];
					}
				}
			}
		}
	}
}

/************************/
/* NXFunction̒` */
/************************/
class Function : Species {

	double cv;   // 2i10i̕ϊW
	int max_gen;   // ő吢㐔
	int kosa_m;   // @
                  //   =-1 : gpȂ
                  //   =0 : ẽRs[
                  //   =1 : _
                  //   =2 : l
                  //   =3 : ω
	double kosa;   // m
	int k_point;   // _̐i̎́C1-pointԂ̃_j
	int k_vr;   // =0 : eƂʒuŌ
                // =1 : eقȂʒuŌi`q͉ρj
	int k_method;   // ̎̐ȇI@
                    //   =-1 : _
                    //   =0 : Kx̂܂܎gp
                    //   =1 : ŏl̍iCȉ̏ꍇ̓j
                    //   =2 : ]lɏʂCŐ`
	double k_bias;   // C܂́Cmethod=2̏ꍇ͏l
	double k_step;   // 
	int mute_m;   // ˑRψٕ@
                  //   =-1 : ˑRψقgpȂ
                  //   =0 : Η`qւ̒u
                  //   =1 : ړ
                  //   =2 : t
                  //   =3 : XNu
                  //   =4 : ]
                  //   =5 : d
                  //   =6 : ۓ
	double mute;   // ˑRψٗ
	int wd;   // ˑRψقɎgp镔`q
	double m_mean;   // ۓ̕ϒl
	double m_std;   // ۓ̕W΍
	int elite;   // G[gIŎc
	int s_method;   // [bg̍쐬@
                    //   =0 : Kx̂܂܎gp
                    //   =1 : ŏl̍iCȉ̏ꍇ̓j
                    //   =2 : ]lɏʂCŐ`
	double s_bias;   // C܂́Cs_method=2̏ꍇ͏l
	double s_step;   // 
	int out_d;   // \Ԋu
	int out_lvl;   // o̓x
                   //   =0 : ŏIo͂
                   //   n>0 : 㖈ɏói̎̓t@Cj
	int out_m;   // o͕@
                 //   =0 : ׂĂo
                 //   =1 : őKx̌̂o
	String o_file;   // o̓t@C

	/***************************************/
	/* RXgN^                      */
	/*      name1 : Species`t@C  */
	/*      name2 : Function`t@C */
	/*      seed : ̏l            */
	/***************************************/
	public Function (String name1, String name2, int seed) : base(name1, seed)
	{
		string[] lines = File.ReadAllLines(name2);
		char[] charSep = new char[] {' '};
					// {f[^̓
						// 1s
		string[] str = lines[0].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		out_lvl      = int.Parse(str[1]);
		out_m        = int.Parse(str[3]);
						// 2s
		str    = lines[1].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		o_file = str[1];
		out_d  = int.Parse(str[3]);
						// 3s
		str      = lines[2].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		kosa_m   = int.Parse(str[1]);
		kosa     = double.Parse(str[3]);
		k_point  = int.Parse(str[5]);
		k_vr     = int.Parse(str[7]);
		k_method = int.Parse(str[9]);
		k_bias   = double.Parse(str[11]);
		k_step   = double.Parse(str[13]);
						// 4s
		str    = lines[3].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		mute_m = int.Parse(str[1]);
		mute   = double.Parse(str[3]);
		wd     = int.Parse(str[5]);
		m_mean = double.Parse(str[7]);
		m_std  = double.Parse(str[9]);
						// 5s
		str      = lines[4].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		elite    = int.Parse(str[1]);
		s_method = int.Parse(str[3]);
		s_bias   = double.Parse(str[5]);
		s_step   = double.Parse(str[7]);
						// 6s
		str     = lines[5].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
		max_gen = int.Parse(str[1]);

		cv = 1.0 / (Math.Pow(2.0, (double)max_len) - 1.0);
	}

	/**************/
	/* Ŝ̐ */
	/**************/
	public void Control()
	{
		int gen = 1;
						// Wc̔
		Init_std();
						// ]
		Adap();
						// o
		Console.WriteLine("*** " + gen + " Kx max " + max +
                          " (" + max_n + ") mean " + mean);

		if (Math.Abs(out_lvl) > 0)
			Output(gen);
						// 
		for (gen = 2; gen <= max_gen; gen++) {
							// 
			switch (kosa_m) {
				case -1:
					break;
				case 0:
					C_copy(2, max_ch/2, k_method, k_bias, k_step);   // ẽRs[
					break;
				case 1:
					C_point(kosa, k_point, k_vr, k_method, k_bias, k_step);   // _
					break;
				case 2:
					C_uniform(kosa, k_method, k_bias, k_step);   // l
					break;
				case 3:
					C_mean(kosa, k_method, k_bias, k_step);   // ω
					break;
				default:
					break;
			}
							// ˑRψ
			switch (mute_m) {
				case -1:
					break;
				case 0:
					M_alle(mute);   // Η`qւ̒u
					break;
				case 1:
					M_move(mute);   // ړ
					break;
				case 2:
					M_inv(mute, wd);   // t
					break;
				case 3:
					M_scram(mute, wd);   // XNu
					break;
				case 4:
					M_chg(mute, wd);   // ]
					break;
				case 5:
					M_dup(mute, wd);   // d
					break;
				case 6:
					M_per(mute, wd, m_mean, m_std);   // ۓ
					break;
				default:
					break;
			}
							// Kx
			Adap();
							// 
			S_roul(elite, s_method, s_bias, s_step);
							// o
			if (gen%out_d == 0)
				Console.WriteLine("*** " + gen + " Kx max " + max +
                                  " (" + max_n + ") mean " + mean);

			if (Math.Abs(out_lvl) > 0) {
				if (gen%Math.Abs(out_lvl) == 0)
					Output(gen);
			}
		}

		gen--;
		int k1 = out_m;
		out_m  = 0;
		Console.WriteLine("*** " + gen + " Kx max " + max +
                          " (" + max_n + ") mean " + mean);
		Output(gen);
		out_m = k1;
	}

	/****************/
	/* Kx̌vZ */
	/****************/
	void Adap()
	{
		max   = 0.0;
		max_n = -1;
		mean  = 0.0;
		int n = 0;

		for (int i1 = 0; i1 < size+max_ch; i1++) {

			if (pi_w[i1] == 1) {
				double x = 0.0;
				double y = 0.0;
				for (int i2 = len[i1]-1; i2 >= 0; i2--) {
					if (ind[i1][i2] > 0)
						x += Math.Pow(2.0, y);
					y += 1.0;
				}
				x        *= cv;
				pi[i1]    = Math.Sin(3.0*x) + 0.5 * Math.Sin(9.0*x) +
                            Math.Sin(15.0*x+50.0);
				pi_w[i1]  = 2;
			}

			if (pi_w[i1] > 0) {
				mean += pi[i1];
				n++;
				if (max_n < 0 || pi[i1] > max) {
					max   = pi[i1];
					max_n = i1;
				}
			}
		}

		mean /= n;
	}

	/*****************************/
	/* ʂ̏o                */
	/*      gen : ݂̐ԍ */
	/*****************************/
	void Output(int gen)
	{
		int pr = -1;
		if (out_lvl >= 0) {
			Console.Write("   o͐́i0:o͂ȂCn:ʂɂÂC-1:t@CjH ");
			pr = int.Parse(Console.ReadLine());
		}

		if (pr != 0) {

			StreamWriter OUT = new StreamWriter(o_file, true);
						// o͐̌ƕ]l̏o
			if (pr < 0) {
				DateTime now = DateTime.Now;   // ݎ̊l
				OUT.WriteLine("*** " + gen + " Kx max " + max +
                              " (" + max_n + ") mean " + mean + "  " + now);
			}
						// ڍ׏o
			int k = 0;
			for (int i1 = 0; i1 < size+max_ch; i1++) {
				if ((pi_w[i1] > 1) && (out_m ==0 || out_m == 1 && i1 == max_n)) {
					if (pr < 0) {
						OUT.Write(i1 + " allele");
						for (int i2 = 0; i2 < len[i1]; i2++)
							OUT.Write(" " + ind[i1][i2]);
						double x = 0.0;
						double y = 0.0;
						for (int i2 = len[i1]-1; i2 >= 0; i2--) {
							if (ind[i1][i2] > 0)
								x += Math.Pow(2.0, y);
							y += 1.0;
						}
						x *= cv;
						OUT.WriteLine(" x " + x + " y " + pi[i1]);
					}
					else {
						Console.Write(i1 + " allele");
						for (int i2 = 0; i2 < len[i1]; i2++)
							Console.Write(" " + ind[i1][i2]);
						double x = 0.0;
						double y = 0.0;
						for (int i2 = len[i1]-1; i2 >= 0; i2--) {
							if (ind[i1][i2] > 0)
								x += Math.Pow(2.0, y);
							y += 1.0;
						}
						x *= cv;
						Console.WriteLine(" x " + x + " y " + pi[i1]);
					}
					if (pr > 0) {
						k++;
						if (k == pr) {
							Console.ReadLine();
							k = 0;
						}
					}
				}
			}

			OUT.Close();
		}
	}
}

/****************/
/* main program */
/****************/
class Program
{
	static void Main(String[] args)
	{
						// ̓~X
		if (args.Length == 0)
			Console.WriteLine("***error  P[XX^fBt@C͂ĉ\n");
						// ͂nj
		else {
							// ̓f[^t@C̓
			String[] lines   = File.ReadAllLines(args[0]);
			int n            = int.Parse(lines[0]);   // ̐
			String[] i_file1 = new String [n];
			String[] i_file2 = new String [n];

			char[] charSep = new char[] {' '};
			for (int i1 = 0; i1 < n; i1++) {
				string[] str = lines[i1+1].Split(charSep, StringSplitOptions.RemoveEmptyEntries);
				i_file1[i1] = str[0];
				i_file2[i1] = str[1];
			}
							// sȉlςj
			for (int i1 = 0; i1 < n; i1++) {
				Console.WriteLine();
				Console.WriteLine("+++++P[X " + (i1+1) + "+++++\n");
								// ͂Əݒ
				Function fn = new Function (i_file1[i1], i_file2[i1], 1000 * i1 + 1234567);
								// œK
				fn.Control();
			}
		}
	}
}
