/****************************/
/* `v@               */
/*      coded by Y.Suganuma */
/****************************/
#include <stdio.h>

/*************/
/* NX LP */
/*************/
class LP
{
		int n;   // ̐
		int m;   // ϐ̐
		int m_s;   // XbNϐ̐
		int m_a;   // lוϐ̐
		int mm;   // m + m_s + m_a
		int *a;   // lוϐ邩ۂ
		int *cp;   // rZqi-1:  < E, 0:  = E, 1:  > EӁj
		int *row;   // es̊ϐ̔ԍ
		double *z;   // ړI֐̌W
		double **s;   // P̕\@
		double eps;   // e덷
		int err;   // G[R[h i0:I, 1:𖳂j
	public:
		/******************************/
		/* RXgN^             */
		/*      n1 : ̐     */
		/*      m1 : ϐ̐         */
		/*      z1 : ړI֐̌W   */
		/*      eq_l : ̍ */
		/*      eq_r : ̉E */
		/*      cp1 : rZq      */
		/******************************/
		LP(int n1, int m1, double *z1, double **eq_l, double *eq_r, int *cp1)
		{
			int i1, i2, k;
					// ݒ
			eps = 1.0e-10;
			err = 0;
			n   = n1;
			m   = m1;
			a   = new int [n];
			cp  = new int [n];
			for (i1 = 0; i1 < n; i1++) {
				a[i1]  = 0;
				cp[i1] = cp1[i1];
			}
			z = new double [m];
			for (i1 = 0; i1 < m; i1++)
				z[i1] = z1[i1];
					// XbNϐƐlוϐ̐𐔂
			m_s = 0;
			m_a = 0;
			for (i1 = 0; i1 < n; i1++) {
				if (cp[i1] == 0) {
					m_a++;
					if (eq_r[i1] < 0.0) {
						eq_r[i1] = -eq_r[i1];
						for (i2 = 0; i2 < m; i2++)
							eq_l[i1][i2] = -eq_l[i1][i2];
					}
				}
				else {
					m_s++;
					if (eq_r[i1] < 0.0) {
						cp[i1]   = -cp[i1];
						eq_r[i1] = -eq_r[i1];
						for (i2 = 0; i2 < m; i2++)
							eq_l[i1][i2] = -eq_l[i1][i2];
					}
					if (cp[i1] > 0)
						m_a++;
				}
			}
					// P̕\̍쐬
							// ݒ
			mm  = m + m_s + m_a;
			row = new int [n];
			s   = new double * [n+1];
			for (i1 = 0; i1 <= n; i1++) {
				s[i1] = new double [mm+1];
				if (i1 < n) {
					s[i1][0] = eq_r[i1];
					for (i2 = 0; i2 < m; i2++)
						s[i1][i2+1] = eq_l[i1][i2];
					for (i2 = m+1; i2 <= mm; i2++)
						s[i1][i2] = 0.0;
				}
				else {
					for (i2 = 0; i2 <= mm; i2++)
						s[i1][i2] = 0.0;
				}
			}
							// XbNϐ
			k = m + 1;
			for (i1 = 0; i1 < n; i1++) {
				if (cp[i1] != 0) {
					if (cp[i1] < 0) {
						s[i1][k] = 1.0;
						row[i1]  = k - 1;
					}
					else
						s[i1][k] = -1.0;
					k++;
				}
			}
							// lוϐ
			for (i1 = 0; i1 < n; i1++) {
				if (cp[i1] >= 0) {
					s[i1][k] = 1.0;
					row[i1]  = k - 1;
					a[i1]    = 1;
					k++;
				}
			}
							// ړI֐
			if (m_a == 0) {
				for (i1 = 0; i1 < m; i1++)
					s[n][i1+1] = -z[i1];
			}
			else {
				for (i1 = 0; i1 <= m+m_s; i1++) {
					for (i2 = 0; i2 < n; i2++) {
						if (a[i2] > 0)
							s[n][i1] -= s[i2][i1];
					}
				}
			}
		}

		/*******************************/
		/* œK                      */
		/*      sw : =0 : Ԍʖ */
		/*           =1 : Ԍʂ */
		/*      return : =0 : I */
		/*             : =1 : 𖳂   */
		/*******************************/
		int optimize(int sw)
		{
			int i1, i2, k;
					// tF[YP
			if (sw > 0) {
				if (m_a > 0)
					printf("\nphase 1\n");
				else
					printf("\nphase 2\n");
			}
			opt_run(sw);
					// tF[YQ
			if (err == 0 && m_a > 0) {
							// ړI֐̕ύX
				mm -= m_a;
				for (i1 = 0; i1 <= mm; i1++)
					s[n][i1] = 0.0;
				for (i1 = 0; i1 < n; i1++) {
					k = row[i1];
					if (k < m)
						s[n][0] += z[k] * s[i1][0];
				}
				for (i1 = 0; i1 < mm; i1++) {
					for (i2 = 0; i2 < n; i2++) {
						k = row[i2];
						if (k < m)
							s[n][i1+1] += z[k] * s[i2][i1+1];
					}
					if (i1 < m)
						s[n][i1+1] -= z[i1];
				}
							// œK
				if (sw > 0)
					printf("\nphase 2\n");
				opt_run(sw);
			}

			return err;
		}

		/*******************************/
		/* œKiP̕\̕ό`j      */
		/*      sw : =0 : Ԍʖ */
		/*           =1 : Ԍʂ */
		/*******************************/
		void opt_run(int sw)
		{
			int i1, i2, p, q, k;
			double x, min;

			err = -1;
			while (err < 0) {
					// Ԍ
				if (sw > 0) {
					printf("\n");
					output();
				}
					// ̑IihߕKŏlIȂCBland ̋Kj
				q = -1;
				for (i1 = 1; i1 <= mm && q < 0; i1++) {
					if (s[n][i1] < -eps)
						q = i1 - 1;
				}
					// IiœKj
				if (q < 0)
					err = 0;
					// s̑Ii Bland ̋K̗pj
				else {
					p   = -1;
					k   = -1;
					min = 0.0;
					for (i1 = 0; i1 < n; i1++) {
						if (s[i1][q+1] > eps) {
							x = s[i1][0] / s[i1][q+1];
							if (p < 0 || x < min || x == min && row[i1] < k) {
								min = x;
								p   = i1;
								k   = row[i1];
							}
						}
					}
							// 𖳂
					if (p < 0)
						err = 1;
							// ό`
					else {
						x      = s[p][q+1];
						row[p] = q;
						for (i1 = 0; i1 <= mm; i1++)
							s[p][i1] /= x;
						for (i1 = 0; i1 <= n; i1++) {
							if (i1 != p) {
								x = s[i1][q+1];
								for (i2 = 0; i2 <= mm; i2++)
									s[i1][i2] -= x * s[p][i2];
							}
						}
					}
				}
			}
		}

		/****************/
		/* P̕\̏o */
		/****************/
		void output()
		{
			int i1, i2;

			for (i1 = 0; i1 <= n; i1++) {
				if (i1 < n)
					printf("x%d", row[i1]+1);
				else
					printf(" z");
				for (i2 = 0; i2 <= mm; i2++)
					printf(" %f", s[i1][i2]);
				printf("\n");
			}
		}

		/**************/
		/* ʂ̏o */
		/**************/
		void result()
		{
			double x;
			int i1, i2;

			if (err > 0)
				printf("\n݂܂\n");
			else {
				printf("\n(");
				for (i1 = 0; i1 < m; i1++) {
					x = 0.0;
					for (i2 = 0; i2 < n; i2++) {
						if (row[i2] == i1) {
							x = s[i2][0];
							break;
						}
					}
					if (i1 == 0)
						printf("%f", x);
					else
						printf(", %f", x);
				}
				printf(") ̂ƂCől %f\n", s[n][0]);
			}
		}
};

/****************/
/* main program */
/****************/
int main()
{
	double **eq_l, *eq_r, *z;
	int i1, i2, n, m, *cp, sw;
	char c[2];
					// 
							// ϐ̐Ǝ̐
	scanf("%d %d", &m, &n);
	cp   = new int [n];
	z    = new double [m];
	eq_l = new double * [n];
	eq_r = new double [n];
	for (i1 = 0; i1 < n; i1++)
		eq_l[i1] = new double [m];
							// ړI֐̌W
	for (i1 = 0; i1 < m; i1++)
		scanf("%lf", &z[i1]);
							// 
	for (i1 = 0; i1 < n; i1++) {
		for (i2 = 0; i2 < m; i2++)
			scanf("%lf", &eq_l[i1][i2]);
		scanf("%s", c);
		if (c[0] == '<')
			cp[i1] = -1;
		else if (c[0] == '>')
			cp[i1] = 1;
		else
			cp[i1] = 0;
		scanf("%lf", &eq_r[i1]);
	}
					// s
	LP lp = LP(n, m, z, eq_l, eq_r, cp);
	sw = lp.optimize(1);
					// ʂ̏o
	lp.result();

	return 0;
}
