/****************************/
/* `v@               */
/*      coded by Y.Suganuma */
/****************************/
using System;

/*************/
/* NX LP */
/*************/
class LP
{
	private int n;   // ̐
	private int m;   // ϐ̐
	private int m_s;   // XbNϐ̐
	private int m_a;   // lוϐ̐
	private int mm;   // m + m_s + m_a
	private int[] a;   // lוϐ邩ۂ
	private int[] cp;   // rZqi-1:<E, 0:=E, 1:>EӁj
	private int[] row;   // es̊ϐ̔ԍ
	private double[] z;   // ړI֐̌W
	private double[][] s;   // P̕\
	private double eps;   // e덷
	private int err;   // G[R[h i0:I, 1:𖳂j

	/******************************/
	/* RXgN^             */
	/*      n1 : ̐     */
	/*      m1 : ϐ̐         */
	/*      z1 : ړI֐̌W   */
	/*      eq_l : ̍ */
	/*      eq_r : ̉E */
	/*      cp1 : rZq      */
	/******************************/
	public LP(int n1, int m1, double[] z1, double[][] eq_l, double[] eq_r, int[] cp1)
	{
					// ݒ
		eps = 1.0e-10;
		err = 0;
		n   = n1;
		m   = m1;
		a   = new int [n];
		cp  = new int [n];
		for (int i1 = 0; i1 < n; i1++) {
			a[i1]  = 0;
			cp[i1] = cp1[i1];
		}
		z = new double [m];
		for (int i1 = 0; i1 < m; i1++)
			z[i1] = z1[i1];
					// XbNϐƐlוϐ̐𐔂
		m_s = 0;
		m_a = 0;
		for (int i1 = 0; i1 < n; i1++) {
			if (cp[i1] == 0) {
				m_a++;
				if (eq_r[i1] < 0.0) {
					eq_r[i1] = -eq_r[i1];
					for (int i2 = 0; i2 < m; i2++)
						eq_l[i1][i2] = -eq_l[i1][i2];
				}
			}
			else {
				m_s++;
				if (eq_r[i1] < 0.0) {
					cp[i1]   = -cp[i1];
					eq_r[i1] = -eq_r[i1];
					for (int i2 = 0; i2 < m; i2++)
						eq_l[i1][i2] = -eq_l[i1][i2];
				}
				if (cp[i1] > 0)
					m_a++;
			}
		}
					// P̕\̍쐬
							// ݒ
		mm  = m + m_s + m_a;
		row = new int [n];
		s   = new double [n+1][];
		for (int i1 = 0; i1 < n+1; i1++)
			s[i1] = new double [mm+1];
		for (int i1 = 0; i1 <= n; i1++) {
			if (i1 < n) {
				s[i1][0] = eq_r[i1];
				for (int i2 = 0; i2 < m; i2++)
					s[i1][i2+1] = eq_l[i1][i2];
				for (int i2 = m+1; i2 <= mm; i2++)
					s[i1][i2] = 0.0;
			}
			else {
				for (int i2 = 0; i2 <= mm; i2++)
					s[i1][i2] = 0.0;
			}
		}
							// XbNϐ
		int k = m + 1;
		for (int i1 = 0; i1 < n; i1++) {
			if (cp[i1] != 0) {
				if (cp[i1] < 0) {
					s[i1][k] = 1.0;
					row[i1]  = k - 1;
				}
				else
					s[i1][k] = -1.0;
				k++;
			}
		}
							// lוϐ
		for (int i1 = 0; i1 < n; i1++) {
			if (cp[i1] >= 0) {
				s[i1][k] = 1.0;
				row[i1]  = k - 1;
				a[i1]    = 1;
				k++;
			}
		}
							// ړI֐
		if (m_a == 0) {
			for (int i1 = 0; i1 < m; i1++)
				s[n][i1+1] = -z[i1];
		}
		else {
			for (int i1 = 0; i1 <= m+m_s; i1++) {
				for (int i2 = 0; i2 < n; i2++) {
					if (a[i2] > 0)
						s[n][i1] -= s[i2][i1];
				}
			}
		}
	}

	/*******************************/
	/* œK                      */
	/*      sw : =0 : Ԍʖ */
	/*           =1 : Ԍʂ */
	/*      return : =0 : I */
	/*             : =1 : 𖳂   */
	/*******************************/
	public int optimize(int sw)
	{
					// tF[YP
		if (sw > 0) {
			if (m_a > 0) {
				Console.WriteLine();
				Console.WriteLine("phase 1");
			}
			else {
				Console.WriteLine();
				Console.WriteLine("phase 2");
			}
		}
		opt_run(sw);
					// tF[YQ
		int k;
		if (err == 0 && m_a > 0) {
							// ړI֐̕ύX
			mm -= m_a;
			for (int i1 = 0; i1 <= mm; i1++)
				s[n][i1] = 0.0;
			for (int i1 = 0; i1 < n; i1++) {
				k = row[i1];
				if (k < m)
					s[n][0] += z[k] * s[i1][0];
			}
			for (int i1 = 0; i1 < mm; i1++) {
				for (int i2 = 0; i2 < n; i2++) {
					k = row[i2];
					if (k < m)
						s[n][i1+1] += z[k] * s[i2][i1+1];
				}
				if (i1 < m)
					s[n][i1+1] -= z[i1];
			}
							// œK
			if (sw > 0) {
				Console.WriteLine();
				Console.WriteLine("phase 2");
			}
			opt_run(sw);
		}

		return err;
	}

	/*******************************/
	/* œKiP̕\̕ό`j      */
	/*      sw : =0 : Ԍʖ */
	/*           =1 : Ԍʂ */
	/*******************************/
	void opt_run(int sw)
	{
		err = -1;
		int p, q, k;
		double x, min;

		while (err < 0) {
					// Ԍ
			if (sw > 0) {
				Console.WriteLine();
				output();
			}
					// ̑IihߕKŏlIȂCBland ̋Kj
			q = -1;
			for (int i1 = 1; i1 <= mm && q < 0; i1++) {
				if (s[n][i1] < -eps)
					q = i1 - 1;
			}
					// IiœKj
			if (q < 0)
				err = 0;
					// s̑Ii Bland ̋K̗pj
			else {
				p   = -1;
				k   = -1;
				min = 0.0;
				for (int i1 = 0; i1 < n; i1++) {
					if (s[i1][q+1] > eps) {
						x = s[i1][0] / s[i1][q+1];
						if (p < 0 || x < min || x == min && row[i1] < k) {
							min = x;
							p   = i1;
							k   = row[i1];
						}
					}
				}
							// 𖳂
				if (p < 0)
					err = 1;
							// ό`
				else {
					x      = s[p][q+1];
					row[p] = q;
					for (int i1 = 0; i1 <= mm; i1++)
						s[p][i1] /= x;
					for (int i1 = 0; i1 <= n; i1++) {
						if (i1 != p) {
							x = s[i1][q+1];
							for (int i2 = 0; i2 <= mm; i2++)
								s[i1][i2] -= x * s[p][i2];
						}
					}
				}
			}
		}
	}

	/****************/
	/* P̕\̏o */
	/****************/
	void output()
	{
		for (int i1 = 0; i1 <= n; i1++) {
			if (i1 < n)
				Console.Write("x" + (row[i1]+1));
			else
				Console.Write(" z");
			for (int i2 = 0; i2 <= mm; i2++)
				Console.Write(" " + s[i1][i2]);
			Console.WriteLine();
		}
	}

	/**************/
	/* ʂ̏o */
	/**************/
	public void result()
	{
		if (err > 0) {
			Console.WriteLine("݂܂");
			Console.WriteLine();
		}
		else {
			Console.WriteLine();
			Console.Write("(");
			for (int i1 = 0; i1 < m; i1++) {
				double x = 0.0;
				for (int i2 = 0; i2 < n; i2++) {
					if (row[i2] == i1) {
						x = s[i2][0];
						break;
					}
				}
				if (i1 == 0)
					Console.Write(x);
				else
					Console.Write(", " + x);
			}
			Console.WriteLine(") ̂ƂCől " + s[n][0]);
		}
	}
}

/****************/
/* main program */
/****************/
class Program
{
	static void Main()
	{
					// 
							// ϐ̐Ǝ̐
		string[] str    = Console.ReadLine().Split(new char[] {' '}, StringSplitOptions.RemoveEmptyEntries);
		int m           = int.Parse(str[0]);
		int n           = int.Parse(str[1]);
		int[] cp        = new int [n];
		double[] z      = new double [m];
		double[][] eq_l = new double [n][];
		for (int i1 = 0; i1 < n; i1++)
			eq_l[i1] = new double [m];
		double[] eq_r = new double [n];
							// ړI֐̌W
		str = Console.ReadLine().Split(new char[] {' '}, StringSplitOptions.RemoveEmptyEntries);
		for (int i1 = 0; i1 < m; i1++)
			z[i1] = double.Parse(str[i1]);
							// 
		for (int i1 = 0; i1 < n; i1++) {
			str = Console.ReadLine().Split(new char[] {' '}, StringSplitOptions.RemoveEmptyEntries);
			for (int i2 = 0; i2 < m; i2++)
				eq_l[i1][i2] = double.Parse(str[i2]);
			if (String.Compare("<", str[m]) == 0)
				cp[i1] = -1;
			else if (String.Compare(">", str[m]) == 0)
				cp[i1] = 1;
			else
				cp[i1] = 0;
			eq_r[i1] = double.Parse(str[m+1]);
		}
					// s
		LP lp  = new LP(n, m, z, eq_l, eq_r, cp);
		int sw = lp.optimize(1);
					// ʂ̏o
		if (sw == 0)
			lp.result();
		else
			Console.WriteLine("܂I");
	}
}
