/********************************/
/* `B֐̃QCƈʑ̌vZ */
/*      coded by Y.Suganuma     */
/********************************/
#include <stdio.h>
#include <stdlib.h>
#include <iostream>

using namespace std;

/****************************/
/* NXComplex            */
/*      coded by Y.Suganuma */
/****************************/
class Complex {
		double r;   // 
		double i;   // 
	public:
		Complex (double a = 0.0, double b = 0.0);   // RXgN^
	friend double abs (Complex a);   // Βl
	friend double angle (Complex a);   // px
	friend Complex pow (Complex a, int n);   // ׂ
	friend Complex operator +(Complex a, Complex b);   // {̃I[o[[h
	friend Complex operator -(Complex a, Complex b);   // [̃I[o[[h
	friend Complex operator *(Complex a, Complex b);   // ̃I[o[[h
	friend Complex operator /(Complex a, Complex b);   // ^̃I[o[[h
	friend ostream& operator << (ostream&, Complex);   // ̃I[o[[h
};

/******************/
/* RXgN^ */
/*      a :   */
/*      b :   */
/******************/
Complex::Complex(double a, double b)
{
	r = a;
	i = b;
}

/******************/
/* f̐Βl */
/******************/
double abs(Complex a)
{
	double x;
	x = sqrt(a.r * a.r + a.i * a.i);
	return x;
}

/****************/
/* f̊px */
/****************/
double angle(Complex a)
{
	double x;
	if (a.r == 0.0 && a.i == 0.0)
		x = 0.0;
	else
		x = atan2(a.i, a.r);
	return x;
}

/****************/
/* f̂ */
/****************/
Complex pow(Complex a, int n)
{
	int i1;
	Complex c(1, 0);
	if (n >= 0) {
		for (i1 = 0; i1 < n; i1++)
			c = c * a;
	}
	else {
		for (i1 = 0; i1 < -n; i1++)
			c = c * a;
		c = 1.0 / c;
	}
	return c;
}

/**********************/
/* {̃I[o[[h */
/**********************/
Complex operator +(Complex a, Complex b)
{
	Complex c;
	c.r = a.r + b.r;
	c.i = a.i + b.i;
	return c;
}

/**********************/
/* [̃I[o[[h */
/**********************/
Complex operator -(Complex a, Complex b)
{
	Complex c;
	c.r = a.r - b.r;
	c.i = a.i - b.i;
	return c;
}

/**********************/
/* ̃I[o[[h */
/**********************/
Complex operator *(Complex a, Complex b)
{
	Complex c;
	c.r = a.r * b.r - a.i * b.i;
	c.i = a.i * b.r + a.r * b.i;
	return c;
}

/**********************/
/* ^̃I[o[[h */
/**********************/
Complex operator /(Complex a, Complex b)
{
	double x;
	Complex c;
	x   = 1.0 / (b.r * b.r + b.i * b.i);
	c.r = (a.r * b.r + a.i * b.i) * x;
	c.i = (a.i * b.r - a.r * b.i) * x;
	return c;
}

/************************/
/* ̃I[o[[h */
/************************/
ostream& operator << (ostream& stream, Complex a)
{
	stream << "(" << a.r << ", " << a.i << ")";
	return stream;
}

Complex G_s(double, int, int, double *, int, int, double *);
Complex value(Complex, int, int, double *);

/*******************/
/* main vO */
/*******************/
int main()
{
	double f, ff, fl, fu, h, *bo, *si, gain, phase = 0.0, x, uc;
	int i1, k, k1, ms, mb, m, n;
	char o_fg[100], o_fp[100];
	Complex g;
	FILE *og, *op;

	uc = 90.0 / asin(1.0);
/*
     f[^̓
*/
					// o̓t@C̓͂ƃt@C̃I[v
	scanf("%*s %s %*s %s", o_fg, o_fp);
	og = fopen(o_fg, "w");
	op = fopen(o_fp, "w");
					// `B֐f[^
	scanf("%*s %lf %lf %*s %d", &fl, &fu, &k);
						// q
	scanf("%*s %d %*s %d %*s", &ms, &m);
							// ĂȂ
	if (ms == 0) {
		k1 = m + 1;
		si = new double [k1];
		for (i1 = 0; i1 < k1; i1++)
			scanf("%lf", &si[i1]);
	}
							// Ă
	else {
		k1 = (m == 0) ? 1 : 2 * m;
		si = new double [k1];
		for (i1 = 0; i1 < k1; i1++)
			scanf("%lf", &si[i1]);
	}
						// 
	scanf("%*s %d %*s %d %*s", &mb, &n);

							// ĂȂ
	if (mb == 0) {
		k1 = n + 1;
		bo = new double [k1];
		for (i1 = 0; i1 < k1; i1++)
			scanf("%lf", &bo[i1]);
	}
							// Ă
	else {
		k1 = (n == 0) ? 1 : 2 * n;
		bo = new double [k1];
		for (i1 = 0; i1 < k1; i1++)
			scanf("%lf", &bo[i1]);
	}
/*
     QCƈʑ̌vZ
*/
	h  = (log10(fu) - log10(fl)) / k;
	ff = log10(fl);

	for (i1 = 0; i1 <= k; i1++) {
					// g̑ΐɖ߂
		f = pow(10.0, ff);
					// ľvZ
		g = G_s(f, ms, m, si, mb, n, bo);
					// QCƈʑ̌vZ
		gain = 20.0 * log10(abs(g));
		x    = angle(g) * uc;
		while (fabs(phase-x) > 180.0) {
			if (x-phase > 180.0)
				x -= 360.0;
			else {
				if (x-phase < -180.0)
					x += 360.0;
			}
		}
		phase = x;
					// o
		fprintf(og, "%f %f\n", f, gain);
		fprintf(op, "%f %f\n", f, phase);
					// ̎g
		ff += h;
	}

	return 0;
}

/********************************************************************/
/* `B֐̂ɂւľvZ                             */
/*      ff : ցigj                                           */
/*      ms : q̕\@                                         */
/*             =0 : isi[0]+si[1]*s+si[1]*s^2+j           */
/*             =1 : i(si[0]+si[1]*s)*(si[2]+si[3]*s)*j */
/*      m : q̎                                              */
/*      si : q̌W                                       */
/*      mb : ̕\@                                         */
/*             =0 : ibo[0]+bo[1]*s+bo[1]*s^2+j           */
/*             =1 : i(bo[0]+bo[1]*s)*(bo[2]+bo[3]*s)*j */
/*      n : ̎                                              */
/*      bo : ꑽ̌W                                       */
/*      return :                                                */
/********************************************************************/
Complex G_s(double ff, int ms, int m, double *si, int mb, int n, double *bo)
{
	Complex f, x, y;
					// g𕡑fɕϊ
	f = Complex (0.0, ff);
					// q
	x = value(f, ms, m, si);
					// 
	y = value(f, mb, n, bo);

	return x / y;
}

/****************************************************************/
/* ̂ɂւľvZ                           */
/*      f : ցigCfj                              */
/*      ms : ̕\@                                   */
/*             =0 : ia[0]+a[1]*s+a[1]*s^2+j          */
/*             =1 : i(a[0]+a[1]*s)*(a[2]+a[3]*s)*j */
/*      n : ̎                                        */
/*      a : ̌W                                        */
/*      return :                                            */
/****************************************************************/
Complex value(Complex f, int ms, int n, double *a)
{
	int i1, k1;
	Complex u0(0.0, 0.0), u1(1.0, 0.0), x;
					// ĂȂ
	if (ms == 0) {
		x = u0;
		for (i1 = 0; i1 <= n; i1++)
			x = x + a[i1] * pow(f, i1);
	}
					// Ă
	else {
		if (n == 0)
			x = a[0] * u1;
		else {
			x  = u1;
			k1 = 2 * n;
			for (i1 = 0; i1 < k1; i1 += 2)
				x = x * (a[i1] + a[i1+1] * f);
		}
	}

	return x;
}

/*
------------------------data1.txt----------------------------
QC gain.txt ʑ phase.txt
g̉Ə 0.01 100  100
q̕\@ 0  0 WiႢj 1.0
̕\@ 0  3 WiႢj 1.0 11.1 11.1 1.0

------------------------data2.txt----------------------------
QC gain.txt ʑ phase.txt
g̉Ə 0.01 100  100
q̕\@ 1  0 WiႢj 1.0
̕\@ 1  3 WiႢj 1.0 0.1 1.0 1.0 1.0 10.0
*/
