/****************************/
/* クイックソート           */
/*      coded by Y.Suganuma */
/****************************/
import java.io.*;
import java.util.*;

public class Test {
	public static void main(String args[])
	{
			// 初期設定
		int N     = 1000000;
		int NS    = 100000;
		Random rn = new Random();
			//
			// 二分探索（ array ）
			//
				// データ設定
		int data[]   = new int [N];
		int data_s[] = new int [NS];
		long tm1 = System.currentTimeMillis();
		int m    = 0;
		for (int i1 = 0; i1 < N; i1++) {
			int k = rn.nextInt();
			data[i1] = k;
			if (i1%10 == 0) {
				data_s[m] = k;
				m++;
			}
		}
				// sort
		long tm2 = System.currentTimeMillis();
		Arrays.sort(data);
				// 二分探索
		long tm3 = System.currentTimeMillis();
		int n = 0;
		for (int i1 = 0; i1 < NS; i1++) {
			int b = Arrays.binarySearch(data, data_s[i1]);
			if (b < 0)
				n++;
		}
		long tm4 = System.currentTimeMillis();
		System.out.printf("データ数(array)： %d，探索データ数 %d\n", N, NS);
		System.out.printf("   data %d ms\n", (tm2-tm1));
		System.out.printf("   sort %d ms\n", (tm3-tm2));
		System.out.printf("   二分探索 %d ms，失敗 %d\n", (tm4-tm3), n);
			//
			// 探索木（ TreeSet ）
			//
				// データ設定
		TreeSet <Integer> s = new TreeSet <Integer> ();
		tm1 = System.currentTimeMillis();
		m   = 0;
		for (int i1 = 0; i1 < N; i1++) {
			int k = rn.nextInt();
			boolean b = s.add(new Integer(k));
			if (b) {
				if (i1%10 == 0) {
					data_s[m] = k;
					m++;
				}
			}
			else
				i1--;
		}
				// 探索
		tm2 = System.currentTimeMillis();
		n   = 0;
		for (int i1 = 0; i1 < NS; i1++) {
			if (!s.contains(data_s[i1]))
				n++;
		}
		tm3 = System.currentTimeMillis();
		System.out.printf("データ数(TreeSet)： %d，探索データ数 %d\n", N, NS);
		System.out.printf("   data %d ms\n", (tm2-tm1));
		System.out.printf("   探索 %d ms，失敗 %d\n", (tm3-tm2), n);
			//
			// ハッシュ（ HashMap ）
			//
				// データ設定
		HashMap <Integer, Double> um = new HashMap <Integer, Double> ();
		tm1 = System.currentTimeMillis();
		m   = 0;
		for (int i1 = 0; i1 < N; i1++) {
			int k    = rn.nextInt();
			double v = rn.nextDouble();
			um.put(new Integer(k), new Double(v));
			if (i1%10 == 0) {
				data_s[m] = k;
				m++;
			}
		}
				// 探索
		tm2 = System.currentTimeMillis();
		n   = 0;
		for (int i1 = 0; i1 < NS; i1++) {
			if (!um.containsKey(data_s[i1]))
				n++;
		}
		tm3 = System.currentTimeMillis();
		System.out.printf("データ数(HashMap)： %d，探索データ数 %d\n", N, NS);
		System.out.printf("   data %d ms\n", (tm2-tm1));
		System.out.printf("   探索 %d ms，失敗 %d\n", (tm3-tm2), n);
			//
			// 文字列（ String ）
			//
		int N1  = 1000201;
		int NS1 = 5000;
		int NL  = 200;
		char data_st1[][] = new char [NS1][NL];
		char str1[]       = new char[N1];
				// データ設定
		tm1 = System.currentTimeMillis();
		n  = 0;
		for (int i1 = 0; i1 < N1; i1++) {
			str1[i1] = (char)(65 + 58 * rn.nextDouble());
			if (n < NS1 && i1 >= 2*NL && (i1 % NL) == 0) {
				int k = i1 - NL - NL / 2 - 1;
				for (int i2 = 0; i2 < NL; i2++) {
					data_st1[n][i2] = str1[k];
					k++;
				}
				if (n % 2 > 0)    // 存在しないデータの作成
					data_st1[n][NL/2] = '(';
				n++;
			}
		}
		String data_st[] = new String [NS1];
		for (int i1 = 0; i1 < NS1; i1++)
			data_st[i1] = new String(data_st1[i1]);
		String str = new String(str1);
				// 探索
		NS1 = n;
		tm2 = System.currentTimeMillis();
		int n1 = 0;
		int n2 = 0;
		for (int i1 = 0; i1 < NS1; i1++) {
			int p = str.indexOf(data_st[i1]);
			if (p >= 0)
				n1++;
			else
				n2++;
		}
		tm3 = System.currentTimeMillis();
		System.out.printf("文字数(String)： %d，探索データ（数 %d，文字数 %d）\n", N1, NS1, NL);
		System.out.printf("   data %d ms\n", (int)(tm2-tm1));
		System.out.printf("   探索 %d ms，成功 %d，失敗 %d\n", (int)(tm3-tm2), n1, n2);
	}
}

/*
データ数(array)： 1000000，探索データ数 100000
   data 19 ms
   sort 90 ms
   二分探索 24 ms，失敗 0
データ数(TreeSet)： 1000000，探索データ数 100000
   data 1297 ms
   探索 92 ms，失敗 0
データ数(HashMap)： 1000000，探索データ数 100000
   data 1027 ms
   探索 19 ms，失敗 0
文字数(String)： 1000201，探索データ（数 5000，文字数 200）
   data 51 ms
   探索 4476 ms，成功 2500，失敗 2500
*/
