#****************************/
#* ソートと探索             */
#*      coded by Y.Suganuma */
#****************************/
# -*- coding: UTF-8 -*-
import sys
import time
import bisect
from random import *

		# 初期設定
seed()
		#
		# 二分探索（ vector ）
		#
			# データ設定
N      = 1000000
NS     = 100000
data   = list()
data_s = list()
tm1    = time.perf_counter()
m      = 0;
for i1 in range(0, N) :
	k = randint(0, 2000000000)
	data.append(k)
	if i1%10 == 0 :
		data_s.append(k)
			# sort
tm2 = time.perf_counter()
data.sort();
			# 二分探索支援
tm3 = time.perf_counter()
for i1 in range(0, NS) :
	bisect.bisect(data, data_s[i1])
tm4 = time.perf_counter()
print("データ数(list)：", N, "探索データ数", NS)
print("   data", int((tm2 - tm1) * 1000), "ms")
print("   sort ", int((tm3 - tm2) * 1000), "ms")
print("   二分探索 ", int((tm4 - tm3) * 1000), "ms")
		#
		# ハッシュ（ unordered_map ）
		#
			# データ設定
um  = dict()
tm1 = time.perf_counter()
data_s.clear()
for i1 in range(0, N) :
	k = randint(0, 2000000000)
	v = random()
	um[k] = v
	if i1%10 == 0 :
		data_s.append(k)
			# 探索
tm2 = time.perf_counter()
n   = 0;
for i1 in range(0, NS) :
	if um.get(data_s[i1], -1) < 0 :
		n += 1
tm3 = time.perf_counter()
print("データ数(dict)： ", N, "，探索データ数 ", NS)
print("   data", int((tm2 - tm1) * 1000), "ms")
print("   探索 ", int((tm3 - tm2) * 1000), "ms", "失敗", n)
		#
		# 文字列（ string ）
		#
N1  = 1000201
NS1 = 5000
NL  = 200
			# データ設定
data_st = list()
st      = ""
n       = 0
tm1     = time.perf_counter()
for i1 in range(0, N1) :
	st += chr(int(65 + 58 * random()))
	if n < NS1 and i1 >= 2*NL and i1 % NL == 0 :
		k = int(i1 - NL - NL / 2 - 1)
		s = st[k : NL]
		if n % 2 > 0 :    # 存在しないデータの作成
			k   = int(NL / 2)
			k1  = k + 1
			s1  = s[0 : k]
			s1 += "("
			s   = s1 + s[k1 : NL]
		data_st.append(s)
		n += 1
			# 探索
tm2 = time.perf_counter()
n1  = 0
n2  = 0
for i1 in range(0, NS1) :
	if st.find(data_st[i1]) < 0 :
		n2 += 1
	else :
		n1 += 1
tm3 = time.perf_counter()
print("文字数(string)： ", N1, "，探索データ（数 ", NS1, "，文字数 ", NL, "）")
print("   data", int((tm2 - tm1) * 1000), "ms")
print("   探索", int((tm3 - tm2) * 1000), "ms，成功 ", n1, "，失敗 ", n2)

"""
データ数(list)： 1000000 探索データ数 100000
   data 2705 ms
   sort  722 ms
   二分探索  200 ms
データ数(dict)：  1000000 ，探索データ数  100000
   data 2938 ms
   探索  55 ms 失敗 0
文字数(string)：  1000201 ，探索データ（数  5000 ，文字数  200 ）
   data 1428 ms
   探索 620 ms，成功  2500 ，失敗  2500
"""
