/****************************/
/* wžvZ           */
/*      coded by Y.Suganuma */
/****************************/
#include <stdio.h>

double p;     // lvZƂ/100ݒ
double ram;     // ꐔ

/****************************************/
/* wžvZiP(X = x), P(X < x)j */
/*      x : f[^                      */
/*      ram : ꐔ                      */
/*      pr : P(X = x)                   */
/*      return : P(X < x)               */
/****************************************/
#include <math.h>

double exponential(double x, double ram, double *pr)
{
	double f = 0.0, y;

	if (x < 0)
		*pr = 0.0;
	else {
		y   = exp(-ram * x);
		*pr = ram * y;
		f   = 1.0 - y;
	}

	return f;
}

/******************************/
/* P(X > x) - 1 + pi֐lj */
/******************************/
double exponential_f(double x)
{
	return p - exp(-ram * x);
}

/**************************/
/* P(X = x)i֐̔j */
/**************************/
double exponential_df(double x)
{
	return ram * exp(-ram * x);
}

/*****************************************************/
/* Newton@ɂ`(f(x)=0)̉            */
/*      f : f(x)vZ֐                     */
/*      df : f(x)̔vZ֐              */
/*      x0 : l                                  */
/*      eps1 : IPibx(k+1)-x(k)beps1j   */
/*      eps2 : IQibf(x(k))beps2j       */
/*      max : ő厎s                           */
/*      ind : ۂ̎s                         */
/*            i͉̎𓾂邱ƂłȂj */
/*      return :                                   */
/*****************************************************/
#include <math.h>

double newton(double(*f)(double), double(*df)(double), double x0,
              double eps1, double eps2, int max, int *ind)
{
	double g, dg, x, x1;
	int sw;

	x1   = x0;
	x    = x1;
	*ind = 0;
	sw   = 0;

	while (sw == 0 && *ind >= 0) {

		sw    = 1;
		*ind += 1;
		g     = (*f)(x1);

		if (fabs(g) > eps2) {
			if (*ind <= max) {
				dg = (*df)(x1);
				if (fabs(dg) > eps2) {
					x = x1 - g / dg;
					if (fabs(x-x1) > eps1 && fabs(x-x1) > eps1*fabs(x)) {
						x1 = x;
						sw = 0;
					}
				}
				else
					*ind = -1;
			}
			else
				*ind = -1;
		}
	}

	return x;
}

/********/
/* main */
/********/
int main()
{
	double x, pr, f, up, h;
	int sw;
	char file1[100], file2[100];
	FILE *out1, *out2;

	printf("ꐔ́H ");
	scanf("%lf", &ram);
	printf("ړIƂ錋ʂ́H \n");
	printf("     =0 : m̌vZi P(X = x) y P(X < x) ̒lj\n");
	printf("     =1 : li P(X > u) = 0.01p ƂȂu̒lj ");
	scanf("%d", &sw);

	if (sw == 0) {

		printf("OtóHi=1: yes,  =0: noj ");
		scanf("%d", &sw);
					// x֐ƕz֐̒l
		if (sw == 0) {
			printf("   f[^́H ");
			scanf("%lf", &x);
			f = exponential(x, ram, &pr);
			printf("P(X = %f) = %f,  P( X < %f) = %f (ꐔ = %f)\n", x, pr, x, f, ram);
		}
					// Oto
		else {
			printf("   x֐̃t@ĆH ");
			scanf("%s", file1);
			printf("   z֐̃t@ĆH ");
			scanf("%s", file2);
			out1 = fopen(file1,"w");
			out2 = fopen(file2,"w");
			printf("   f[^̏́H ");
			scanf("%lf", &up);
			printf("   ݕ́H ");
			scanf("%lf", &h);
			for (x = 0; x < up+0.5*h; x += h) {
				f = exponential(x, ram, &pr);
				fprintf(out1, "%f %f\n", x, pr);
				fprintf(out2, "%f %f\n", x, f);
			}
		}
	}
					// l
	else {
		printf("̒ĺH ");
		scanf("%lf", &x);
		p = 0.01 * x;
		if (p < 1.0e-7)
			printf("%fl =  (ꐔ = %f)\n", x, ram);
		else {
			f = newton(exponential_f, exponential_df, 0.0, 1.0e-6, 1.0e-10, 100, &sw);
			printf("%fl = %f  sw %d (ꐔ = %f)\n", x, f, sw, ram);
		}
	}

	return 0;
}
