# -*- coding: UTF-8 -*-
import sys
from math import *
from random import *

###########################
# 乱数の発生
#      coded by Y.Suganuma
###########################

sed = int(input("乱数の初期値を入力してください "))
seed(sed)   # 乱数の初期設定
#seed()   # 初期値もランダムにしたい場合

#
#          [a b] 区間の一様乱数
#
mean = 0.0
sd   = 0.0
a    = 2.0
b    = 4.0
n    = 10000

for i1 in range(0, n) :
	r     = a + (b - a) * random()
	mean += r
	sd   += r * r

mean = mean / n
sd   = sqrt(abs(n /(n - 1.0) * (sd / n - mean * mean)))

print("一様分布")
print("   平均", mean, "標準偏差", sd)
#
#          平均 m の指数分布
#
mean = 0.0
sd   = 0.0
m    = 0.5

for i1 in range(0, n) :
	r     = expovariate(1/m) 
	mean += r
	sd   += r * r

mean = mean / n
sd   = sqrt(abs(n /(n - 1.0) * (sd / n - mean * mean)))

print("指数分布")
print("   平均", mean, "標準偏差", sd)
#
#          標準正規分布
#
mean = 0.0
sd   = 0.0

for i1 in range(0, n) :
	r     = gauss(0.0, 1.0)
	mean += r
	sd   += r * r

mean = mean / n
sd   = sqrt(abs(n /(n - 1.0) * (sd / n - mean * mean)))

print("標準正規分布")
print("   平均", mean, "標準偏差", sd)
