############################
# 乱数の発生
#      coded by Y.Suganuma
############################

##*****************************/
## [0, 1]区間の一様乱数の発生 */
##      rerutn : 乱数         */
##*****************************/
def unifm_d()
   return rand(0)
end

##****************************/
## 平均値 m の指数乱数の発生 */
##      m : 平均             */
##****************************/
def exp_d(m)
	return -m * Math.log(unifm_d())
end

##**********************************/
## 正規分布変量の発生              */
##      m : 平均                   */
##      s : 標準偏差               */
##           return : 正規分布変量 */
##**********************************/
def norm_d(m, s)
	x = 0.0

	for i1 in 1 .. 12
		x += unifm_d()
	end

	x = s * (x - 6.0) + m

	return x
end

print("乱数の初期値を入力してください ")
seed = Integer(gets())
srand(seed)   #  乱数の初期設定
#srand()   # 初期値もランダムにしたい場合

#
#          [a b] 区間の一様乱数
#
mean = 0.0
sd   = 0.0
a    = 2.0
b    = 4.0
n    = 10000

for i1 in 1 .. n
	r     = a + (b - a) * unifm_d()
	mean += r
	sd   += r * r
end

mean = mean / n
sd   = Math.sqrt((n /(n - 1.0).abs * (sd / n - mean * mean)))

print("一様分布\n")
print("   平均 " + String(mean) + " 標準偏差 " + String(sd) + "\n")
#
#          平均 m の指数分布
#
mean = 0.0
sd   = 0.0
m    = 0.5

for i1 in 1 .. n
	r     = exp_d(m)
	mean += r
	sd   += r * r
end

mean = mean / n
sd   = Math.sqrt((n /(n - 1.0).abs * (sd / n - mean * mean)))

print("指数分布\n")
print("   平均 " + String(mean) + " 標準偏差 " + String(sd) + "\n")
#
#          標準正規分布
#
mean = 0.0
sd   = 0.0

for i1 in 1 .. n
	r     = norm_d(0.0, 1.0)
	mean += r
	sd   += r * r
end

mean = mean / n
sd   = Math.sqrt((n /(n - 1.0).abs * (sd / n - mean * mean)))

print("標準正規分布\n")
print("   平均 " + String(mean) + " 標準偏差 " + String(sd) + "\n")
