/****************************/
/* t@WC_             */
/*      coded by Y.Suganuma */
/****************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*********************/
/* NXFuzzy̒` */
/*********************/
class Fuzzy {
		double ***left;   // [i][j][0] : S
                          //       [1] : 
		double **right;   // [i][0] : S
                          //    [1] : 
		double *omega;   // ւ̒l
		int bun;   // ϕ̕
		int method;   // _@
                      //    =0 : and,or
                      //    =1 : *,or
                      //    =2 : *,+
		int n_rule;   // K̐
		int n_val;   // ϐ̐
		int **rule;   // [i][j] =0 : Ԗڂ̋K͂Ԗڂ̕ϐgpȂ
                      //        =1 : Ԗڂ̋K͂Ԗڂ̕ϐgp
	public:
		Fuzzy(char *);   // RXgN^
		~Fuzzy();   // fXgN^
		double Cross(double, double, double, double);
		double Height(double, double *);
		double Inf(double *);   // _̎s
		double Result(double *);
};

/************************************/
/* RXgN^                   */
/*      name : ̓f[^t@C */
/************************************/
Fuzzy::Fuzzy(char *name)
{
	int i1, i2;
	FILE *in;

	in = fopen(name, "r");
/*
     {f[^̓
*/
	fscanf(in, "%*s %d %*s %d %*s %d %*s %d",
           &method, &n_rule, &n_val, &bun);
/*
     ̈̊m
*/
	left  = new double ** [n_rule];
	right = new double * [n_rule];
	omega = new double [n_rule];
	rule  = new int * [n_rule];

	for (i1 = 0; i1 < n_rule; i1++) {
		left[i1]  = new double * [n_val];
		right[i1] = new double [2];
		rule[i1]  = new int [n_val];
		for (i2 = 0; i2 < n_val; i2++)
			left[i1][i2]  = new double [2];
	}
/*
     Kf[^̓
*/
	for (i1 = 0; i1 < n_rule; i1++) {

		fscanf(in, "%*s");
						// 
		for (i2 = 0; i2 < n_val; i2++) {
			fscanf(in, "%*s %d", &(rule[i1][i2]));
			if (rule[i1][i2] > 0)
				fscanf(in, "%*s %lf %lf", &(left[i1][i2][0]), &(left[i1][i2][1]));
		}
						// E
		fscanf(in, "%*s %lf %lf", &(right[i1][0]), &(right[i1][1]));
	}

	fclose(in);
}

/****************/
/* fXgN^ */
/****************/
Fuzzy::~Fuzzy()
{
	int i1, i2;

	for (i1 = 0; i1 < n_rule; i1++) {
		for (i2 = 0; i2 < n_val; i2++)
			delete [] left[i1][i2];
		delete [] left[i1];
		delete [] right[i1];
		delete [] rule[i1];
	}

	delete [] left;
	delete [] right;
	delete [] rule;
}

/*******************************************/
/* _̌vZ                              */
/*      x : x                              */
/*      c : S                           */
/*      h :                              */
/*      r : <0 : ӂ̃o[Vbv֐  */
/*          >=0 : E()                 */
/*      return : _                      */
/*******************************************/
double Fuzzy::Cross(double x, double c, double h, double r)
{
	double x1, x2, y, y1, y2;

	if (x < c) {
		x1 = c - h;
		x2 = c;
		y1 = 0.0;
		y2 = (r < 0.0 || (r >= 0.0 && method == 0)) ? 1.0 : r;
	}
	else {
		x1 = c;
		x2 = c + h;
		y1 = (r < 0.0 || (r >= 0.0 && method == 0)) ? 1.0 : r;
		y2 = 0.0;
	}

	y = y1 + (y2 - y1) * (x - x1) / (x2 - x1);

	if (y < 0.0)
		y = 0.0;
	else {
		if (r >= 0.0 && method == 0 && y > r)
			y = r;
	}

	return y;
}

/**********************************************/
/* Eӂ̌vZ                                 */
/*      x : l                                */
/*      om[i] : <0 : Ԗڂ̋KgpȂ */
/*              >=0 : ւ̒l                  */
/*      return : ɂEӂ̒l           */
/**********************************************/
double Fuzzy::Height(double x, double *om)
{
	double y = 0.0, y1;
	int i1, sw;

	sw = 0;

	for (i1 = 0; i1 < n_rule; i1++) {

		if (om[i1] >= 0.0) {

			y1 = Cross(x, right[i1][0], right[i1][1], om[i1]);

			if (sw == 0) {
				y  = y1;
				sw = 1;
			}

			else {
				if (method < 2) {
					if (y1 > y)
						y = y1;
				}
				else
					y += y1;
			}
		}
	}

	return y;
}

/**************************/
/* _̎s             */
/*      x[i] : eϐ̒l */
/*      return : _l   */
/**************************/
double Fuzzy::Inf(double *x)
{

	double x1, y;
	int i1, i2;
/*
     ւ̌vZ
*/
	for (i1 = 0; i1 < n_rule; i1++) {

		omega[i1] = -1.0;

		for (i2 = 0; i2 < n_val; i2++) {

			if (rule[i1][i2] > 0) {

				if (x[i2] > left[i1][i2][0]-left[i1][i2][1] &&
                    x[i2] < left[i1][i2][0]+left[i1][i2][1])
					x1 = Cross(x[i2], left[i1][i2][0], left[i1][i2][1], -1.0);
				else
					x1 = 0.0;

				if (omega[i1] < 0.0)
					omega[i1] = x1;
				else {
					if (method == 0) {
						if (x1 < omega[i1])
							omega[i1] = x1;
					}
					else
						omega[i1] *= x1;
				}
			}
		}
	}
/*
     Eӂ̌vZ
*/
	y = Result(omega);

	return y;
}

/**********************************************/
/* Eӂɂ鐄_                             */
/*      om[i] : <0 : Ԗڂ̋KgpȂ */
/*              >=0 : ւ̒l                  */
/*      return : _l                       */
/**********************************************/
double Fuzzy::Result(double *om)
{
	double h, max = 0.0, min = 0.0, x1, x2, y = 0.0, y1, y2, z1, z2;
	int i1, sw;
/*
     ϕ͈͂Ɛϕ̌vZ
*/
	sw = 0;

	for (i1 = 0; i1 < n_rule; i1++) {
		if (om[i1] >= 0.0) {
			x1 = right[i1][0] - right[i1][1];
			x2 = right[i1][0] + right[i1][1];
			if (sw == 0) {
				min = x1;
				max = x2;
				sw  = 1;
			}
			else {
				if (x1 < min)
					min = x1;
				if (x2 > max)
					max = x2;
			}
		}
	}

	h = (max - min) / bun;

	if (h < 1.0e-15) {
		printf("***error  invalid data (h = 0) ***\n");
		exit(1);
	}
/*
     ϕ(dŠvZC`)
*/
	z1 = Height(min, om);
	z2 = Height(max, om);
	y1 = 0.5 * (min * z1 + max * z2);
	y2 = 0.5 * (z1 + z2);
	x1 = min;

	for (i1 = 0; i1 < bun-1; i1++) {
		x1 += h;
		z1  = Height(x1, om);
		y1 += x1 * z1;
		y2 += z1;
	}

	y1 *= h;
	y2 *= h;

	if (fabs(y2) > 1.0e-10)
		y = y1 / y2;
	else {
		printf("***error  invalid data (y2 = 0) ***\n");
		exit(1);
	}

	return y;
}

/****************/
/* main program */
/****************/
int main(int argc, char *argv[])
{
	double *x, **xx, y;
	int i1, i2, n_d, n_val;
	FILE *in, *out;

	if (argc == 4) {
					// IuWFNg̐
		Fuzzy fz(argv[1]);
					// _f[^̓ǂݍ
		in = fopen(argv[2], "r");
		fscanf(in, "%*s %d %*s %d", &n_val, &n_d);
		x  = new double [n_val];
		xx = new double * [n_val];
		for (i1 = 0; i1 < n_val; i1++) {
			fscanf(in, "%*s");
			xx[i1] = new double [n_d];
			for (i2 = 0; i2 < n_d; i2++)
				fscanf(in, "%lf", &xx[i1][i2]);
		}
		fclose(in);
					// _Ƃ̌ʂ̏o
		out = fopen(argv[3], "w");
		for (i1 = 0; i1 < n_d; i1++) {
			for (i2 = 0; i2 < n_val; i2++) {
				x[i2] = xx[i2][i1];
				fprintf(out, "%f ", x[i2]);
			}
			y = fz.Inf(x);   // _
			fprintf(out, "%f\n", y);
		}
		fclose(out);
	}

	else {
		printf("***error   ̓f[^t@Cw肵ĉ\n");
		exit(1);
	}

	return 0;
}

/*
------------------------Kt@C--------------
_@ 0 K̐ 3 ϐ̐ 1 ϕ̕ 100
KP
@ϐP 1 Sƕ 1.0 1.0
@EӁiSƕj 1.0 15.0
KQ
@ϐP 1 Sƕ 2.0 1.0
@EӁiSƕj 11.0 15.0
KR
@ϐP 1 Sƕ 3.0 1.0
@EӁiSƕj 21.0 15.0

------------------------_t@C--------------
ϐ̐ 1 f[^ 21
ϐP 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0 2.1 2.2 2.3 2.4 2.5 2.6 2.7 2.8 2.9 3.0
*/
